/************************************************************************
 
 Revision Control information

 $Source: /home/zephyr/zephyr-cvs/zephyr/backend/vpo/arm/ease/drive_p.c,v $
 $Date: 2003/11/09 14:19:51 $
 $Revision: 1.1 $
 $Name:  $

 Log of changes:

 $Log: drive_p.c,v $
 Revision 1.1  2003/11/09 14:19:51  jwd
 Initial version from SPARC--incomplete for arm

 Revision 1.2  1998/04/07 20:05:56  jwd
 First ANSI C version.


*************************************************************************/

#include <stdio.h>

#define DRIVE_P 1
#include "ease.h"
#include "drive_p.h"

/*
 * This file contains the functions needed to start and finish a program
 * instrumented to perform precision timing only.
 */

static int my_pid;

/*
 * ease_start_p - start measurements, precison timing only
 */
void __ease_start_p(void) {

   int getpid(void);
   void __ease_start_prec();

   __ease_start_prec();
   my_pid = getpid();
}

/*
 * ease_end_p - finish measurements, precision timing only
 */
void __ease_end_p(void) {

   int getpid(void);
   void __ease_stop_prec();

   if (my_pid != getpid())
      return;

   __ease_stop_prec();
}
