/************************************************************************
 
 Revision Control information

 $Source: /home/zephyr/zephyr-cvs/zephyr/backend/vpo/arm/regs.c,v $
 $Date: 2004/01/21 18:39:46 $
 $Revision: 1.82 $
 $Name:  $

 Log of changes:

 $Source: /home/zephyr/zephyr-cvs/zephyr/backend/vpo/arm/regs.c,v
 $Date: 2004/01/21 18:39:46 $
 $Revision: 1.82 $
 $Name:  $

 Log of changes:

 $Log: regs.c,v $
 Revision 1.82  2004/01/21 18:39:46  jdh8d
 Latest Vista additions/changes.  Don't yell at me if it's broken/bad.. prasad wanted these changes.  I've reviewed them, and tested,  minimally.. things appear OK (for the batch compiler)

 Revision 1.81  2003/11/10 18:08:54  jdh8d
 lots of ease fixes for arm.

 Revision 1.80  2003/04/16 18:30:56  jdh8d
 fixed call to remv_dead_variables

 Revision 1.79  2002/07/16 19:44:03  clc5q
 Clean up #include chains. Use #include instead of extern to get access
 to global variables from other modules.

 Revision 1.78  2002/06/21 21:18:11  jdh8d
 fixed minor bug when variable offset is exactly 0

 Revision 1.77  2002/05/16 19:39:40  jdh8d
 some changes from Mas

 Revision 1.76  2002/05/15 14:12:31  jwd
 Removed some duplicate code having to do with VET.

 $Log: regs.c,v $
 Revision 1.82  2004/01/21 18:39:46  jdh8d
 Latest Vista additions/changes.  Don't yell at me if it's broken/bad.. prasad wanted these changes.  I've reviewed them, and tested,  minimally.. things appear OK (for the batch compiler)

 Revision 1.81  2003/11/10 18:08:54  jdh8d
 lots of ease fixes for arm.

 Revision 1.80  2003/04/16 18:30:56  jdh8d
 fixed call to remv_dead_variables

 Revision 1.79  2002/07/16 19:44:03  clc5q
 Clean up #include chains. Use #include instead of extern to get access
 to global variables from other modules.

 Revision 1.78  2002/06/21 21:18:11  jdh8d
 fixed minor bug when variable offset is exactly 0

 Revision 1.77  2002/05/16 19:39:40  jdh8d
 some changes from Mas

 Revision 1.75  2002/04/02 21:18:33  rv3s
 code expander generated constants that are referenced and had their definition removed (due to removal of unreachable blocks in which they were defined) are removed from the constants table

 Revision 1.74  2002/03/22 01:11:21  jdh8d
 guarded calls to build dom tree with swg

 Revision 1.73  2002/03/19 03:52:33  jdh8d
 *** empty log message ***

 Revision 1.72  2002/03/18 17:13:12  jdh8d
 *** empty log message ***

 Revision 1.71  2002/03/06 19:34:07  jdh8d
 changes to support PID a near alias of PIC

 Revision 1.70  2002/02/13 15:31:25  jdh8d
 *** empty log message ***

 Revision 1.69  2002/02/12 17:14:27  rv3s
 *** empty log message ***

 Revision 1.68  2002/02/12 15:45:32  jdh8d
 *** empty log message ***

 Revision 1.67  2002/01/30 19:53:28  jdh8d
 *** empty log message ***

 Revision 1.66  2002/01/15 15:38:21  jdh8d
 *** empty log message ***

 Revision 1.65  2002/01/08 22:23:28  jdh8d
 *** empty log message ***

 Revision 1.64  2002/01/07 22:00:10  jdh8d
 *** empty log message ***

 Revision 1.63  2002/01/03 16:46:32  jdh8d
 *** empty log message ***

 Revision 1.62  2001/12/31 02:43:36  rv3s
 New routine remove_unpromoted_table_entries() added to remove compiler
 generated temporaries that held global table entries and were not promoted to
 registers. The temporaries are replaced with table address + offset. We assume
 that the table address is promoted to a register and the register is not
 re-defined in the function.

 Revision 1.61  2001/12/29 13:40:01  jdh8d
 Minimize registers and a ton of fixes

 Revision 1.60  2001/12/19 17:07:20  jdh8d
 *** empty log message ***

 Revision 1.59  2001/12/18 15:20:26  rv3s
 reset_local_links called in fixentry instead of set_local_links to clear the links before resetting them

 Revision 1.58  2001/12/04 16:32:44  jdh8d
 *** empty log message ***

 Revision 1.57  2001/12/03 20:14:04  jdh8d
 *** empty log message ***

 Revision 1.56  2001/11/27 21:02:58  jdh8d
 *** empty log message ***

 Revision 1.55  2001/11/13 19:05:17  jdh8d
 *** empty log message ***

 Revision 1.54  2001/11/13 17:04:49  jdh8d
  fixed memory leaks

 Revision 1.53  2001/11/06 19:10:41  rv3s
 fp_necessary now looks for both _alloca and alloca function calls (in sanyo mode)

 Revision 1.52  2001/11/03 17:18:13  jdh8d
 *** empty log message ***

 Revision 1.51  2001/10/29 13:55:26  jdh8d
 *** empty log message ***

 Revision 1.50  2001/10/18 17:46:30  jdh8d
 *** empty log message ***

 Revision 1.49  2001/10/04 18:31:29  jdh8d
 *** empty log message ***

 Revision 1.48  2001/10/03 17:51:20  jdh8d
 *** empty log message ***

 Revision 1.47  2001/10/03 13:12:13  jdh8d

 Changes to support only 2-letter tokens that don't
 interfere with memory reference.

 EG:

 	d[0]=ID[r[0]] looks like a memory reference.

 We've now disallowed two character tokens that end in
 a letter that's used as a memory reference.

 (exceptions: PC, ST, and RT are always allowed, even if
 C, or T memory types are defined)

 Revision 1.46  2001/09/30 17:37:11  jdh8d
 *** empty log message ***

 Revision 1.45  2001/09/24 20:35:35  jdh8d
 *** empty log message ***

 Revision 1.44  2001/09/15 01:57:05  jdh8d
 *** empty log message ***

 Revision 1.43  2001/09/10 17:55:38  jdh8d
 *** empty log message ***

 Revision 1.42  2001/09/05 18:44:16  jdh8d
 *** empty log message ***

 Revision 1.41  2001/08/29 16:44:31  jdh8d
 *** empty log message ***

 Revision 1.40  2001/08/23 02:28:56  jdh8d
 *** empty log message ***

 Revision 1.39  2001/08/23 01:42:09  jdh8d
 *** empty log message ***

 Revision 1.38  2001/08/21 00:11:03  jdh8d
 *** empty log message ***

 Revision 1.37  2001/08/07 19:33:35  jdh8d
 *** empty log message ***

 Revision 1.36  2001/08/06 18:17:34  jdh8d
 *** empty log message ***

 Revision 1.35  2001/07/24 18:33:14  jdh8d
 *** empty log message ***

 Revision 1.34  2001/07/20 15:48:49  jdh8d
 *** empty log message ***

 Revision 1.33  2001/07/19 20:21:02  jdh8d
 *** empty log message ***

 Revision 1.32  2001/07/18 17:33:34  jdh8d
 *** empty log message ***

 Revision 1.31  2001/07/16 17:42:27  jdh8d


 added code to support __irq functions.  All (used) scratch regs
 must be saved, and special return code is used.

 Revision 1.30  2001/06/30 15:01:48  jdh8d
 *** empty log message ***

 Revision 1.29  2001/06/19 14:24:23  jdh8d
 *** empty log message ***

 Revision 1.28  2001/06/08 15:05:38  jdh8d
 *** empty log message ***

 Revision 1.27  2001/06/05 18:55:35  jdh8d
 *** empty log message ***

 Revision 1.26  2001/06/04 11:06:01  jdh8d
 *** empty log message ***

 Revision 1.25  2001/05/31 00:01:18  rv3s
 Remove redundant move comments and piclabel for sanyo assembler

 Revision 1.24  2001/05/30 01:08:59  rv3s
 Comment format generated by fixentry changed to support sanyo assembler

 Revision 1.23  2001/05/24 21:05:02  rv3s
 Added support for sanyo assembler directives (passed onto the backend thro the "SANYOASM" debug option

 Revision 1.22  2001/05/21 18:42:56  jdh8d
 *** empty log message ***

 Revision 1.21  2001/05/17 23:09:00  jdh8d
 *** empty log message ***

 Revision 1.20  2001/05/16 18:53:32  jdh8d
 Changes to support "soft floating point"

 Revision 1.19  2001/05/15 20:16:44  jdh8d
 *** empty log message ***

 Revision 1.18  2001/05/15 20:13:30  jdh8d

 added support for -fpic

 Revision 1.17  2001/04/15 21:49:41  jdh8d
 *** empty log message ***

 Revision 1.16  2001/04/11 21:12:41  jdh8d
 strength reduction fixes, accepted multiply by constant
 if the constant is a power of 2..

 Revision 1.15  2001/04/04 19:40:17  jdh8d

 changes to support pre/post modification of an address register.

 in simp.c we added support to change:

 	r[X]=R[..];r[Y]=r[Y]; to simply remove the 2nd effect.

 This came from

 	r[X]=R[..];r[Y]=r[Y]+r[Z]; to simply remove the 2nd effect.

 but r[Z] was later recognized to be zero.  It works if the useless
 effect comes first as well.

 Revision 1.14  2001/03/24 22:41:27  jdh8d


 add new instructions:	r[x]=R[L1] and reverse subtract r[x]=constant-r[y]

 re-worked fixentry 2 or 3 times to make it lots more efficient.

 Revision 1.13  2001/03/14 21:09:22  jdh8d


 inst.c:  added support for  r[x]=r[x]*r[y] by printing it out as
 if it were r[x]=r[y]*r[x] which is a valid instruction.

 regs.c:  changed the multiply "fix" to only work if all 3 regs
 are the same.

 rtl.c: made mask an int so 0xffff would get printd right.

 Revision 1.12  2001/03/12 20:02:31  jdh8d
 *** empty log message ***

 Revision 1.11  2001/03/09 04:42:25  jdh8d
 *** empty log message ***

 Revision 1.10  2001/03/07 15:49:58  jdh8d

 bug fixes, alloca added.  multiply problem fixed in fixentry (ick)

 Revision 1.9  2001/02/27 22:35:10  jdh8d
 *** empty log message ***

 Revision 1.8  2001/02/20 14:30:17  jdh8d

 Added lots of support:  r-reg=label (adr instr) halfword loads/stores.
 Many fixentry bugs taken care of.

 Revision 1.7  2001/02/13 16:56:17  jdh8d
 Added ST=REG0 rtl.  Fixed ConstantTooBig to work for ARM,
 marked the LR as reserved.

 Revision 1.6  2001/02/12 21:54:22  jdh8d
 fixes for call, changed ST=GLO[1],0,0 to just ST=GLO[1]

 still need to add ST=rreg

 Revision 1.5  2001/02/09 13:32:34  jdh8d

 Modified regs.c to support saving/restore of registers, and
 proper allocation of parameter space on the stack.  Hopefully it'll
 be fine to go without register allocation now.  Need to do some
 work with gpalias and fpalias in order to map reg-args to their
 proper registers.

 Revision 1.4  2001/02/05 20:46:55  jdh8d
 added fixz.  most float/int instructions should work, branches, etc are OK
 too

 Revision 1.3  2001/02/04 23:36:48  jdh8d
 Most of the integer instructions now work, including cmp, and the branches.
 Non parameter variables are all working as far as I know, and the floating
 point instructions work.


 works:	ldr, str, add, sub, mul, adr, mov, shift left (mov r0, r1 asl r2),
 shift right (mov r0, r1 rsl r2), mufs, adfs, sufs, difs, mufd, adfd, sufd,
 difd, difd, stfs, stfd, ldfs, ldfd.

 Turned off optimization for debugging purposes.

 Revision 1.2  2001/02/03 13:02:58  jdh8d
 Lastest version of the back end.  I added the "cmp" and branch instructions.
 At this point, i compiled a small for loop with a print statement inside.
 Moving addresses to regsiters is tricky though.  I'm not sure how we'll
 be able to help.

 Revision 1.1  2001/02/01 22:55:19  jdh8d

 Initial arm version. Much stuff is still wrong.  Mostly this is a copy
 of the mips code but setup as an "arm" target.  Next I'll start converting
 functions so that they work with ARM instead of mips.  inst.c here I come.


*************************************************************************/

/*

Some notes about the ARM stack frame:

1)	It's more effecient, but not always possible to "move"
the incoming register arguments to the same area as the saved
integer registers.  This way, we can save them with the
same instruction as we save all the other registers.  See
can_move_reg_args() for details about when it's possible
to move register arguments.

2)	When reg args are moved, they are considered "integer
callee saved registers"  Space is reserved for them there.

3)  	This makes parameter offsets difficult to calculate.
Part of the parameters are with the saved regs, and part
of them are are on the caller's stack frame.

4)	We're attempting to omit the frame pointer for most
calls.  (Not possible when alloca is called).  Thus, there
are really two frame layouts.  When the frame pointer is needed,
(needs_fp is true) we have this stack layout:


--------------------------------- 	<---- fp
|	unmoved reg args 	|
--------------------------------- 	
|	integer saved regs 	|
--------------------------------- 	
|	float saved regs 	|
--------------------------------- 	
|	spill locations		|
--------------------------------- 	
|	local variables 	|
--------------------------------- 	
|	alloca area; 		|
--------------------------------- 	
|	arg build area  	|
--------------------------------- 	<---- sp


When we omit the frame pointer, we get:

--------------------------------- 	
|	unmoved reg args 	|
--------------------------------- 	
|	integer saved regs 	|
--------------------------------- 	
|	float saved regs 	|
--------------------------------- 	
|	local variables 	|
--------------------------------- 	
|	spill locations		|
--------------------------------- 	
|	arg build area  	|
--------------------------------- 	<---- sp





*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>
#include <setjmp.h>

#include "../lib/vpo.h"
#include "../lib/misc.h"
#include "../lib/assign.h"
#include "../lib/locals.h"
#include "../lib/vectors.h"

#include "recdef.h"
#include "addrdef.h"
#include "instdef.h"
#include "inst.h"
#include "predicates.h"
#include "rtl.h"
#include "regs.h"
#include "regs2.h"

#ifndef REGOFFSET
#define REGOFFSET -16
#endif

int ptr_type = RTREG;    /* Type of register needed for strength reduction */
int regmap[16];          /* Permits registers to be mapped on output       */
int spilloff;            /* Starting offset for spill locations            */
char cc_reg[REGSTRING];

static int alias[16];    /* Permits register renaming both ways            */

static int lr_used=FALSE;
static int mla_ok=FALSE;

#ifdef VET
#include "../lib/view.h"
#endif

char* makefp();
int is_irq_handler();
struct locuse *sort_locs_by_offset(struct locuse *head);
struct locuse *sort_locs_by_size(struct locuse *head);
void large_offset(char* code, int offset);
void put_offset_in_lr(int offset, struct list* nptr, int use_asmlines);
void add_epilogue(struct blist *ret_preds, int reg_param_space, int int_save_space,
		int totalsaved);
void fix_multiplies(void);
void fix_register_parameters(struct list* ptr);
void calc_param_offsets(struct list* ptr, int moved_offset, int unmoved_offset);
void calc_local_offsets(struct list* ptr, int local_start);
void save_registers(struct list* ptr);
void save_stack_space(struct list* ptr, int size);
void set_needs_spill_lr(int int_regs_saved);
int calculate_register_arguments_stack_size(void);
int calculate_non_scratch_int_reg_save_size(void);
int calculate_non_scratch_float_reg_save_size(void);
int calculate_temporary_spill_size(void);
int calculate_local_size(void);
int calculate_arg_build_size(void);
int can_move_reg_args();
void move_args_to_proper_regs(struct list* ptr);
struct list* can_tail_call(struct list* rtl);
int reg_num_of_param(struct locuse* param);
void fix_spills(void);
int find_spilled_reg_params();
int arg_build_size=0;
int hunt_sb();
int needs_sb;
int fp_necessary();
int fp_num=11;
int needs_fp;
int irq_handler;
void sanity_check_args();
int should_remove_table=FALSE;
void remove_table_if_unnecessary();
void fix_jump_table_refs();
void memorize_jump_table_defs();
int get_multiregs(void);


/* we need to spill the SP if we aren't moving reg args to
save an instruction.  If we're using the FP, we need to spill
it as well, just for simplicity */
#define needs_spill_sp (needs_fp||!can_move_reg_args())

/* for now, we'll just set this to true until we can figure
	out when we don't need it */
static int needs_spill_lr=TRUE;
static int must_spill[4];
static int spilled_reg;

#define roundup(a) (((a)+3) & ~3)

void remove_unpromoted_table_entries();

/*
 * fixentry - perform steps required to set up procedure entry
 */
void fixentry(struct list *ptr, struct blist *ret_preds) 
{
	char new[MAXSTRING];
	int register_arguments_stack_size,
		non_scratch_float_reg_save_size, non_scratch_int_reg_save_size,
		spill_size, local_size;
	int change;
        mla_ok=TRUE;
	set_next_prev_ptrs();
#ifdef VET
#ifdef INTERACT
	begin_phase(FIX_ENTRY_EXIT_TRANS);	
#else
	begin_phase(FIXENTRYEXIT_PHASE);
#endif
#endif

#ifdef INTERACT
	begin_trans(VET_REQUIRED_TRANS);
#endif

	/* we should only have one return point for a size optimization */
	if(ret_preds && ret_preds->next && debug_opt("size"))
		assert(0);

	sanity_check_args();

	irq_handler=is_irq_handler();
	needs_sb=hunt_sb();
	if(irq_handler)
	  add_rtl_with_type(ptr->daddy, ptr, "func is irq handler", rinit(), COMMENT);
	else
	  add_rtl_with_type(ptr->daddy, ptr, "func is not irq handler", rinit(), COMMENT);
		

	remove_unpromoted_table_entries();

	/* sort the local variables by offset so we analyze them in the
	 * right order 
	 */
	/* sort locals by size */
   	locs = (struct locuse *) sort_locs_by_size(locs); 
	/* sort arguments by offset */
   	locs = (struct locuse *) sort_locs_by_offset(locs); 


	/* NOTE!  This must happen after sorting! */
	spilled_reg=find_spilled_reg_params();


	register_arguments_stack_size=calculate_register_arguments_stack_size();
	register_arguments_stack_size=roundup(register_arguments_stack_size);

	non_scratch_float_reg_save_size=calculate_non_scratch_float_reg_save_size();
	non_scratch_float_reg_save_size=roundup(non_scratch_float_reg_save_size);

	non_scratch_int_reg_save_size=calculate_non_scratch_int_reg_save_size();
	non_scratch_int_reg_save_size=roundup(non_scratch_int_reg_save_size);

	spill_size=calculate_temporary_spill_size();
	spill_size=roundup(spill_size);

	local_size=calculate_local_size();
	local_size=roundup(local_size);

	arg_build_size=calculate_arg_build_size();
	arg_build_size=roundup(arg_build_size);


	if(needs_fp)
		spilloff=-(register_arguments_stack_size+non_scratch_float_reg_save_size+
		non_scratch_int_reg_save_size+spill_size);
	else
		spilloff=arg_build_size;
 
	/* this gets register parameters in the right spot. 
	 * if thats the stack, it stores them there.
	 * if it's in a different register than where it started,
	 * it puts it there 
	 * the "exception" is that if register arguments are "moved"
	 * they get saved in save_regs
	 */
	fix_register_parameters(ptr);

	/*
	 * saves any incoming registers, r, f, or d regs 
	 */
	save_registers(ptr);

	/*
	 * saves room on the stack on this target we use auto-inc
	 * when saving regs, so we only save room for spills, locals, and
	 * outgoing arguments 
	 */
	save_stack_space(ptr,spill_size+local_size+arg_build_size);

	/*
	 * calculates offsets for local variables, emits equates if
	 * necessary 
	 */
	if(needs_fp)
		calc_local_offsets(ptr, 
        		register_arguments_stack_size+non_scratch_float_reg_save_size+
			non_scratch_int_reg_save_size+spill_size+local_size);
	else
		calc_local_offsets(ptr, arg_build_size+spill_size);

	/*
	 * calculates offsets for parameters that are on the stack, 
	 * emits equates if necessary 
	 */
	if(needs_fp)
		calc_param_offsets(ptr, -(register_arguments_stack_size+non_scratch_int_reg_save_size),0);
	else
		calc_param_offsets(ptr, 
			non_scratch_float_reg_save_size+spill_size+local_size+arg_build_size,
			non_scratch_int_reg_save_size+
			non_scratch_float_reg_save_size+ spill_size+local_size+arg_build_size
		);



	/*
	 * if any parameters get assigned to registers, get them into the correct ones.
	 * we do this after calculating offsets, etc, because it may require spilling
	 * them to the stack.  Bummer.
	 */
	move_args_to_proper_regs(ptr);

	/* 
 	 * adds epilogue code to each return block 
 	 */
	add_epilogue(ret_preds,register_arguments_stack_size,non_scratch_int_reg_save_size,
		spill_size+local_size+arg_build_size);

	/* 
	 * fixes any multiply instructions that
	 * have the form r[x]=r[x]*r[x], hopefully
	 * this won't happen 
	 */
	fix_multiplies();
	fix_spills();
        add_rtl_with_type(ptr->daddy, ptr, "end of fixentry", rinit(), COMMENT);

#ifdef INTERACT
	end_trans();
	end_phase(FIX_ENTRY_EXIT_TRANS);
#endif

	reset_local_links();
        /*change=TRUE;*/
	change = FALSE;
	if(swg)
	{
#ifdef VET
		if (swtm)
			setjmp(my_env);
		if (moreopts)
#endif
			depth_first_search(0);
#ifdef VET
		if (swtm)
			setjmp(my_env);
		if (moreopts)
#endif
			build_dominator_tree(2);
#ifdef VET
		if (swtm)
			setjmp(my_env);
		if (moreopts)
#endif
			find_dominance_frontiers(2);
	}
        while(change && swg && !debug_opt("no_late_instruction_selection")) 
        {
                change=FALSE;
		set_local_links();
#ifdef VET
      if (moreopts)
#endif
               	live_variable_analysis(0,0,0);
#ifdef VET
      if (moreopts)
#endif
		remv_dead_variables(0,0,TRUE);
#ifdef VET
      if (moreopts)
#endif

#ifdef INTERACT	
	change|=instruction_selection(0, FALSE);
#else
      change|=instruction_selection(0);
#endif
      
                if(     !change &&
#ifdef VET
                        moreopts &&
#endif
                        swc)
		{

			change|=common_subexpression_elimination(c_s_e_count++);
			if(change)
				reset_local_links(0);
		}
        }

#ifdef VET
#ifdef INTERACT
	begin_phase(FIX_ENTRY_EXIT_TRANS);	
#else
	begin_phase(FIXENTRYEXIT_PHASE);
#endif
#endif

#ifdef INTERACT
	begin_trans(VET_REQUIRED_TRANS);
#endif

	if(needs_sb && debug_opt("PIC"))
	{
		if(debug_opt_i("SANYOASM"))
			sprintf(new, "\tldr r9, |.%s.tblptr|", fn);
		else	
			sprintf(new, "\tldr r9, .%s.tblptr", fn);
                add_rtl_with_type(ptr->daddy, ptr, new, rinit(), ASMLINE);
		sprintf(new, "\tldr r9, [r9]");
                add_rtl_with_type(ptr->daddy, ptr, new, rinit(), ASMLINE);
	}
	if (debug_opt_i("PIC")) 
        {
	  	if (debug_opt_i("SANYOASM"))
	    		sprintf(new, "|.L%s.piclabel| ",fn);
	  	else
	    		sprintf(new, ".L%s.piclabel: ",fn);
	  	add_rtl_with_type(ptr->daddy, ptr, new, rinit(), ASMLINE);
	}
	if(needs_sb && debug_opt("PIC"))
	{
		sprintf(new, "\tadd r9, r9, pc");
                add_rtl_with_type(ptr->daddy, ptr, new, rinit(), ASMLINE);
	}

#ifndef INTERACT
	/*during iterative compilation, sometimes the variable
	  should_remove_table is set to TRUE after call fixentry after some
	  optimization, but it may happen that the code is not executed since
	  that optimization did not change the control flow. In that case
	  early_frame_setup() is not called after that optimization, and so
	  this variable is not reset, which causes VPO to remove the table
	  for some later optimization when it is required causing link
	  errors. So disabling this for the moment*/
        remove_table_if_unnecessary();
#endif

	/* if the function has a name, we need to memorize jump table entries here */
	memorize_jump_table_defs();
#ifdef INTERACT
	end_trans();
#endif

#ifdef VET
#ifdef INTERACT
	end_phase(FIX_ENTRY_EXIT_TRANS);
#else
	end_phase(FIXENTRYEXIT_PHASE);
#endif
#endif
}



/* determine if it's safe to map reg_b to reg_a */
int can_map(int reg_a, int reg_b)
{
	char reg[REGSTRING];
	char reg2[REGSTRING];
	struct locuse* ptr;
        struct bblock* cblk;
        struct list* nptr;

	makereg(reg, RTREG, reg_a);
	makereg(reg2, RTREG, reg_b);

	if(debug_opt("never_map"))
		return FALSE;


	/* if reg_a has a useline, we can't map */
	if(isused[regtoindex(RTREG, reg_a)] )
		return FALSE;
	/* if reg_b has a useline, we can't map */
	if(isused[regtoindex(RTREG, reg_b)] )
		return FALSE;

	/* it's not safe to map a non-scratch to a scratch.
	   a function call (without a use-line for the var)
	   may destroy the scratch reg */
	if(!leaf() && scratchreg(reg)!=scratchreg(reg2))
		return FALSE;

	if(varargs)
		return FALSE;


	/* we have to make sure there are no reserve lines for
		the register in question, walk the function to find out */
        for (cblk = top; cblk; cblk = cblk->down)
        {
                for (nptr = cblk->rtls; nptr; nptr = nptr->next)
                {
                        if (nptr->type&RESLINE)
                        {
				if(cmploc(nptr->val, reg)==0)
					return FALSE;
				if(cmploc(nptr->val, reg2)==0)
					return FALSE;
                        }
#ifdef SOFTFLOAT
                        /* watch for alias references */
                        if(cnts(nptr))
                        {
                                if(!fmatch(nptr->val,reg) && (isaliasref(nptr->val,reg) || isaliasset(nptr->val,reg)))
                                                return FALSE;
                                if(!fmatch(nptr->val,reg2) && (isaliasref(nptr->val,reg2) || isaliasset(nptr->val,reg2)))
                                                return FALSE;
                        }


#endif
                }
        }


	return TRUE;



}

void move_args_to_proper_regs( struct list* ptr)
{
    int conflict[16];          /* Prevents write/read problems with arguments    */
    int index,index2;
    int base, item;

    char reg[MAXSTRING], reg2[MAXSTRING], new[MAXSTRING];

    struct locuse* lptr;

    index=0;
    for (lptr = locs; lptr; lptr = lptr->next) 
    {
	if(!lptr->arg)
		continue;
	if(lptr->regin && *lptr->regin)
	{
	  sprintf(new, "arg r%d in reg r%d", index, regnum(lptr->regin));
	  add_rtl_with_type(ptr->daddy, ptr, new, rinit(), COMMENT);
	}
	index++;
	
    }


    /*
     * First we set up a conflict array which is going to allow us to determine
     * if we have to be careful about how we order our argument moves to
     * avoid clobbering an argument.
     */
    for (index = 0; index < 16; index++)
	conflict[index] = 0;

    /* mark each register that conflicts */
    for (lptr = locs; lptr; lptr = lptr->next) 
    {
	/* is this local allocated to a register */
      if (*lptr->regin && lptr->type == RTREG) 
      {
	  /* if the offset is 0, generate r0, offset=4, r1, etc */
          index = reg_num_of_param(lptr);
          makereg(reg, RTREG, index);
          index2= regmap[regnum(lptr->regin)];
          makereg(reg2, RTREG, index2);


	  /* is the local in a different register than 
	     where the register allocator put it */
          if (strcmp(reg, reg2))
          {
	    /* if it's feasable to map the registers, we go ahead and do it */
	    if(can_map(index, regnum(reg2)))
            {
		char new2[100];
		sprintf(new2, "mapping r%d to r%d", regnum(reg2), index);
		add_rtl_with_type(ptr->daddy, ptr, new2, rinit(), COMMENT);
               	item = alias[index];
                regmap[item] = regmap[regnum(lptr->regin)];
                regmap[regnum(lptr->regin)]= index;
                alias[index] = alias[regmap[item]];
                alias[regmap[item]] = item;
            }
          }
      }
    }

    for (lptr = locs; lptr; lptr = lptr->next) 
    {
	/* is this local allocated to a register */
      if (*lptr->regin && lptr->type == RTREG) 
      {
	  /* if the offset is 0, generate r0, offset=4, r1, etc */
          index = reg_num_of_param(lptr);
          makereg(reg, RTREG, index);
          index2= regmap[regnum(lptr->regin)];
          makereg(reg2, RTREG, index2);

	  /* is the local in a different register than 
	     where the register allocator put it */
          if (strcmp(reg, reg2))
          {
	    if(!can_map(index, regnum(reg2)))
            {
	      /* mark that index needs to be moved to somewhere, but can't yet */
              conflict[index] |= 1;
	      /* mark that regin needs to get a value, but can't yet */
              conflict[regnum(reg2)] |= 2;
            }
          }
      }
    }


    /*
     * Now go back and look at the items that came in on register, were
     * allocated to registers, but could not be mapped, and thus must be
     * moved to the appropriate register.  If there are any conflicts, we
     * note the fact so that we can order moves appropriately.
     */
    base = FALSE;
    for (lptr = locs; lptr; lptr = lptr->next) 
    {

	/* if the argument is held in a intger register */
      if (*lptr->regin && lptr->type == RTREG)  
      {
	  /* if the offset is 0, generate r0, offset=4, r1, etc */
          index = reg_num_of_param(lptr);
          makereg(reg, RTREG, index);
          index2= regmap[regnum(lptr->regin)];
          makereg(reg2, RTREG, index2);

	  /* but not the right one */
          if (strcmp(reg, reg2))
          {
	    if(!can_map(index, regnum(reg2)))
            {
              if (!(conflict[regnum(reg2)] & 1)) 
              {
		int my_reg1, my_reg2;
                conflict[index] &= ~1;

/* if we emit this as an RTL, we want the alias (so the map can un-alias it
properly).  eince we're doing it as an asmline, we want the real number 
          	index = alias[reg_num_of_param(lptr)];
*/
                makereg(reg, RTREG, index);
		my_reg1=regmap[regnum(lptr->regin)];
		my_reg2=regnum(reg);


                sprintf(new, "\tmov r%d, r%d", 	my_reg1, my_reg2);
#ifdef RTL_MOVES_AS_ASMLINES
		/* if we should add this as an RTL, we do */
                add_rtl_with_type(ptr->daddy, ptr, new, rinit(), ASMLINE);
#else
		{
			char test1[REGSTRING];
			char test2[REGSTRING];

			/* otherwise we'll add it as a comment so we can catch mistakes easily */
                	add_rtl_with_type(ptr->daddy, ptr, new, rinit(), COMMENT);

			makereg(test1,RTREG,alias[my_reg1]);
			makereg(test2,RTREG,alias[my_reg2]);
			*skiploc(test1)=0;
			*skiploc(test2)=0;
                	sprintf(new, "%s=%s;", 	test1,test2);
                	add_rtl_with_type(ptr->daddy, ptr, new, rinit(), RTLINE);
		}

#endif

                conflict[regnum(reg2)] &= ~2;
                *lptr->regin = '\0';
              }
              else
                base = TRUE;
            }
          }
      }
    }


    /*
     * Now go back and pick up those items that could not be moved because of
     * conflicts.
     */
    while (base) 
    {
      base = item = FALSE;
      for (lptr = locs; lptr; lptr = lptr->next) 
      {
        if (*lptr->regin && lptr->type == RTREG) 
        {
            index = reg_num_of_param(lptr);
            makereg(reg, RTREG, index);
            index2= regmap[regnum(lptr->regin)];
            makereg(reg2, RTREG, index2);

            if (strcmp(reg, reg2)) {
	      if(!can_map(index, regnum(reg2)))
              {
                if (!(conflict[regnum(reg2)] & 1)) 
                {
		  int my_reg1, my_reg2;
                  item = TRUE;
                  conflict[index] &= ~1;
                  sprintf(new, "\tmov r%d, r%d", my_reg1=regnum(reg2), my_reg2=regnum(reg));
#ifdef RTL_MOVES_AS_ASMLINES
                /* if we should add this as an RTL, we do */
                add_rtl_with_type(ptr->daddy, ptr, new, rinit(), ASMLINE);
#else
                {
                        char test1[REGSTRING];
                        char test2[REGSTRING];

                        /* otherwise we'll add it as a comment so we can catch mistakes easily */
                        add_rtl_with_type(ptr->daddy, ptr, new, rinit(), COMMENT);

                        makereg(test1,RTREG,alias[my_reg1]);
                        makereg(test2,RTREG,alias[my_reg2]);
                        *skiploc(test1)=0;
                        *skiploc(test2)=0;
                        sprintf(new, "%s=%s;",  test1,test2);
                        add_rtl_with_type(ptr->daddy, ptr, new, rinit(), RTLINE);
                }

#endif

                  conflict[regnum(reg2)] &= ~2;
                  *lptr->regin = '\0';
                }
                else
                  base = TRUE;
              }
          }
        }
      }

      /*
       * If the following test it true, then we have some sort of a circular
       * conflict between the registers having argument values coming in and
       * registers that must receive the values.  We resolve the conflict by
       * taking some fairly drastic actions (going through memory).
       * we could use the link reg to break the conflict.. but, for now...
       */
      if (base && !item) 
      {
        for (lptr = locs; lptr; lptr = lptr->next) 
        {
          if (*lptr->regin) 
          {
            if (lptr->type == RTREG) 
            {
              index = reg_num_of_param(lptr);
              makereg(reg, RTREG, index);
              index2= regmap[regnum(lptr->regin)];
              makereg(reg2, RTREG, index2);
              if (strcmp(reg, reg2))
              {
	        if(!can_map(index, regnum(reg2)))
                {
		  if(needs_fp)
                  	sprintf(new, "\tldr r%d, [fp,#%d]", regnum(reg2), lptr->offset);
		  else
                  	sprintf(new, "\tldr r%d, [sp,#%d]", regnum(reg2), lptr->offset);
                  add_rtl_with_type(ptr->daddy, ptr, new, rinit(), ASMLINE);
                }
              }
            }
          }
        }
        base = FALSE;
      }
    }
}


int calculate_register_arguments_stack_size(void)
{
        /*
         * If the function is not a leaf, then we need to make room for at
         * least four registers at the bottom of our activation record, since
         * that is the minimum amount of space that must be allowed when
         * calling a varargs-type function (which immediately writes the four
         * integer argument-passing registers to the stack).  Then, we look at
         * each call RTL in the function to determine the amount of space that
         * must be reserved to pass any arguments that cannot be placed on the
         * calling registers
         */

	int  i, sum=0;

	/* don't save space here for them */
	if(can_move_reg_args())
		return 0;
	return spilled_reg*4;
}

int calculate_non_scratch_float_reg_save_size()
{
#ifdef HARDFLOAT 
	int reg_save_size=0;
    	regarray tr = (regarray) top->regstate;
	int item, index;
	char reg[MAXSTRING];

	int lowreg=100;
        int highreg=-1;

        item = availreg(DTREG);
        for (index = firstreg(DTREG); item--; index += skipreg(DTREG))
        {
                if (tr->reg[index].status != NOTUSED)
                {
                        makereg(reg, DTREG, indextoreg(DTREG, index));
                        if (!scratchreg(reg))
                        {
                                if(indextoreg(DTREG,index)<lowreg)
                                        lowreg=indextoreg(DTREG,index);
                                if(indextoreg(DTREG,index)>highreg)
                                        highreg=indextoreg(DTREG,index);
                        }
                }
        }
        if(highreg!=-1)
        {
        	return (highreg-lowreg+1)*12;
        }
#endif
	/* soft float saves no regs */
	return 0;
}

int calculate_non_scratch_int_reg_save_size()
{
	int reg_save_size=0;
    	regarray tr = (regarray) top->regstate;
	int item, index;
	char reg[MAXSTRING];

    	item = availreg(RTREG);
    	for (index = firstreg(RTREG); item--; index += skipreg(RTREG)) 
	{
      		if (tr->reg[index].status != NOTUSED) 
		{
        		makereg(reg, RTREG, indextoreg(RTREG, index));
        		if (!scratchreg(reg))
          			reg_save_size += 4;
        	}
      	}
	set_needs_spill_lr(reg_save_size);
	/* always store fp, sp, and lr */
	if(needs_fp)
		reg_save_size+=12;
	/* if we're using the FP, but we still need the SP spilled, spill sp+lr */
	else if(needs_spill_sp)
		reg_save_size+=8;
	/* otherwise, if the LR is busy, just spill that */
	else if(needs_spill_lr)
		reg_save_size+=4;
	/* and 4 more if we need to save the SB */
	/* only in PIC mode */
        if(needs_sb && debug_opt("PIC"))
		reg_save_size+=4;
	if(can_move_reg_args())
		reg_save_size+=(spilled_reg*4);

	/* we need to save r[12], or ip if this is an irq_handler */
	/* r0-r3 are saved necessary "arguments" */
	if(irq_handler)
		reg_save_size+=4;

	sprintf(reg, "calculate_non_scratch_int_reg_save_size = %d", reg_save_size);
	add_rtl_with_type(top, top->rtls, reg, rinit(), COMMENT);

	return reg_save_size;
}

void set_needs_spill_lr(int int_regs_saved)
{
	struct locuse* lptr;
        struct bblock* cblk;
        struct list* nptr;
	needs_spill_lr=FALSE;	

#ifdef MEASURE
	/* always save/restore the LR for frequency measurement */
	if(swef)
	{
		needs_spill_lr=TRUE;	
		return ;
	}
#endif

	/* if any locals have references, we may need the LR for
		"fixing" them.  see large-offset */
	for(lptr=locs; lptr; lptr=lptr->next)
		if(lptr->reps)	
			needs_spill_lr=TRUE;

	/* if we're spilling the FP, or SP, or this isn't a leaf
		func, then we need to spill the LR */
	if(needs_fp || needs_spill_sp)
		needs_spill_lr=TRUE;

	if(!leaf())
	{
          for (cblk = top; cblk && !needs_spill_lr; cblk = cblk->down)
	  {
                for (nptr = cblk->rtls; nptr && !needs_spill_lr; nptr = nptr->next)
		{
			if(cnts(nptr) && fmatch(nptr->val,"ST="))
			{
				if(cnts(cblk->rtlend) && 
					fmatch(cblk->rtlend->val, "PC=RT;"))
				{
					if(can_tail_call(cblk->rtlend)!=nptr)
						needs_spill_lr=TRUE;
				}
				else
					needs_spill_lr=TRUE;
					
			}
		}
	  }
	}

	/* if we're spilling other regs, it's fewer
		instructions to spill the LR and restore
		it than it is to actually just jump to it
		in the end, so we don't save it */
	if(int_regs_saved!=0)
		needs_spill_lr=TRUE;
	if(!can_move_reg_args() || spilled_reg>0)
		needs_spill_lr=TRUE;
	if(needs_sb && debug_opt("PIC"))
		needs_spill_lr=TRUE;
	if(calculate_temporary_spill_size()!=0)
		needs_spill_lr=TRUE;

#ifdef SOFTFLOAT
	{
	  char reg[REGSTRING+10];
	  char* a;
	  makereg(reg, RTREG, 14);
  
          for (cblk = top; cblk && !needs_spill_lr; cblk = cblk->down)
	  {
                for (nptr = cblk->rtls; nptr && !needs_spill_lr; nptr = nptr->next)
                {
                        if(nptr->se==0 || (nptr->type&RTLINE)!=RTLINE)
				continue;
			a=nptr->se;
			while(a=gtrg(a))
				if(cmploc(unskiploc(a), reg)==0 && *a=='=')
					needs_spill_lr=TRUE;
			
			
		}
	  }
	}

#endif
		
	
	if(!needs_spill_lr)
	  add_rtl_with_type(top, top->rtls, "we wont' need the LR saved", rinit(), COMMENT);
	else
	  add_rtl_with_type(top, top->rtls, "we will need the LR saved", rinit(), COMMENT);
}
			


int calculate_temporary_spill_size()
{

	int  reg_spill_size=0;
	int index;
	char reg[MAXSTRING];
        /*
         * Calculate the amount of space needed for temporary spill areas.  Set
       	 * the spilloff global variable so that the machine description will
       	 * be able to calculate the correct value of the SP[] macros.
       	 */
      	index = MAXTEMP;
      	while (--index >= 0)
      	{
        	if (usedtemps[index])
          		break;
      	}
      	if (index >= 0) 
      	{
        	reg_spill_size=reg_spill_size += (index + 1) << 3;
      	}

	
	sprintf(reg, " spill size = %d", reg_spill_size);
	add_rtl_with_type(top, top->rtls, reg, rinit(), COMMENT);
	return reg_spill_size;
}
	

int calculate_local_size()
{
      	/*
       	 * Allocate space for each variable that needs space on the activation
       	 * record.  
       	 */
	int local_size=0;
	struct locuse* lptr;
	char reg[MAXSTRING];
      	for (lptr = locs; lptr; lptr = lptr->next)
      	{
          	if(!lptr->arg && lptr->reps)
          	{
                	/* 1 byte things don't need alignment */
                	if(lptr->size == 1)
                        	/* do nothing */ ;

                	/* two or 3 bytes need short alignment */
                	else if(lptr->size == 2 || lptr->size == 3)
                        	local_size = ((local_size + 1) & ~1);

                	/* otherwise we can word align */
			/* doubles dont' need double alignment, yay */
                	else
                        	local_size = ((local_size + 3) & ~3);

			local_size+=lptr->size;
          	}
      	}
	/* we may waste space here, but only a few bytes */
        local_size = ((local_size + 3) & ~3);

	sprintf(reg, "local size = %d", local_size);
	add_rtl_with_type(top, top->rtls, reg, rinit(), COMMENT);
	return local_size;

}

int calculate_arg_build_size()
{

	/* walk the function looking for calls. 
	 * when we find a call, figure out how much space is needed 
	 * for the argument build area.  Memorize the maximum arg 
	 * build area for this function 
	 */
	int my_arg_build_size=0;
	struct bblock* cblk;
	struct list* nptr;
	int index;
	char reg[MAXSTRING];
      	for (cblk = top; cblk; cblk = cblk->down) 
	{
        	for (nptr = cblk->rtls; nptr; nptr = nptr->next) 
		{
			/* we found a call, get the arg build size */
          		if (nptr->type==ARGBLINE)
			{
            			char* a = nptr->val;
            			if ((index = atoi(a))>my_arg_build_size)
              				my_arg_build_size = index;
            		}
          	}
        }
	my_arg_build_size=(my_arg_build_size+3) & ~3;
        /* the start of the arg build area is the stack pointer. */ 

	sprintf(reg, "my_arg_build_size=%d", my_arg_build_size);
	add_rtl_with_type(top, top->rtls, reg, rinit(), COMMENT);
	return my_arg_build_size;	

}

void	fix_register_parameters(struct list* ptr)
{
        /*
         * save the sp into the IP for a moment because the SP is gonna
         * go wild in just a moment
         */
	char new[MAXSTRING];
	char reg[10];
	int i, total;
	int	spill_max = 4;

        (void) sprintf(new, "\tmov\tip, sp");
	if(needs_fp || !can_move_reg_args())
	{
		if(!irq_handler)
        		add_rtl_with_type(ptr->daddy, ptr, new, rinit(), ASMLINE);
	}


	/* if we're moving the register args, don't save them here */
	if(can_move_reg_args())
		return;

        /* now, reserve the 16 bytes for the register arguments */
        /* for var args, we need to store r0-r3 on the stack
         * next to the SP so that we can traverse them
         */

	total = spilled_reg;
	if(total)
	{
		int first=TRUE;
		
		if (get_multiregs() == 3 && must_spill[3] && total==4)
		{
       			sprintf(new, "\tstmfd\tsp!, {r3}");
       			add_rtl_with_type(ptr->daddy, ptr, new, rinit(), ASMLINE);
				spill_max--;
		}		

		(void) sprintf(new, "\tstmfd\tsp!, {");
		for(i=0;i<spill_max;i++)
		{
			if(must_spill[i])
			{
				if(!first)
					strcat(new, ",");
				first=FALSE;
				sprintf(reg, "r%d",i);
				strcat(new, reg);
			}
		}
       		(void) strcat(new, "}");
       		add_rtl_with_type(ptr->daddy, ptr, new, rinit(), ASMLINE);
	}

	/* OK, now we push the IP and set it to what the stack pointer
	 * was when the function was entered.  Since we've pushed r0-r3,
	 * and r12, that's 20 bytes.  If irq_handler is true, we require
	 * r0-r3 be pushed, regardless of whether they "need" to be. 
	 */
	if(irq_handler)
	{
       		(void) sprintf(new, "\tstmfd\tsp!, {ip}");
       		add_rtl_with_type(ptr->daddy, ptr, new, rinit(), ASMLINE);
        	(void) sprintf(new, "\tsub\tip, sp, #-20");
       		add_rtl_with_type(ptr->daddy, ptr, new, rinit(), ASMLINE);
	}
}

void save_registers(struct list* ptr)
{
	char new[MAXSTRING], reg[MAXSTRING];
	int item, index, lowreg, highreg;
	int i;
   	regarray tr = (regarray) top->regstate;
	int really_spilled=FALSE;
	int spill_list[MAXREGS], spillcnt = 0, remreg, stmcnt;
    	int multiregs = get_multiregs();

	/* if we're moving the register args, save them here */
	if(can_move_reg_args())
	{
		for(i=0;i<4;i++)
		{
			if(must_spill[i])
			{
				really_spilled=TRUE;
				spill_list[spillcnt++] = i;
			}
		}
	}
   	item = availreg(RTREG);
   	for (index = firstreg(RTREG); item--; index+= skipreg(RTREG)) 
	{
   		if (tr->reg[index].status != NOTUSED) 
		{
   		  	makereg(reg, RTREG, indextoreg(RTREG, index));
       		if (!scratchreg(reg) && indextoreg(RTREG,index)<=9)
			{				
				spill_list[spillcnt++] = alias[indextoreg(RTREG, index)];
				really_spilled=TRUE;
			}
   		}
   	}
	if(needs_sb && debug_opt("PIC"))
	{
		spill_list[spillcnt++] = 9;			/* for r9 */
		really_spilled=TRUE;
	}

   	item = availreg(RTREG);
   	for (index = firstreg(RTREG); item--; index+= skipreg(RTREG)) 
	{
   		if (tr->reg[index].status != NOTUSED) 
		{
   		  	makereg(reg, RTREG, indextoreg(RTREG, index));
       		if (!scratchreg(reg) && indextoreg(RTREG,index)>9)
			{				
				spill_list[spillcnt++] = alias[indextoreg(RTREG, index)];
				really_spilled=TRUE;
			}

		}
   	}

	/* if we're using the FP, all bets are off, spill everything */
	if(needs_fp)
	{
		really_spilled=TRUE;
		spill_list[spillcnt++] = 11;			/* for fp */
		spill_list[spillcnt++] = 12;			/* for ip */
		spill_list[spillcnt++] = 14;			/* for lr */
	}
	else if(needs_spill_sp)
	{
		really_spilled=TRUE;
		if(can_move_reg_args())
			spill_list[spillcnt++] = 13;		/* for sp */
		else
			spill_list[spillcnt++] = 12;		/* for ip */
		spill_list[spillcnt++] = 14;			/* for lr */
	}
	else if(needs_spill_lr || really_spilled)
	{
		really_spilled=TRUE;
		spill_list[spillcnt++] = 14;			/* for lr */
	}

	/* if really spilled, output STMFD instructions to save regs */
	if (really_spilled)
	{
		for (spillcnt--, stmcnt=spillcnt/multiregs; stmcnt>=0; --stmcnt)
		{
			remreg = (spillcnt%multiregs);

			(void) sprintf(new, "\tstmfd\tsp!, {");
			for (index=spillcnt-remreg; remreg>=0; --remreg)
			{
				(void) strcat(new, r_regs[spill_list[index++]]);
				if (remreg)
					(void) strcat(new, ", ");
				spillcnt--;
			}
			(void) strcat(new, "}");
   			add_rtl_with_type(ptr->daddy, ptr, new, rinit(), ASMLINE);
		}
	}


/* only save float regs in float version */
#ifdef HARDFLOAT 
	lowreg=100;
	highreg=-1;

   	item = availreg(DTREG);
   	for (index = firstreg(DTREG); item--; index += skipreg(DTREG)) 
	{
      		if (tr->reg[index].status != NOTUSED) 
		{
         		makereg(reg, DTREG, indextoreg(DTREG, index));
         		if (!scratchreg(reg)) 
			{
				if(indextoreg(DTREG,index)<lowreg)
					lowreg=indextoreg(DTREG,index);
				if(indextoreg(DTREG,index)>highreg)
					highreg=indextoreg(DTREG,index);
         		}
      		}
	}
	if(highreg!=-1)
	{
		sprintf(new, "\tsfmfd\tf%d,%d,[sp]!", lowreg, highreg-lowreg+1);
       		add_rtl_with_type(top, ptr, new, rinit(), ASMLINE);
	}
#endif
}

void save_stack_space(struct list* ptr, int size)
{
	char reg2[MAXSTRING], reg[MAXSTRING], new[MAXSTRING];


        if(size!=0)
        {
		valid_int(size);
	  	if(!valid_integer)
		{
			put_offset_in_lr(size,ptr,FALSE);
                	(void) sprintf(new, "\tsub\tsp, sp, lr");
                	add_rtl_with_type(ptr->daddy,ptr, new,rinit(), ASMLINE);
		}
		else
		{
                	(void) sprintf(new, "\tsub\tsp, sp, #%d", size);
                	add_rtl_with_type(ptr->daddy,ptr, new,rinit(), ASMLINE);
		}
        }
        (void) sprintf(new, "\tsub\tfp, ip, #0");

	/* move the IP to the FP only if we need the FP */
	if(needs_fp)
        	add_rtl_with_type(ptr->daddy,ptr, new,rinit(), ASMLINE);
}

void recover_stack_space(struct list* ptr, int size)
{
	char reg2[MAXSTRING], reg[MAXSTRING], new[MAXSTRING];


        if(size!=0)
        {
		valid_int(size);
	  	if(!valid_integer)
		{
			put_offset_in_lr(size,ptr,FALSE);
                	(void) sprintf(new, "\tadd\tsp, sp, lr");
                	add_rtl_with_type(ptr->daddy,ptr, new,rinit(), ASMLINE);
		}
		else
		{
                	(void) sprintf(new, "\tadd\tsp, sp, #%d", size);
                	add_rtl_with_type(ptr->daddy,ptr, new,rinit(), ASMLINE);
		}
        }
}

void calc_local_offsets(struct list* ptr, int local_start)
{
	/* calculate offsets for local variables */
	int offset= needs_fp ? -local_start : local_start;
	struct locuse* lptr;
	char new[MAXSTRING];
	sprintf(new, "local start=%d", local_start);
	add_rtl_with_type(top, top->rtls, new, rinit(), COMMENT);

    	for (lptr = locs; lptr; lptr = lptr->next) 
	{

		/* we're only assigning offsets for local variables
		 	that are accessed */
		if(lptr->arg) 
			continue;
		if(!lptr->reps)
		{
       			sprintf(new, "%s not used ", lptr->item );
       			add_rtl_with_type(ptr->daddy, ptr, new, rinit(), COMMENT);
			continue;
		}

		/* round the offset to the proper alignment */
		/* 1 byte things don't need alignment */
		if(lptr->size == 1)
			/* do nothing */ ;
		/* two or 3 bytes need short alignment */
		else if(lptr->size == 2 || lptr->size == 3)
		{
			if(needs_fp)
				offset = -((-offset ) & ~1);
			else
				offset = ((offset +1) & ~1);
		}
		/* otherwise we can word align */
		else 
		{
			if(needs_fp)
				offset = -((-offset ) & ~3);
			else
				offset = ((offset +3) & ~3);
		}


		/* set the offset for the variable */
		lptr->offset = offset;

		/* adjust the pointer past this variable */
       		offset += lptr->size;

		/* emit the assembler equate */
       		sprintf(new, "%s = %d", lptr->item, lptr->offset);
		if(debug_opt_i("SANYOASM"))
			add_rtl_with_type(ptr->daddy, ptr, new, rinit(), COMMENT);
		else
			add_rtl_with_type(ptr->daddy, ptr, new, rinit(), ASMLINE);
		


		/* because of the wierd constants on arm, we 
			move all uses of locals out of the 
			rtls they are in, and into new rtls.
			we'll call instruction selection (later)
			again to help us out. 
                */
		large_offset(lptr->code, lptr->offset);
	}

}

void calc_param_offsets(struct list* ptr, int moved_offset, int unmoved_offset)
{

	struct locuse* lptr;
	char new[MAXSTRING];
	int total;

	int offset;


	/* find out which args actually made it to the stack */
	total=spilled_reg;

	/* the spilled reg params go "before" the unmoved offset area */
	if(needs_fp)
		offset=unmoved_offset-(total*4);
	else
		offset=unmoved_offset;

        /* calculate offsets for each parameter */
	/* spill those to the stack that don't have *regin set */
        for (lptr = locs; lptr; lptr = lptr->next)
        {
		int i;
		/* if its' not an arg, look at the next local */
                if(!lptr->arg) 
			continue;

		/* we find out what register this param is in */
		i=reg_num_of_param(lptr);

		/* if it's not spilled, we don't emit an offset */
		/* or save space */
		if(i<4 && !must_spill[i])
		{
       			sprintf(new,"%s not used",lptr->item,lptr->offset);
			add_rtl_with_type(ptr->daddy, ptr, new, rinit(), COMMENT);
			continue;
		}


		/* here we start the stack arguments, consequently, 
		   the offset from the fp is 0 */
		if(i==4)
			offset=unmoved_offset;

		/* if we're moving register arguments, do so */
		if(can_move_reg_args() && i<4)
			lptr->offset=moved_offset;
		else
			lptr->offset=offset;
       		sprintf(new,"%s = %d",lptr->item,lptr->offset);
		if(debug_opt_i("SANYOASM"))
			add_rtl_with_type(ptr->daddy, ptr, new, rinit(), COMMENT);
		else
			add_rtl_with_type(ptr->daddy, ptr, new, rinit(), ASMLINE);
		offset+=lptr->size;
		moved_offset+=lptr->size;
		assert(lptr->size%4==0);

		large_offset(lptr->code, lptr->offset);
	}
}


void add_epilogue(struct blist *ret_preds, int reg_param_space, int int_save_space,
	int total_saved)
{

	char reg[MAXSTRING], new[MAXSTRING];
	struct list* call_site;
	int highreg, lowreg;
	int item, index;
	int total;
	int float_non_scratch_reg_save_size=calculate_non_scratch_float_reg_save_size();
	int extra_needed=0;
    	regarray tr = (regarray) top->regstate;
	int really_restored=FALSE;
	char ldm[MAXSTRING];
	int restore_list[MAXREGS], restorecnt;
	int	multiregs = get_multiregs();
	int ldm_needed, regs_for_this_ldm, first_time, use_ip = FALSE;

	total=spilled_reg;

	  sprintf(new, "reg_param_space=%d, int_save_space=%d",
		reg_param_space,int_save_space);
	  add_rtl_with_type(top, top->rtls, new, rinit(), COMMENT);

    	/*
     	 * Go to all of the exit points of the function and insert the 
	 * appropriate epilogue code.
     	 */
    	while (ret_preds) 
	{
		
#ifdef HARDFLOAT 
        	lowreg=100;
        	highreg=-1;

        	item = availreg(DTREG);
        	for (index = firstreg(DTREG); item--; index += skipreg(DTREG))
        	{
                	if (tr->reg[index].status != NOTUSED)
                	{
                        	makereg(reg, DTREG, indextoreg(DTREG, index));
                        	if (!scratchreg(reg))
                        	{
                                	if(indextoreg(DTREG,index)<lowreg)
                                        	lowreg=indextoreg(DTREG,index);
                                	if(indextoreg(DTREG,index)>highreg)
                                        	highreg=indextoreg(DTREG,index);
                        	}
                	}
        	}
		if(highreg!=-1)
		{
			/* the fp, sp, and lr are saved at fp+16 */
			/* we left 16 bytes for r0-r3 if they needed to be saved */
			if(needs_fp)
			{
      				sprintf(new, "\tsub\tip, fp, #%d", reg_param_space+int_save_space);
            			add_rtl_with_type(ret_preds->ptr, ret_preds->ptr->rtlend, new, rinit(), ASMLINE);
        			sprintf(new, "\tlfmea\tf%d,%d,[ip]", lowreg, highreg-lowreg+1);
            			add_rtl_with_type(ret_preds->ptr, ret_preds->ptr->rtlend, new, rinit(), ASMLINE);
			}
			else
			{
				recover_stack_space(ret_preds->ptr->rtlend, total_saved);
        			sprintf(new, "\tlfmfd\tf%d,%d,[sp]!", lowreg, highreg-lowreg+1);
            			add_rtl_with_type(ret_preds->ptr, ret_preds->ptr->rtlend, new, rinit(), ASMLINE);
				if(can_move_reg_args()) 	
					extra_needed=total*4;
				if(extra_needed)
                                	recover_stack_space(ret_preds->ptr->rtlend, extra_needed);  
				extra_needed=0;	
			}

		}
		else
#endif /* #ifdef HARDFLOAT */
		{
			if(!needs_fp)
			{
				if(can_move_reg_args()) 	
					extra_needed=total*4;
                                recover_stack_space(ret_preds->ptr->rtlend,  
                                  total_saved+float_non_scratch_reg_save_size+extra_needed);
				extra_needed=0;
			}
		}
		if(irq_handler)
		{
			/* the FP regs have been restore, now restore 
			 * the int regs */
      			sprintf(new, "\tsub\tip, fp, #20");
            		add_rtl_with_type(ret_preds->ptr, ret_preds->ptr->rtlend, 
					new, rinit(), ASMLINE);
      			sprintf(new, "\tldmea ip, {");
                	item = availreg(RTREG);
                	for (index = firstreg(RTREG); item--; 
				index+= skipreg(RTREG))
                	{
                    	    if (tr->reg[index].status != NOTUSED)
                    	    {
                        	makereg(reg, RTREG, indextoreg(RTREG, index));
                        	if (!scratchreg(reg) && 
					indextoreg(RTREG,index)<=9)
                        	{
                                	char* spill_reg=
					   r_regs[indextoreg(RTREG, index)];
                                	strcat(new, spill_reg);
                                	strcat(new, ", ");
                        	}
                    	    }
                	}
                	if(needs_sb && debug_opt("PIC"))
                        	strcat(new, "r9, ");
                	item = availreg(RTREG);
                	for (index = firstreg(RTREG); item--; 
				index+= skipreg(RTREG))
                	{
                    	    if (tr->reg[index].status != NOTUSED)
                    	    {
                        	makereg(reg, RTREG, indextoreg(RTREG, index));
                        	if (!scratchreg(reg) && 
					indextoreg(RTREG,index)>9)
                        	{
                                	char* spill_reg=
					r_regs[indextoreg(RTREG, index)];
                                	strcat(new, spill_reg);
                                	strcat(new, ", ");
                        	}
                    	    }
                	}
                        strcat(new, "fp, sp, lr}");
            		add_rtl_with_type(ret_preds->ptr, ret_preds->ptr->rtlend, 
					new, rinit(), ASMLINE);

      			sprintf(new, "\tmov\tsp, ip");
            		add_rtl_with_type(ret_preds->ptr, ret_preds->ptr->rtlend, 
					new, rinit(), ASMLINE);
      			sprintf(new, "\tldmfd sp!, {ip}");
            		add_rtl_with_type(ret_preds->ptr, ret_preds->ptr->rtlend, 
					new, rinit(), ASMLINE);
      			sprintf(new, "\tldmfd sp!, {r0,r1,r2,r3}");
            		add_rtl_with_type(ret_preds->ptr, ret_preds->ptr->rtlend, 
					new, rinit(), ASMLINE);

			
			if(debug_opt("debug_irq"))
      				sprintf(new, "\tmov pc, lr");
			else
	      			sprintf(new, "\tsubs pc, lr, #4");
            		add_rtl_with_type(ret_preds->ptr, ret_preds->ptr->rtlend, 
					new, rinit(), ASMLINE);
		}
		else
		{	
			restorecnt = 0;
           		item = availreg(RTREG);
           		for (index = firstreg(RTREG); item--; index+= skipreg(RTREG))
           		{
                		if (tr->reg[index].status != NOTUSED)
                		{
                    			makereg(reg, RTREG, indextoreg(RTREG, index));
		       		  	if (!scratchreg(reg) && indextoreg(RTREG,index)<=9)
					{	
						restore_list[restorecnt++] = indextoreg(RTREG, index);
						really_restored=TRUE;
					}
               			}
           		}
		   	if(needs_sb && debug_opt("PIC"))
		   	{
			   	restore_list[restorecnt++] = 9;
  				really_restored=TRUE;
		   	}
           		item = availreg(RTREG);
           		for (index = firstreg(RTREG); item--; index+= skipreg(RTREG))
           		{
                		if (tr->reg[index].status != NOTUSED)
                		{
                    			makereg(reg, RTREG, indextoreg(RTREG, index));
			     		if (!scratchreg(reg) && indextoreg(RTREG,index)>9) 
					{
						restore_list[restorecnt++] = indextoreg(RTREG, index);
						really_restored=TRUE;
					}
               			}
           		}
		   	call_site=can_tail_call(ret_preds->ptr->rtlend);
		   	if(needs_fp)
		   	{
				restore_list[restorecnt++] = 11;	/* for fp */
				restore_list[restorecnt++] = 13;	/* for sp */
				really_restored=TRUE;
		   	}
		   	else if(needs_spill_sp)
		   	{
				restore_list[restorecnt++] = 13;	/* for sp */
				really_restored=TRUE;
		   	}
		   	else if(needs_spill_lr || really_restored)
				really_restored=TRUE;

		   	/* new is only used of really_restored is true */
		   	if(is_interwork_func() || call_site)
				restore_list[restorecnt++] = 14;	/* for lr */
		   	else
				restore_list[restorecnt++] = 15;	/* for pc */

			/* if really restored, output LDM instructions to restore regs */
			if (really_restored)
			{
				if (needs_fp && restorecnt <= multiregs)
				{
					/* the fp, sp, and lr are saved at fp+16 */
					/* we left 16 bytes for r0-r3 if they needed to be saved */
					if (reg_param_space)
					{
						sprintf(new, "\tsub\tip, fp, #%d", reg_param_space);
           					add_rtl_with_type(ret_preds->ptr, ret_preds->ptr->rtlend, new, rinit(), ASMLINE);
						sprintf(new, "\tldmea\tip, {");
					}
					else
						sprintf(new, "\tldmea\tfp, {");

					/* must restore registers backward from ip */
					for (index =0; index < restorecnt; index++)
					{
						if(index)
							strcat(new, ", ");
						strcat(new, r_regs[restore_list[index]]);
					}
					strcat(new, "}");
           				add_rtl_with_type(ret_preds->ptr, ret_preds->ptr->rtlend, new, rinit(), ASMLINE);
				}
				else
				{
					if (needs_fp)
					{
						sprintf(new, "\tsub\tip, fp, #%d", reg_param_space + (restorecnt*4));
           					add_rtl_with_type(ret_preds->ptr, ret_preds->ptr->rtlend, new, rinit(), ASMLINE);
						use_ip = TRUE;
					}
					ldm_needed = restorecnt/multiregs;
					regs_for_this_ldm = restorecnt%multiregs;
					if (regs_for_this_ldm)
						ldm_needed++;
					else
					{
						regs_for_this_ldm = multiregs;
						ldm_needed--;
					}
					first_time = TRUE;
					for (index = 0; index < restorecnt; index++)
					{
						if (first_time)
						{
							/* the sp, and lr are saved at fp+16 */
							/* we left 16 bytes for r0-r3 if they needed to be saved */
							if (use_ip)
								(void) strcpy(new, "\tldmfd\tip!, {");
							else
								(void) strcpy(new, "\tldmfd\tsp!, {");
							first_time = FALSE;
						}
						else
							(void) strcat(new, ", ");
						(void) strcat(new, r_regs[restore_list[index]]);
						if (--regs_for_this_ldm == 0)
						{
							(void) strcat(new,"}");
              						add_rtl_with_type(ret_preds->ptr, ret_preds->ptr->rtlend, new, rinit(), ASMLINE);
							regs_for_this_ldm = multiregs;
							ldm_needed--;
							first_time = TRUE;
						}
					}
				}
			}

		   	if(call_site)
		   	{
				struct list* rtlptr;
				struct list* call_site_prev, *rtlptr_next;
				call_site->val[0]='P';
				call_site->val[1]='C';
				ret_preds->ptr->rtlend->val=NULL;
				ret_preds->ptr->rtlend->se=NULL;
				remv_links(call_site);
				remv_links(ret_preds->ptr->rtlend);
	
				for(rtlptr=call_site; ; rtlptr=rtlptr->next)
				{
					if(rtlptr->type&ASMLINE)
						break;
					if(rtlptr==ret_preds->ptr->rtlend)
						break;
				}
				/* we found an ASM line (indicating the return code) or the end ptr */
				/* we need to back up one so we don't move the return code*/
				rtlptr=rtlptr->prev;
	
	
	
				call_site_prev=call_site->prev;
				rtlptr_next=rtlptr->next;
	
		
				/* break 4 links */
				call_site->prev=NULL;
				if(call_site_prev)	call_site_prev->next=NULL;
				rtlptr->next=NULL;	
				rtlptr_next->prev=NULL;	
	
				/* add 4 links */
				call_site->daddy->rtlend->next=call_site;
				call_site->prev=call_site->daddy->rtlend;
				rtlptr_next->prev=call_site_prev;
				call_site_prev->next=rtlptr_next;
		
				if(!call_site_prev)	call_site->daddy->rtls=rtlptr_next;
				call_site->daddy->rtlend=rtlptr;
	
		   	}
		   	else if(!needs_spill_lr && !is_interwork_func())
		   	{
				sprintf(new, "\tmov\tpc, lr");
               			add_rtl_with_type(ret_preds->ptr, ret_preds->ptr->rtlend, new, rinit(), ASMLINE);
		   	}
		   	else if(is_interwork_func())
		   	{
				sprintf(new, "\tbx\tlr");
               			add_rtl_with_type(ret_preds->ptr, ret_preds->ptr->rtlend, new, rinit(), ASMLINE);
		   	}
		  
		}

		ret_preds = ret_preds->next;
	}
}

struct list* can_tail_call(struct list* rtl)
{
	struct bblock* cblk;
	struct list* temp, *nptr;
	struct locuse* temp2;
	if(needs_fp)			return NULL;
	if(!can_move_reg_args())	return NULL;
	if(is_interwork_func())		return NULL;
	if(irq_handler)			return NULL;
	if(debug_opt("never_tail_call")) return NULL;
	if(rtl==NULL)			return NULL;

#ifdef MEASURE
	if(swef)
		return NULL;
#endif

        for(temp2=locs;temp2;temp2=temp2->next)
	{
		/* we might pass the address of this local to the 
			func, so, we can't get rid of it yet */
		if(temp2->reps && temp2->indref && !temp2->arg)
			return NULL;

		/* if it's an argument that's on our stack frame */
		/* that's referenced indirectly, we can't tail-call */
		if(temp2->arg && temp2->reps && temp2->indref &&
			reg_num_of_param(temp2)<4)
			return NULL;
	}
        /* otherwise, search the function for setjmp. */
        for (cblk = top; cblk; cblk = cblk->down)
        {
                for (nptr = cblk->rtls; nptr; nptr = nptr->next)
                {
                        /* we found a call, get the arg build size */
                        if (cnts(nptr) && nptr->val[0]=='S' && nptr->val[1]=='T')
                        {
				char *addr=NULL;
                                if(isGlobal(nptr->val+3))
					addr=nptr->val+3;
                                if(strlen(nptr->val)>8 && isGlobal(nptr->val+8))
					addr=nptr->val+8;
					
				if(addr)
                                {
                                        if(strcmp(globalname(nptr->val+3),"setjmp")==0)
                                                return NULL;
                                        if(strcmp(globalname(nptr->val+3),"_setjmp")==0)
                                                return NULL;
                                }
                        }
                }
        }


	for(temp=rtl->prev;temp;temp=temp->prev)
	{
		if(cnts(temp) && fmatch(temp->val,"ST="))
		{
			/* but not a predicated call */
			if(fmatch(temp->val,cc_reg)) 
				return NULL;

			/* not an indirect call, please */
			if(!isGlobal(temp->val+3))
				return NULL;

			if(temp->prev && (temp->prev->type&ARGBLINE) && 
			   temp->prev->val && atoi(temp->prev->val)==0)
				/* OK, good chance to tail call. */
				return temp;

			/* we failed to find the arg-build size.. can only do it if it's zero. */
			return NULL;
		}
		if(cnts(temp))
			return NULL;
	}
	return NULL;

	
}

void fix_multiplies(void)
{
	struct bblock* cblk;
	struct list* nptr;
	char reg[MAXSTRING], reg2[MAXSTRING], new[MAXSTRING];

	/* fixup multiplies that've gone awry */
      	for (cblk = top; cblk; cblk = cblk->down) 
	{
        	for (nptr = cblk->rtls; nptr; nptr = nptr->next) 
		{
			char *a;
			a=nptr->val;
			if(a)
			{
				if(strlen(a)<=5)
					continue;

				/* only worry about r[x]=r[x]*r[x] */
				/* others are valid, inst.c emits r[x]=r[x]*r[y]
				   as r[x]=r[y]*r[x] */
				if(a[5]=='*' && a[0]==a[3] && a[1]==a[4] && 
					a[6]==a[0] && a[7]==a[1] &&
					regtype(a)==RTREG)
				{
					lr_used=TRUE;
					makereg(reg2, RTREG, 14);
      					sprintf(new, "%s=XX;", reg2);
					new[3]=a[0];
					new[4]=a[1];
					a[3]=reg2[0];
					a[4]=reg2[1]; 
      					nptr=add_rtl_with_type(nptr->daddy, nptr, new, rinit(), RTLINE);
				}
				
			}

		}
	}
}



/*
 * regarg - return TRUE if the local enters the function in a register
 */
int regarg(struct locuse *lptr) 
{
	if(lptr->type!=RTREG)
		return FALSE;
	if(lptr->size!=4)
		return FALSE;
	if(!lptr->arg)
		return FALSE;
   	return(lptr->offset < 16 );
}

/*
 * initmap - initialize register mapping database
 */
void initmap() {
    register int i;
   
    for (i = 0; i < 16; i++)
      regmap[i] = alias[i] = i;
}

void early_frame_setup()
{
    static int first=TRUE;
    static int rinit_availreg;
    static int finit_availreg;
    static int dinit_availreg;
    struct bblock* cblk;
    struct list* nptr;
    struct list* start;
    struct list* end;
    makereg(cc_reg,CTREG,0);
    *skiploc(cc_reg)=0;


    if(first)
    {
	rinit_availreg=availreg(RTREG);
	finit_availreg=availreg(FTREG);
	dinit_availreg=availreg(DTREG);
	if (debug_opt_i("SANYOASM")) 
        {
	  labprt = "|.%s|\n";
	  acomment = " ; %s\n";
	}
 
    	first=FALSE;
    }

    mla_ok=FALSE;

    availreg(RTREG)=rinit_availreg;
    availreg(FTREG)=finit_availreg;
    availreg(DTREG)=dinit_availreg;
    if(!debug_opt_i("PIC") && !debug_opt("PID"))
    {
    	availreg(RTREG)++;
#ifdef SOFTFLOAT
	availreg(FTREG)++;
#endif
    }
    needs_fp=FALSE;
    if(!fp_necessary())
    {
	char fp[REGSTRING];
	char sp[REGSTRING];
	struct bblock* cblk;
	struct list* nptr;
	makereg(fp, RTREG, 11);
	makereg(sp, RTREG, 13);
	availreg(RTREG)++;
#ifdef SOFTFLOAT
	availreg(FTREG)++;
#endif
      	for (cblk = top; cblk; cblk = cblk->down) 
	{
        	for (nptr = cblk->rtls; nptr; nptr = nptr->next) 
		{
			/* we found a call, get the arg build size */
          		if (cnts(nptr))
			{
				/* fix any references to the frame pointer
					to now point to the stack poiners */
				while(fmatch(nptr->val, fp))
					copyloc(bpos, sp);
			}
		}
	}
	fp_num=13;
	add_rtl_with_type(top, top->rtls, "fp is not necessary, using FP", rinit(), COMMENT);

    }
    else
    {
	needs_fp=TRUE;
	add_rtl_with_type(top, top->rtls, "fp is necessary, not using FP", rinit(), COMMENT);
	fp_num=11;
    }

    if((debug_opt_i("PIC")||debug_opt("PID")) && !needs_fp)
    {
	/* if we're in PIC mode but the fp is not necessary 
	 * (common if pic mode) then we need to make sure
	 * that the FP can get colored
	 */
	_i2r[11]=11;	/* thus, we put the FP first */
	_i2r[12]=9;	/* then the static base */
	_r2i[RTREG][9]=12;	
	_r2i[RTREG][11]=11;
#ifdef SOFTFLOAT
	_r2i[FTREG][9]=12;	
	_r2i[FTREG][11]=11;
	_r2i[DTREG][9]=12;	
	_r2i[DTREG][11]=11;
#endif
    }
    else
    {
	/* otherwise, the SB can be colored first */
	_i2r[11]=9;
	_i2r[12]=11;
	_r2i[RTREG][9]=11;	
	_r2i[RTREG][11]=12;	
#ifdef SOFTFLOAT
	_r2i[FTREG][9]=11;	
	_r2i[FTREG][11]=12;	
	_r2i[DTREG][9]=11;	
	_r2i[DTREG][11]=12;	
#endif
    }

    if(debug_opt("size") || debug_opt("size_opt"))
	max_pred_cost=12;
    if(debug_opt("min_size") || debug_opt("min_size_opt"))
	max_pred_cost=0x3fffffff;

    if(should_remove_table)
    {
        start=end=0;
        for (cblk = top; cblk; cblk = cblk->down)
        {
                for (nptr = cblk->rtls; nptr; nptr = nptr->next)
                {
                        if ((nptr->type&METADATALINE) &&
                                strcmp(nptr->val, "start_table")==0)
                        {
                                start=nptr;
                        }
                        else if ((nptr->type&METADATALINE) &&
                                strcmp(nptr->val, "end_table")==0)
                        {
                                end=nptr;
                        }
                }
        }
        if(start && end)
        {
                nptr=start->next;
                while(nptr!=end)
                {
                        struct list* temp=nptr->next;
                        remv_rtl(nptr);
                        nptr=temp;
                }
        }

        should_remove_table=FALSE;
    }

    /* here we fixup any references to jump table entries that're invalid */
    fix_jump_table_refs();
}

/*
 * map - return register mapping on final output phase
 */
int map(char *reg) {

    return((regtype(reg) == RTREG) ? regmap[regnum(reg)] : regnum(reg));
}

/*
 * transfer - return an RTL to perform a transfer operation
 */
int transfer(char *rtl, rlist *deads, int rc1, int rt1, int ri1, int rc2,
 int rt2, int ri2) {
    register char *a;

    /*
     * There is no single instruction that will move a value from one
     * temporary memory location to another on this target machine.
     */
    if (rc1 == TEMP && rc2 == TEMP)
      return(FALSE);

    *deads = rinit();
    if (rc1 == REGISTER) {
      makerg(rtl, rt1, ri1);
      a = rtl + 2;
      }
    else {
      maketemp(rtl, rt1, ri1);
      for (a = rtl; *a; a++);
      }
    *a++ = '=';
    if (rc2 == REGISTER) {
      makereg(a, rt2, ri2);
      rinsert(a, deads);
      a += 2;
      }
    else if (rc2 == LIVEREG) {
      makereg(a, rt2, ri2);
      a += 2;
      }
    else {
      maketemp(a, rt2, ri2);
      while (*a)
        a++;
      }
    *a++ = ';';
    *a++ = '\0';
    *a = '\0';
    return(TRUE);
}

/*
 * maketemp - make a temporary location reference of a given type and index
 */
void maketemp(char *temp, int tt, int tnum) 
{
    char frame_pointer[REGSTRING];

    /* make the frame pointer */
    bzero(frame_pointer, REGSTRING);
    makereg(frame_pointer, RTREG, fp_num);

    (void) sprintf(temp, "%c[%s+SL[%d]]", memrf(tt), frame_pointer, tnum << 3);
}

/*
 * leaf - return TRUE if we are optimizing a leaf function
 */
int leaf() 
{
	return LeafFunction;
}

/*
 * sort_locs_by_offset - sort locals (locs) according to the  "offset" field
 * just a stupid  selection sort - it just looks complicated because
 * it's on a doubly-linked list.  This needs to be done because some
 * optimizations scramble the order, and for arguments, we need to process
 * them in offset order because this affects which registers hold the
 * incoming values.
 */
struct locuse *sort_locs_by_offset(struct locuse *head) 
{

  struct locuse *chase1,*chase2;
  struct locuse *tail,*temp,*hold,*smallest;

  if(!head) return head;
  chase1 = head;
  /* now, sort the arguments by swapping the smallest arg smaller
   * than chase
   */
  chase1=head;
  while(chase1) {
     smallest = chase1;
     for(chase2=chase1->next;chase2;chase2=chase2->next) {
       if(!chase2->arg)
         continue;
       if(!smallest->arg) {
            smallest = chase2;
       } else if(chase2->offset < smallest->offset) { /* swap */
            smallest = chase2;
       }
     }
     hold = chase1;
     chase1 = chase1->next;
     if(smallest != hold) {     /* swap 'em */
        if(hold->prev) {
           hold->prev->next = smallest;
        } else {
           head = smallest;
        }
        if(hold->next==smallest) {
           smallest->prev=hold->prev;
           hold->next=smallest->next;
           if(hold->next) hold->next->prev=hold;
           smallest->next=hold;
           hold->prev=smallest;
        } else {
           hold->next->prev = smallest;
           if(smallest->next) smallest->next->prev = hold;
           smallest->prev->next = hold;
           temp = smallest->next;
           smallest->next = hold->next;
           hold->next = temp;
           temp = smallest->prev;
           smallest->prev = hold->prev;
           hold->prev = temp;
        }
       }
    }
     return head;
}

struct locuse *sort_locs_by_size(struct locuse *head) 
{

  struct locuse *chase1,*chase2;
  struct locuse *tail,*temp,*hold,*smallest;

	if(!swg)
  		for(chase2=locs;chase2;chase2=chase2->next) 
  		{
			chase2->reps++;
  		}

  if(!head) return head;
  chase1=head;
  while(chase1) 
  {
     smallest=chase1;
     for(chase2=chase1->next;chase2;chase2=chase2->next) 
     {
       if(chase2->arg)
	  continue;
       if(smallest->arg)
	  smallest=chase2;
       if(chase2->size > smallest->size) 
       { /* swap */
            smallest = chase2;
       }
     }
     hold = chase1;
     chase1 = chase1->next;
     if(smallest != hold) 
     {     /* swap 'em */
        if(hold->prev) 
        {
           hold->prev->next = smallest;
        } 
        else 
        {
           head = smallest;
        }
        if(hold->next==smallest) 
        {
           smallest->prev=hold->prev;
           hold->next=smallest->next;
           if(hold->next) hold->next->prev=hold;
           smallest->next=hold;
           hold->prev=smallest;
        } 
        else 
        {
           hold->next->prev = smallest;
           if(smallest->next) smallest->next->prev = hold;
           smallest->prev->next = hold;
           temp = smallest->next;
           smallest->next = hold->next;
           hold->next = temp;
           temp = smallest->prev;
           smallest->prev = hold->prev;
           hold->prev = temp;
        }
     }
  }
  return head;
}


void large_offset(char* code, int offset)
{
	struct bblock* cblk;
	struct list* nptr;
	char xtra[MAXSTRING];
	char reg[REGSTRING];
	char fp[REGSTRING];
	char *a, *b, *c;
	char new[MAXSTRING];
	if(debug_opt("no_large_offset"))
		return;
   	makereg(fp, RTREG, fp_num);
	for (cblk = top; cblk; cblk = cblk->down) 
	{
               	for (nptr = cblk->rtls; nptr; nptr = nptr->next) 
		{
		  *xtra=0;
                  if (a = cnts(nptr)) 
		  {
                     while (*a) 
		     {
			/* since F[fp+lr] is invalid, we watch for the fp here */
			/* look for fp+local */
                        if (*a == *fp && *(a + 1) == *(fp + 1) && *(a+2)=='+'
				&& *(a+3) == *code && *(a + 4) == *(code + 1)) 
			{
			   int byte=3;
			   update_type(nptr, nptr->type|COMBLINE);
                           makereg(reg, RTREG, 14);
                           *a++ = reg[0];
                           *a++ = reg[1];
			   rinsert(reg,&nptr->deads);
			   a=sub(a, a+3, "");
                           c = a;
			   if(offset<0)
			   {
			   	put_offset_in_lr(-offset, nptr,TRUE);
                           	sprintf(new, "%s=%s-%s;", reg, fp, reg);
			   }
			   else
			   {
			   	put_offset_in_lr(offset, nptr,TRUE);
                           	sprintf(new, "%s=%s+%s;", reg, fp, reg);
			   }
                           add_rtl_with_type(nptr->daddy, nptr, new, rinit(), RTLINE);
                           sprintf(new, "\tfixentry loaded %s", 
				localrecord(code)->item);
                           nptr=add_rtl_with_type(nptr->daddy, nptr, new, rinit(), COMMENT);
                           if (*xtra)
                              a = sub(c, a, "");
                           break;
                        }
			/* look for local+fp */
                        else if (*a == *code && *(a + 1) == *(code + 1) && *(a+2)=='+'
				&& *(a+3) == *fp && *(a + 4) == *(fp + 1)) 
			{
			   int byte=3;
			   update_type(nptr, nptr->type|COMBLINE);
                           makereg(reg, RTREG, 14);
                           *a++ = reg[0];
                           *a++ = reg[1];
			   rinsert(reg,&nptr->deads);
			   a=sub(a, a+3, "");
                           c = a;
			   if(offset<0)
			   {
			   	put_offset_in_lr(-offset, nptr,TRUE);
                           	sprintf(new, "%s=-%s;", reg, fp, reg);
   			   	add_rtl_with_type(nptr->daddy, nptr, new, rinit(), RTLINE);
			   }
			   else
			   {
			   	put_offset_in_lr(offset, nptr,TRUE);
			   }
                           sprintf(new, "%s=%s-%s;", reg, fp, reg);
                           add_rtl_with_type(nptr->daddy, nptr, new, rinit(), RTLINE);
                           sprintf(new, "%s=%s%s;", reg, reg, fp);
                           add_rtl_with_type(nptr->daddy, nptr, new, rinit(), RTLINE);
                           if (*xtra)
                              a = sub(c, a, "");
                           break;
                        }
                        else if (*a == *code && *(a + 1) == *(code + 1)) 
			{
			   int byte=3;
			   update_type(nptr, nptr->type|COMBLINE);
                           makereg(reg, RTREG, 14);
                           *a++ = reg[0];
                           *a++ = reg[1];
			   rinsert(reg,&nptr->deads);
                           c = a;
                           b = xtra;
                           while (*a != ';' && *a != ']')
                              *b++ = *a++;
                           *b++ = '\0';
			   if(offset<0)
			   {
			   	put_offset_in_lr(-offset, nptr,TRUE);
                           	sprintf(new, "%s=-%s;", reg, fp, reg);
   			   	add_rtl_with_type(nptr->daddy, nptr, new, rinit(), RTLINE);
			   }
			   else
			   {
			   	put_offset_in_lr(offset, nptr,TRUE);
			   }
                           /*
                            * xtra contains the expression added to the offset
                            * if it exists
                            */
                           if (*xtra)
			   {
                              	sprintf(new, "%s=%s%s;", reg, reg, xtra);
                           	add_rtl_with_type(nptr->daddy, nptr, new, rinit(), RTLINE);
			   }
                           if (*xtra)
                              a = sub(c, a, "");
                           break;
                        }
			a++;
		    }
		  }
		  if((nptr->type&ASMLINE) && nptr->val && fmatch(nptr->val, ".stabs"))
		  {
			char var_name[MAXSTRING];
			char value[MAXSTRING];
		
			sprintf(var_name, "|%s|", localrecord(code)->item);
			sprintf(value, "%d", offset);
			/* if we find the name in this stab, replace it with the value */
			if(fmatch(nptr->val, var_name))
				sub(bpos,epos,value);

                  }
		}
	}
}

void put_offset_in_lr(int offset, struct list* nptr, int use_rtls)
{
   char new[MAXSTRING];
   char reg[REGSTRING];
   int first=TRUE;
   int byte=0;


   lr_used=TRUE;
   makereg(reg, RTREG, 14);

   if(offset==0)
   {
	if(use_rtls)
	{
   		sprintf(new, "%s=%d;", reg,offset);
        	add_rtl_with_type(nptr->daddy, nptr, new, rinit(), RTLINE);
	}
	else
	{
   		sprintf(new, "\tmov\t r%s, #%d", regnum(reg),offset);
        	add_rtl_with_type(nptr->daddy, nptr, new, rinit(), ASMLINE);
	}
        return;
   }

   while(offset!=0)
   {
   	valid_int(offset);
	if(first)
	{
   		if(valid_integer || valid_flipped)
   		{
			if(use_rtls)
			{
   				sprintf(new, "%s=%d;", reg,offset);
   				add_rtl_with_type(nptr->daddy, nptr, new, rinit(), RTLINE);
			}
			else
			{
   				sprintf(new, "\tmov\t r%s, #%d", regnum(reg),offset);
        			add_rtl_with_type(nptr->daddy, nptr, new, rinit(), ASMLINE);
			}
			return;
   		}
		else if(valid_negated)
		{
			if(use_rtls)
			{
   				sprintf(new, "%s=%d;", reg,-offset);
   				add_rtl_with_type(nptr->daddy, nptr, new, rinit(), RTLINE);
   				sprintf(new, "%s=-%s;", reg,reg);
   				add_rtl_with_type(nptr->daddy, nptr, new, rinit(), RTLINE);
			}
			else
			{
   				sprintf(new, "\tmov\tr%d, #%d", regnum(reg),-offset);
   				add_rtl_with_type(nptr->daddy, nptr, new, rinit(), ASMLINE);
   				sprintf(new, "\tneg\tr%d,%d", regnum(reg),regnum(reg));
   				add_rtl_with_type(nptr->daddy, nptr, new, rinit(), ASMLINE);
			}
			return;
		}
		else if((offset&(255<<(byte*8))) !=0 )
		{
			if(use_rtls)
			{
				sprintf(new, "%s=%d;", reg, offset&(255<<(byte*8)));
                		add_rtl_with_type(nptr->daddy, nptr, new, rinit(), RTLINE);
			}
			else
			{
				sprintf(new, "\tmov\tr%d, #%d", regnum(reg), offset&(255<<(byte*8)));
                		add_rtl_with_type(nptr->daddy, nptr, new, rinit(), ASMLINE);
			}
			first=FALSE;
		}
	}
	else
	{
   		if(valid_integer)
   		{
			if(use_rtls)
			{
   				sprintf(new, "%s=%s|%d;", reg, reg, offset);
   				add_rtl_with_type(nptr->daddy, nptr, new, rinit(), RTLINE);
			}
			else
			{
   				sprintf(new, "\torr\tr%d,r%d,#%d", regnum(reg), regnum(reg), offset);
   				add_rtl_with_type(nptr->daddy, nptr, new, rinit(), ASMLINE);
			}
			return;
   		}
		else if((offset&(255<<(byte*8))) !=0 )
		{
			if(use_rtls)
			{
				sprintf(new, "%s=%s|%d;", reg, reg, offset&(255<<(byte*8)));
                		add_rtl_with_type(nptr->daddy, nptr, new, rinit(), RTLINE);
			}
			else
			{
				sprintf(new, "\torr\tr%d,r%d,#%d", regnum(reg), regnum(reg), 
					offset&(255<<(byte*8)));
                		add_rtl_with_type(nptr->daddy, nptr, new, rinit(), ASMLINE);
			}
		}
	}
	offset=offset&(~(255<<(byte*8)));
	byte++;
   }

}

int can_move_reg_args()
{
	/* we'd like to know if it's save to move incoming register arguments 
	 * this lets us use one store multiple instead of 2 to store
	 * all integer registers.
 	 */
        struct locuse* lptr;
	int  offset;

	if(debug_opt("never_move_reg_args"))
		return FALSE;

	/* args must be contiguous for var-arg style functions */
	if(varargs)
		return FALSE;

	/* we don't want to try to optimize this if it's an irq handler */
	if(irq_handler)
		return FALSE;

	offset=-16;
        for (lptr = locs; lptr; lptr = lptr->next)
        {
		if(!lptr->arg)
			continue;

		/* if some parameter spans the area between
			registers and stack, we can't move
			the registers around */
		if(offset<0 && offset+lptr->size>0)
			return FALSE;
		offset+=lptr->size;
		assert(lptr->size%4==0);


		/* OK, no more register arguments */
		if(offset>0)
			break;
	}

	/* OK, we haven't found any reason to not move them, 
	 * go ahead and do it 
	 */
	return TRUE;
}

char* makefp()
{
        static char reg[REGSTRING];
        makereg(reg, RTREG, fp_num);

        return reg;
}

int reg_num_of_param(struct locuse* param)
{
	int a=0;
	struct locuse* lptr;
	for(lptr=locs;lptr;lptr=lptr->next)
	{	
		if(!lptr->arg)
			continue;
		if(lptr==param)
			return a;
		a+=(lptr->size/4);
	}
	assert(0);
}


int find_spilled_reg_params()
{
    int conflict[16];          /* Prevents write/read problems with arguments    */
    int index, index2;
    int base, item;
    int a, offset;

    char reg[MAXSTRING], reg2[MAXSTRING], new[MAXSTRING];

    struct locuse* lptr;


    /* initialize which_regs */
    must_spill[0]=must_spill[1]=must_spill[2]=must_spill[3]=0;


    /* for vararg functions, we have to spill them all */
    if(varargs || is_irq_handler())
    {
        must_spill[0]=must_spill[1]=must_spill[2]=must_spill[3]=1;
	return 4;
    }




    /*
     * First we set up a conflict array which is going to allow us to determine
     * if we have to be careful about how we order our argument moves to
     * avoid clobbering an argument.
     */
    for (index = 0; index < 16; index++)
	conflict[index] = 0;

    for (lptr = locs; lptr; lptr = lptr->next) 
	lptr->memChar=(lptr->regin && *lptr->regin);

    for (lptr = locs; lptr; lptr = lptr->next) 
    {
	/* is this local allocated to a register */
      if (*lptr->regin && lptr->memChar && lptr->type == RTREG) 
      {
	  /* if the offset is 0, generate r0, offset=4, r1, etc */
          index = reg_num_of_param(lptr);
          makereg(reg, RTREG, index);
          index2= regmap[regnum(lptr->regin)];
          makereg(reg2, RTREG, index2);

	  /* is the local in a different register than 
	     where the register allocator put it */
          if (strcmp(reg, reg2))
          {
	    if(can_map(index, regnum(reg2)) && !lptr->reps)
            {
              char new2[100];
               	item = alias[index];
                regmap[item] = regmap[regnum(lptr->regin)];
                regmap[regnum(lptr->regin)]= index;
                alias[index] = alias[regmap[item]];
                alias[regmap[item]] = item;

/*
              item = alias[index];
              regmap[item] = regmap[regnum(lptr->regin)];
              regmap[regnum(lptr->regin)]= index;
              alias[index] = alias[regmap[item]];
              alias[regmap[item]] = item;
*/
              lptr->memChar=0;

            }
          }
      }
    }

    for (lptr = locs; lptr; lptr = lptr->next)
    {
        /* is this local allocated to a register */
      if (*lptr->regin && lptr->memChar && lptr->type == RTREG)
      {
          /* if the offset is 0, generate r0, offset=4, r1, etc */
          index = reg_num_of_param(lptr);
          makereg(reg, RTREG, index);
          index2= regmap[regnum(lptr->regin)];
          makereg(reg2, RTREG, index2);

          /* is the local in a different register than
             where the register allocator put it */
          if (strcmp(reg, reg2))
          {
            if(!can_map(index, regnum(reg2)))
            {
             /* mark that index needs to be moved to somewhere, but can't yet */
              conflict[index] |= 1;
              /* mark that regin needs to get a value, but can't yet */
              conflict[alias[regnum(reg2)]] |= 2;
		/* whoa.. if we have problems with find_spilled_reg param behaving differently
			than move_reg_params.. this might be the line.  the other one doesn't
			have the "alias" in this line
			
			If it's fixed here, don't forget the same fix in thumb.
		*/
            }
          }
      }
    }





    /*
     * Now go back and look at the items that came in on register, were
     * allocated to registers, but could not be mapped, and thus must be
     * moved to the appropriate register.  If there are any conflicts, we
     * note the fact so that we can order moves appropriately.
     */
    base = FALSE;
    for (lptr = locs; lptr; lptr = lptr->next)
    {

        /* if the argument is held in a intger register */
      if (*lptr->regin && lptr->memChar && lptr->type == RTREG)
      {
          /* if the offset is 0, generate r0, offset=4, r1, etc */
          index = reg_num_of_param(lptr);
          index2= regmap[regnum(lptr->regin)];
          makereg(reg, RTREG, index);
          makereg(reg2, RTREG, index2);

          /* but not the right one */
          if (strcmp(reg, reg2))
          {
            if(!can_map(index, regnum(reg2)))
            {
              if (!(conflict[regnum(reg2)] & 1))
              {

                /* here we just note that a move would have occurred */
                conflict[index] &= ~1;
                conflict[regnum(reg2)] &= ~2;

                /* we use memChar as a temporary to see if we've examined
                        this lptr yet */
                lptr->memChar=0;
              }
              else
                base = TRUE;
            }
          }
      }
    }


    /*
     * Now go back and pick up those items that could not be moved because of
     * conflicts.
     */
    while (base) 
    {
      base = item = FALSE;
      for (lptr = locs; lptr; lptr = lptr->next)
      {
        if (*lptr->regin && lptr->memChar && lptr->type == RTREG)
        {
            index = reg_num_of_param(lptr);
            index2= regmap[regnum(lptr->regin)];
            makereg(reg, RTREG, index);
            makereg(reg2, RTREG, index2);
            if (strcmp(reg, reg2)) {
              if(!can_map(index, regnum(reg2)))
              {
                if (!(conflict[regnum(reg2)] & 1))
                {
                  conflict[index] &= ~1;
                  conflict[regnum(reg2)] &= ~2;
                  lptr->memChar=0;
                  /*here we'd emit a "move" so we won't have to spill this reg*/
                }
                else
                  base = TRUE;
              }
          }
        }
      }


      /*
       * If the following test it true, then we have some sort of a circular
       * conflict between the registers having argument values coming in and
       * registers that must receive the values.  We resolve the conflict by
       * taking some fairly drastic actions (going through memory).
       * we could use the link reg to break the conflict.. but, for now...
       */
      if (base && !item) 
      {
        for (lptr = locs; lptr; lptr = lptr->next)
        {
          if (lptr->memChar && lptr->type == RTREG)
          {
              index = reg_num_of_param(lptr);
              index2= regmap[regnum(lptr->regin)];
              makereg(reg, RTREG, index);
              makereg(reg2, RTREG, index2);
              if (strcmp(reg, reg2))
              {
                if(!can_map(index, regnum(reg2)))
                {
                        int a=reg_num_of_param(lptr);
                        int i;
                        for(i=0;i<lptr->size;i+=4)
                                must_spill[a++]=1;

                }
              }
          }
        }
        base=FALSE;
      }

    }

    /* calculate which registers may actually contains args.  don't
	spill them all if there's only one arg */
    offset=-16;
    a=0;
    for (lptr = locs; lptr; lptr = lptr->next)
    {
	   int i;
           if(!lptr->arg)
                    continue;

            offset+=lptr->size;
            assert(lptr->size%4==0);


	    for(i=0;i<lptr->size;i+=4)
	    {
		/* if there are no reps to this param, who cares */
		if(a<4 && lptr->reps)
			must_spill[a]=1;
		a++;		
	    }

            /* OK, no more register arguments */
            if(offset>0)
                    break;
    }
    /* don't spill extra regs */
    for( ; a<4; a++)
	must_spill[a]=0;


    initmap();
    return must_spill[0]+must_spill[1]+must_spill[2]+must_spill[3];
}


/* return TRUE if the sb is needed in this function */
int hunt_sb()
{
	struct bblock *cblk;
	struct list* ptr;
	char* val;
	char r9[REGSTRING];
	
	makereg(r9, RTREG, 9);

        if(!debug_opt("PIC") && !debug_opt("PID"))
                return FALSE;

        for (cblk = top; cblk; cblk = cblk->down)
        {
                for (ptr = cblk->rtls; ptr; ptr = ptr->next)
                {
			if(val=cnts(ptr))
			{
				if(fmatch(val, r9))
					return TRUE;	
			}
		}
	}
	return FALSE;

}


void fix_spills(void)
{
        struct bblock* cblk;
        struct list* nptr;
        char reg[MAXSTRING], reg2[MAXSTRING], new[MAXSTRING];
	if(debug_opt("no_fix_spills"))
		return;

        /* fixup multiplies that've gone awry */
        for (cblk = top; cblk; cblk = cblk->down)
        {
                for (nptr = cblk->rtls; nptr; nptr = nptr->next)
                {
                        if(nptr->val && (nptr->type&RTLINE)==RTLINE)
                        if(fmatch(nptr->val, "SL"))
                        {

                                /* OK, this is a spill, fix it */
                                char reg_lr[REGSTRING];
                                char reg_fp[REGSTRING];
                                char new[MAXSTRING];
                                int offset=atoi(epos+1);
                                char* old_epos;
                                makereg(reg_lr, RTREG, 14);
                                makereg(reg_fp, RTREG, fp_num);
                                if(!fmatch(nptr->val,"D["))
					continue;
                                *epos++=reg_lr[0];
                                *epos++=reg_lr[1];
			   	rinsert(reg_lr,&nptr->deads);
                                old_epos=epos;
                                fmatch(old_epos, "]]");
                                sub(old_epos, epos, "]");


                                put_offset_in_lr(-(spilloff+offset), nptr,TRUE);

                                sprintf(new, "%s=-%s;", reg_lr,reg_lr);
                                add_rtl_with_type(nptr->daddy, nptr, new, rinit(), RTLINE);

                                sprintf(new, "%s=%s+%s;", reg_lr,reg_lr, reg_fp);
                                add_rtl_with_type(nptr->daddy, nptr, new, rinit(), RTLINE|COMBLINE);

                        }
                }
        }
}


/*
 * Code to determine if the frame pointer is necessary.
 */
int fp_necessary()
{

	/* walk the function looking for calls. 
	 * when we find a call, figure out if it's to alloca;
	 */
	struct bblock* cblk;
	struct list* nptr;

	/* we allow this debug option for testing the frame-poitner stack 
	 * and also for generating code w/debug info 
	 */
	if(debug_opt_i("never_omit_framepointer"))
		return TRUE;

	/* we'll need the frame poitner for var-arg funcs */
	if(varargs)
		return TRUE;

	/* and, let's not try to optimize anymore if we're looking at an 
	 * IRQ handling functin 
 	 */
	if(is_irq_handler())
		return TRUE;


	/* otherwise, search the function for alloca. */
      	for (cblk = top; cblk; cblk = cblk->down) 
	{
        	for (nptr = cblk->rtls; nptr; nptr = nptr->next) 
		{
			/* we found a call, get the arg build size */
          		if (cnts(nptr) && nptr->val[0]=='S' && nptr->val[1]=='T')
			{
				if(isGlobal(nptr->val+3))
				{
					if (debug_opt_i("SANYOASM")) {
						if(strcmp(globalname(nptr->val+3),"_alloca")==0)
						return TRUE;
					} else if(strcmp(globalname(nptr->val+3),"alloca")==0)
						return TRUE;
				}
            		}
          	}
        }

	return FALSE;
}

int is_interwork_func()
{

        /* walk the function looking for metadata.
         * when we find it, see if it specifies an irq function
         */

        struct bblock* cblk;
        struct list* nptr;

	/* just so we can test the stack layout of all functions */
	if(debug_opt("debug_irq") || debug_opt("interwork"))
		return TRUE;

        for (cblk = top; cblk; cblk = cblk->down)
        {
                for (nptr = cblk->rtls; nptr; nptr = nptr->next)
                {
                        if (nptr->type&METADATALINE)
                        {
				if(strcmp(nptr->val, "interwork")==0)
					return TRUE;
                        }
                }
        }

        return FALSE;
}

int is_irq_handler()
{

        /* walk the function looking for metadata.
         * when we find it, see if it specifies an irq function
         */

        struct bblock* cblk;
        struct list* nptr;

	/* just so we can test the stack layout of all functions */
	if(debug_opt("debug_irq"))
		return TRUE;
        for (cblk = top; cblk; cblk = cblk->down)
        {
                for (nptr = cblk->rtls; nptr; nptr = nptr->next)
                {
                        if (nptr->type&METADATALINE)
                        {
				if(strcmp(nptr->val, "interrupt")==0)
					return TRUE;
                        }
                }
        }

        return FALSE;
}


/* 
we want to check for any parameters that are assigned
to a register, but not really used in the function.  This can
happen when the optimizer chooses to assign the parameter to a
register before it knows that the value won't really be used.

Thus, leaving around a parameter assigned to a register that
is never used.  This can cause a problem if some part of
code decides to not push a register (say, r10) but then
when moving arguments to the proper register, r10 gets set.
*/
void sanity_check_args()
{
    struct locuse* lptr;
    regarray tr = (regarray) top->regstate;
    int index=0;
    char reg[REGSTRING];

    for (lptr = locs; lptr; lptr = lptr->next)
    {
    	int item=availreg(RTREG);
        for (index = firstreg(RTREG); item--; index += skipreg(RTREG))
        {
                if (tr->reg[index].status == NOTUSED && !isused[index])
                {
                        makereg(reg, RTREG, indextoreg(RTREG, index));

			/* we found an unused reg assigned to a parameter.  forget
			 * the assignment, the param is unused 
			 */
			if(cmploc(lptr->regin,reg)==0)
				*lptr->regin=0;
                }
        }
    }

}

void remove_table_if_unnecessary()
{
        struct bblock* cblk;
        struct list* nptr;
        struct list* start;
        struct list* end;
        char* label;

        /* just so we can test the stack layout of all functions */
        start=end=0;
        for (cblk = top; cblk; cblk = cblk->down)
        {
                for (nptr = cblk->rtls; nptr; nptr = nptr->next)
                {
                        if ((nptr->type&METADATALINE) &&
                                strncmp(nptr->val, "table_label=",
                                        strlen("table_label="))==0)
                        {
                                label=nptr->val+strlen("table_label=");
                        }
                }
        }
        for (cblk = top; cblk; cblk = cblk->down)
        {
                for (nptr = cblk->rtls; nptr; nptr = nptr->next)
                {
                        if (cnts(nptr))
                        {
                                if(fmatch(nptr->val, label))
                                        return;
                        }
                }
        }


        /* if we make it here, we need to remove the table, and tableptr */

        /* just so we can test the stack layout of all functions */
        should_remove_table=TRUE;
        start=end=0;
        for (cblk = top; cblk; cblk = cblk->down)
        {
                for (nptr = cblk->rtls; nptr; nptr = nptr->next)
                {
                        if ((nptr->type&METADATALINE) &&
                                strcmp(nptr->val, "start_tableptr")==0)
                        {
                                start=nptr;
                        }
                        else if ((nptr->type&METADATALINE) &&
                                strcmp(nptr->val, "end_tableptr")==0)
                        {
                                end=nptr;
                        }
                }
        }
        if(start && end)
        {
                nptr=start->next;
                while(nptr!=end)
                {
                        struct list* temp=nptr->next;
                        remv_rtl(nptr);
                        nptr=temp;
                }
        }
}



#define MAXSWITCHES 100
#define MAXCEGENCONSTS 100
static char* switch_index_defs[MAXSWITCHES];
static char* cegen_const_defs[MAXCEGENCONSTS];
static int num_switch_index_defs=0;
static int num_cegen_const_defs = 0;

void memorize_jump_table_defs()
{
	struct bblock* cblk;
	struct list* rtlptr;
	num_switch_index_defs=0;
	num_cegen_const_defs=0;
 	for (cblk = top; cblk; cblk = cblk->down)
        {
                for (rtlptr = cblk->rtls; rtlptr; rtlptr = rtlptr->next)
                {
                        if ((rtlptr->type&METADATALINE) &&
                                fmatch(rtlptr->val, "switch_index_def"))
                        {
				switch_index_defs[num_switch_index_defs]=(char*)CALLOC_PERM(strlen(epos)+2);
				strcpy(switch_index_defs[num_switch_index_defs],epos);
				num_switch_index_defs++;
                        }
                        else if ((rtlptr->type&METADATALINE) &&
                                fmatch(rtlptr->val, "cegen_const_def"))
                        {
				cegen_const_defs[num_cegen_const_defs]=(char*)CALLOC_PERM(strlen(epos)+2);
				strcpy(cegen_const_defs[num_cegen_const_defs],epos);
				num_cegen_const_defs++;
                        }
                }
        }
}

void fix_jump_table_refs()
{
	struct bblock* cblk;
	struct list* rtlptr;
	int i;
 	for (cblk = top; cblk; cblk = cblk->down)
        {
                for (rtlptr = cblk->rtls; rtlptr; rtlptr = rtlptr->next)
                {
                        if ((rtlptr->type&METADATALINE) &&
                                fmatch(rtlptr->val, "switch_index_ref"))
                        {
				int found=FALSE;
				for(i=0;i<num_switch_index_defs;i++)
				{
					if(fmatch(rtlptr->val,switch_index_defs[i]))
						found=TRUE;
				}
				/* OK, we need to fix the reference to this switch table now */
				if(!found)
				{
					assert(rtlptr->next && rtlptr->next->val && rtlptr->next->type&ASMLINE);
					if(debug_opt("SANYOASM"))
						sprintf(rtlptr->next->val,"\tDCD\t0");
					else
						sprintf(rtlptr->next->val,".word 0");
				}
                        }
			else if ((rtlptr->type&METADATALINE) &&
				 fmatch(rtlptr->val, "cegen_const_ref"))
			  {
			    int found=FALSE;
			    for(i=0;i<num_cegen_const_defs;i++)
			      {
				if(fmatch(rtlptr->val,cegen_const_defs[i]))
				  found=TRUE;
			      }
			    /* OK, we need to fix the reference to this switch table now */
			    if(!found)
			      {
				assert(rtlptr->next && rtlptr->next->val && rtlptr->next->type&ASMLINE);
				if(debug_opt("SANYOASM"))
				  sprintf(rtlptr->next->val,"\tDCD\t0");
				else
				  sprintf(rtlptr->next->val,".word 0");
			      }
			  }
                        
                }
        }
}


/* This routine removes compiler generated temporaries that hold
global table entries and were not promoted to registers. This requires
that the global table address be promoted to a register and the
register not used for any other purpose anywhere in the function.

Removing the local involves keeping track of the offset of the table
entry. The code expander inserts meta-data for this. 
*/


struct temp_info
{
  char name[MAXSTRING];
  int offset;

};
int table_ptr_reg_reset(char *reg,char*);

void remove_unpromoted_table_entries()
{
  struct bblock *cblk;
  char table_addr_reg[REGSTRING]; /* Register holding the table addr */
  char table_label[MAXSTRING];
  char rtlcopy[MAXSTRING];
  struct list *rtl,*prtl;
  char *c,*a,*p1,*p2;
  struct temp_info temps_used[100];
  int index=0,j;
  char local[MAXSTRING];
  int lset,type,ind;
  char frame_pointer[REGSTRING];
  int offset;
  char buffer[MAXSTRING];
  struct locuse* loc=NULL;

  if(debug_opt("never_remove_promoted_table_entries"))
	return;
  if(debug_opt("PIC"))
	return;
  if(debug_opt("PID"))
	return;



  if (!top)
    return;

  table_label[0]=0;
  for (rtl = top->rtls; rtl; rtl = rtl->next) 
  {
    if ((rtl->type & METADATALINE) && strncmp(rtl->val,"promoted_constant",strlen("promoted_constant"))==0) 
    {
	char name[MAXSTRING];
        j = 0;
        c = rtl->val + strlen("promoted_constant");
        c++;
      	while (*c != ',')
        	name[j++] = *c++;
      	name[j]=0;
	for(loc=locs;loc;loc=loc->next)
	{
		if(loc->reps && strcmp(loc->item,name)==0)
		{
			add_rtl_with_type(rtl->daddy,rtl,"constant not promoted",rinit(), COMMENT);
		}
	}
    }
  }

  for (rtl = top->rtls; rtl; rtl = rtl->next) {
    if ((rtl->type & METADATALINE) && strncmp(rtl->val,"table_label",strlen("table_label"))==0) {
      c = rtl->val + strlen("table_label");
      c++; /* skip = */
      strcpy(table_label,c);
      break;

    }

  }
  
  if (!table_label[0])
    return;

  for (rtl = top->rtls; rtl; rtl = rtl->next) 
  {
    if (cnts(rtl))
    {
      	if (fmatch(rtl->val,"LA[")) 
	{
		if (strncmp(epos,table_label,strlen(table_label))==0) 
		{
	  		/* Get the regr onto which it is loaded */
	  		a = c = rtl->val;
	  		if (isrg(c) && (c = gtrg(c)) && *c == '=') 
			{
	    			copyloc(table_addr_reg,a);
	    			*(skiploc(table_addr_reg)) = 0;
	    			break;
	  		}
		}
      	}
      	else if(fmatch(rtl->val,table_label))
	{
		return;
	}
     
    }
  }

  /* Add a check here to make sure the table_ptr_reg is never reset */
  if (table_ptr_reg_reset(table_addr_reg,table_label))
    return;

  /* Get the list of temporaries onto which table entries are loaded */
  index = 0;
  for (rtl = top->rtls; rtl; rtl = rtl->next) 
  {

    if ((rtl->type & METADATALINE) && strncmp(rtl->val,"promoted_table_entry",strlen("promoted_table_entry"))==0) 
    {
      j = 0;
      c = rtl->val + strlen("promoted_table_entry");
      c++;
      while (*c != ',')
	temps_used[index].name[j++] = *c++;

      temps_used[index].name[j]=0;
      temps_used[index++].offset = atoi(++c);
      
      if (index >= 99)
	break;
    }
  }

  temps_used[index].name[0]=0;

  /* Now, go thro each block and look for use of a temporary */
  makereg(frame_pointer,RTREG,fp_num);

  for (cblk = top; cblk; cblk = cblk->next) {
    for (rtl = cblk->rtls; rtl ; rtl = rtl->next) {
      if (!(rtl->type & RTLINE) || !cnts(rtl))
	continue;
      c = rtl->val;
      if (locget(&c,local,&type,&ind,&lset,rtl)) {
	/* Check if the local is a temporary holding the global entry */
	if (lset) {
	  if (local_in_temp(local,temps_used,&offset)) {
	    /* Remove the rtl */
	    prtl = rtl->prev;
	    remv_rtl(rtl);
	    rtl = prtl;
	  } 
	  continue;
	}
	*(skiploc(local)) = 0;
	if (local_in_temp(local,temps_used,&offset)) {
	  /* Replace with table_ptr + offset */
	  strcpy(rtlcopy,rtl->val);
	  c = rtlcopy;
	  fmatch(c,local);
	  p1 = epos;
	  fmatch(c,frame_pointer);
	  p2 = epos;
	  if (epos < p1) {
	    a = unskiploc(epos);
	    sub(a,epos,table_addr_reg);
	    a = unskiploc(p1);
	    sprintf(buffer,"%d",offset);
	    sub(a,p1,buffer);
	  } else {
	    a = unskiploc(p1);
	    sub(a,p1,table_addr_reg);
	    a = unskiploc(epos);
	    sprintf(buffer,"%d",offset);
	    sub(a,epos,buffer);
	  }
	  if (strlen(rtlcopy) > strlen(rtl->val)) {
	    FREE(rtl->val);
	    rtl->val = strcpy(CALLOC(strlen(rtlcopy)+1),rtlcopy);
	  } else
	    strcpy(rtl->val,rtlcopy);

	}

      }
    }
  }
}


int local_in_temp(char *local, struct temp_info *tbl, int *offset)
{
  int i;
  for (i=0; tbl[i].name[0];i++) {
    if (strcmp(localname(local),tbl[i].name) == 0) {
      *offset = tbl[i].offset;
      return TRUE;
    }
  }
  return FALSE;
}

int table_ptr_reg_reset(char *reg,char *lbl)
{
  struct bblock *cblk;
  struct list *rtl;
  int start_looking = FALSE;
  char *c;
  char str[MAXSTRING];

  sprintf(str,"LA[%s]",lbl);

  for (cblk = top; cblk ; cblk = cblk->next) 
  {
    for (rtl = cblk->rtls; rtl ; rtl = rtl->next) 
    {

      	if (cnts(rtl))
      	{
		if (!start_looking) 
        	{
	  		if (fmatch(rtl->val,str))
	    			start_looking = TRUE;
	  		continue;
		} 
	

		/* If the reg is ever the dest of an operation, return true */
		if(isaliasset(rtl->val,reg))
			return TRUE;
		if(rtl->se && isaliasset(rtl->se,reg))
			return TRUE;
      	} 
      
	if (!start_looking)
	  continue;
      	if (rtl->type & SETLINE) 
	{
	    	if(isaliasref(rtl->val,reg))
	    		return TRUE;
	  
	}
    }
  }
  return FALSE;
}

int get_multiregs()
{
	if (debug_opt_i("MULTIREGS", 3))
		return 3;
	if (debug_opt_i("MULTIREGS", 4))
		return 4;
	if (debug_opt_i("MULTIREGS", 5))
		return 5;
	if (debug_opt_i("MULTIREGS", 6))
		return 6;
	if (debug_opt_i("MULTIREGS", 7))
		return 7;
	if (debug_opt_i("MULTIREGS", 8))
		return 8;
	if (debug_opt_i("MULTIREGS", 9))
		return 9;
	if (debug_opt_i("MULTIREGS", 10))
		return 10;
	if (debug_opt_i("MULTIREGS", 11))
		return 11;
	if (debug_opt_i("MULTIREGS", 12))
		return 12;
	if (debug_opt_i("MULTIREGS", 13))
		return 13;
	if (debug_opt_i("MULTIREGS", 14))
		return 14;
	if (debug_opt_i("MULTIREGS", 15))
		return 15;
	return 16;
}
