
/************************************************************************/
/*                                                                      */
/* Copyright (c) 1987, 1988, 1989, 1990, 1991, 1992 -                   */
/*     The Rector and Visitors of the University of Virginia            */
/*                                                                      */
/* This code may not be distributed further without permission          */
/*      from the University of Virginia.                                */
/* This code is distributed WITHOUT ANY WARRANTY.  No claims are        */
/*      made as to whether it serves any particular purpose or even     */
/*      works at all.                                                   */
/*                                                                      */
/************************************************************************/

/************************************************************************
 
*************************************************************************/



#include <stdio.h>
#include "vpo.h"
#include "vpo2.h"

#include "y.tab.h" /* Machine dependent?*/
#include "misc.h"



/*
 * check_tokens -  execute a fatal error if the user mis-configures VPO
 */

static check(char *the_char)
{
	
	if(fmatch(MEMPRT,the_char))
	{
		fprintf(stderr,"Cannot have 2 character macro ending in %c, it"
			" conflicts with a memory\n", *the_char);

		exit(-1);
	}
}
void check_tokens() 
{

#if defined(AA)
	check("A");
#endif
#if defined(BA)
	check("A");
#endif
#if defined(CA)
	check("A");
#endif
#if defined(DA)
	check("A");
#endif
#if defined(EA)
	check("A");
#endif
#if defined(FA)
	check("A");
#endif
#if defined(GA)
	check("A");
#endif
#if defined(HA)
	check("A");
#endif
#if defined(IA)
	check("A");
#endif
#if defined(JA)
	check("A");
#endif
#if defined(KA)
	check("A");
#endif
#if defined(LA)
	check("A");
#endif
#if defined(MA)
	check("A");
#endif
#if defined(NA)
	check("A");
#endif
#if defined(OA)
	check("A");
#endif
#if defined(PA)
	check("A");
#endif
#if defined(QA)
	check("A");
#endif
#if defined(RA)
	check("A");
#endif
#if defined(SA)
	check("A");
#endif
#if defined(TA)
	check("A");
#endif
#if defined(UA)
	check("A");
#endif
#if defined(VA)
	check("A");
#endif
#if defined(WA)
	check("A");
#endif
#if defined(XA)
	check("A");
#endif
#if defined(YA)
	check("A");
#endif
#if defined(ZA)
	check("A");
#endif
#if defined(AB)
	check("B");
#endif
#if defined(BB)
	check("B");
#endif
#if defined(CB)
	check("B");
#endif
#if defined(DB)
	check("B");
#endif
#if defined(EB)
	check("B");
#endif
#if defined(FB)
	check("B");
#endif
#if defined(GB)
	check("B");
#endif
#if defined(HB)
	check("B");
#endif
#if defined(IB)
	check("B");
#endif
#if defined(JB)
	check("B");
#endif
#if defined(KB)
	check("B");
#endif
#if defined(LB)
	check("B");
#endif
#if defined(MB)
	check("B");
#endif
#if defined(NB)
	check("B");
#endif
#if defined(OB)
	check("B");
#endif
#if defined(PB)
	check("B");
#endif
#if defined(QB)
	check("B");
#endif
#if defined(RB)
	check("B");
#endif
#if defined(SB)
	check("B");
#endif
#if defined(TB)
	check("B");
#endif
#if defined(UB)
	check("B");
#endif
#if defined(VB)
	check("B");
#endif
#if defined(WB)
	check("B");
#endif
#if defined(XB)
	check("B");
#endif
#if defined(YB)
	check("B");
#endif
#if defined(ZB)
	check("B");
#endif
#if defined(AC)
	check("C");
#endif
#if defined(BC)
	check("C");
#endif
#if defined(CC)
	check("C");
#endif
#if defined(DC)
	check("C");
#endif
#if defined(EC)
	check("C");
#endif
#if defined(FC)
	check("C");
#endif
#if defined(GC)
	check("C");
#endif
#if defined(HC)
	check("C");
#endif
#if defined(IC)
	check("C");
#endif
#if defined(JC)
	check("C");
#endif
#if defined(KC)
	check("C");
#endif
#if defined(LC)
	check("C");
#endif
#if defined(MC)
	check("C");
#endif
#if defined(NC)
	check("C");
#endif
#if defined(OC)
	check("C");
#endif

/*  we don't need to check PC, that token is important.  we won't see PC[ anyhow. 
#if defined(PC)
	check("C");
#endif
*/
#if defined(QC)
	check("C");
#endif
#if defined(RC)
	check("C");
#endif
#if defined(SC)
	check("C");
#endif
#if defined(TC)
	check("C");
#endif
#if defined(UC)
	check("C");
#endif
#if defined(VC)
	check("C");
#endif
#if defined(WC)
	check("C");
#endif
#if defined(XC)
	check("C");
#endif
#if defined(YC)
	check("C");
#endif
#if defined(ZC)
	check("C");
#endif
#if defined(AD)
	check("D");
#endif
#if defined(BD)
	check("D");
#endif
#if defined(CD)
	check("D");
#endif
#if defined(DD)
	check("D");
#endif
#if defined(ED)
	check("D");
#endif
#if defined(FD)
	check("D");
#endif
#if defined(GD)
	check("D");
#endif
#if defined(HD)
	check("D");
#endif
#if defined(ID)
	check("D");
#endif
#if defined(JD)
	check("D");
#endif
#if defined(KD)
	check("D");
#endif
#if defined(LD)
	check("D");
#endif
#if defined(MD)
	check("D");
#endif
#if defined(ND)
	check("D");
#endif
#if defined(OD)
	check("D");
#endif
#if defined(PD)
	check("D");
#endif
#if defined(QD)
	check("D");
#endif
#if defined(RD)
	check("D");
#endif
#if defined(SD)
	check("D");
#endif
#if defined(TD)
	check("D");
#endif
#if defined(UD)
	check("D");
#endif
#if defined(VD)
	check("D");
#endif
#if defined(WD)
	check("D");
#endif
#if defined(XD)
	check("D");
#endif
#if defined(YD)
	check("D");
#endif
#if defined(ZD)
	check("D");
#endif
#if defined(AE)
	check("E");
#endif
#if defined(BE)
	check("E");
#endif
#if defined(CE)
	check("E");
#endif
#if defined(DE)
	check("E");
#endif
#if defined(EE)
	check("E");
#endif
#if defined(FE)
	check("E");
#endif
#if defined(GE)
	check("E");
#endif
#if defined(HE)
	check("E");
#endif
#if defined(IE)
	check("E");
#endif
#if defined(JE)
	check("E");
#endif
#if defined(KE)
	check("E");
#endif
#if defined(LE)
	check("E");
#endif
#if defined(ME)
	check("E");
#endif
#if defined(NE)
	check("E");
#endif
#if defined(OE)
	check("E");
#endif
#if defined(PE)
	check("E");
#endif
#if defined(QE)
	check("E");
#endif
#if defined(RE)
	check("E");
#endif
#if defined(SE)
	check("E");
#endif
#if defined(TE)
	check("E");
#endif
#if defined(UE)
	check("E");
#endif
#if defined(VE)
	check("E");
#endif
#if defined(WE)
	check("E");
#endif
#if defined(XE)
	check("E");
#endif
#if defined(YE)
	check("E");
#endif
#if defined(ZE)
	check("E");
#endif
#if defined(AF)
	check("F");
#endif
#if defined(BF)
	check("F");
#endif
#if defined(CF)
	check("F");
#endif
#if defined(DF)
	check("F");
#endif
#if defined(EF)
	check("F");
#endif
#if defined(FF)
	check("F");
#endif
#if defined(GF)
	check("F");
#endif
#if defined(HF)
	check("F");
#endif
#if defined(IF)
	check("F");
#endif
#if defined(JF)
	check("F");
#endif
#if defined(KF)
	check("F");
#endif
#if defined(LF)
	check("F");
#endif
#if defined(MF)
	check("F");
#endif
#if defined(NF)
	check("F");
#endif
#if defined(OF)
	check("F");
#endif
#if defined(PF)
	check("F");
#endif
#if defined(QF)
	check("F");
#endif
#if defined(RF)
	check("F");
#endif
#if defined(SF)
	check("F");
#endif
#if defined(TF)
	check("F");
#endif
#if defined(UF)
	check("F");
#endif
#if defined(VF)
	check("F");
#endif
#if defined(WF)
	check("F");
#endif
#if defined(XF)
	check("F");
#endif
#if defined(YF)
	check("F");
#endif
#if defined(ZF)
	check("F");
#endif
#if defined(AG)
	check("G");
#endif
#if defined(BG)
	check("G");
#endif
#if defined(CG)
	check("G");
#endif
#if defined(DG)
	check("G");
#endif
#if defined(EG)
	check("G");
#endif
#if defined(FG)
	check("G");
#endif
#if defined(GG)
	check("G");
#endif
#if defined(HG)
	check("G");
#endif
#if defined(IG)
	check("G");
#endif
#if defined(JG)
	check("G");
#endif
#if defined(KG)
	check("G");
#endif
#if defined(LG)
	check("G");
#endif
#if defined(MG)
	check("G");
#endif
#if defined(NG)
	check("G");
#endif
#if defined(OG)
	check("G");
#endif
#if defined(PG)
	check("G");
#endif
#if defined(QG)
	check("G");
#endif
#if defined(RG)
	check("G");
#endif
#if defined(SG)
	check("G");
#endif
#if defined(TG)
	check("G");
#endif
#if defined(UG)
	check("G");
#endif
#if defined(VG)
	check("G");
#endif
#if defined(WG)
	check("G");
#endif
#if defined(XG)
	check("G");
#endif
#if defined(YG)
	check("G");
#endif
#if defined(ZG)
	check("G");
#endif
#if defined(AH)
	check("H");
#endif
#if defined(BH)
	check("H");
#endif
#if defined(CH)
	check("H");
#endif
#if defined(DH)
	check("H");
#endif
#if defined(EH)
	check("H");
#endif
#if defined(FH)
	check("H");
#endif
#if defined(GH)
	check("H");
#endif
#if defined(HH)
	check("H");
#endif
#if defined(IH)
	check("H");
#endif
#if defined(JH)
	check("H");
#endif
#if defined(KH)
	check("H");
#endif
#if defined(LH)
	check("H");
#endif
#if defined(MH)
	check("H");
#endif
#if defined(NH)
	check("H");
#endif
#if defined(OH)
	check("H");
#endif
#if defined(PH)
	check("H");
#endif
#if defined(QH)
	check("H");
#endif
#if defined(RH)
	check("H");
#endif
#if defined(SH)
	check("H");
#endif
#if defined(TH)
	check("H");
#endif
#if defined(UH)
	check("H");
#endif
#if defined(VH)
	check("H");
#endif
#if defined(WH)
	check("H");
#endif
#if defined(XH)
	check("H");
#endif
#if defined(YH)
	check("H");
#endif
#if defined(ZH)
	check("H");
#endif
#if defined(AI)
	check("I");
#endif
#if defined(BI)
	check("I");
#endif
#if defined(CI)
	check("I");
#endif
#if defined(DI)
	check("I");
#endif
#if defined(EI)
	check("I");
#endif
#if defined(FI)
	check("I");
#endif
#if defined(GI)
	check("I");
#endif
#if defined(HI)
	check("I");
#endif
#if defined(II)
	check("I");
#endif
#if defined(JI)
	check("I");
#endif
#if defined(KI)
	check("I");
#endif
#if defined(LI)
	check("I");
#endif
#if defined(MI)
	check("I");
#endif
#if defined(NI)
	check("I");
#endif
#if defined(OI)
	check("I");
#endif
#if defined(PI)
	check("I");
#endif
#if defined(QI)
	check("I");
#endif
#if defined(RI)
	check("I");
#endif
#if defined(SI)
	check("I");
#endif
#if defined(TI)
	check("I");
#endif
#if defined(UI)
	check("I");
#endif
#if defined(VI)
	check("I");
#endif
#if defined(WI)
	check("I");
#endif
#if defined(XI)
	check("I");
#endif
#if defined(YI)
	check("I");
#endif
#if defined(ZI)
	check("I");
#endif
#if defined(AJ)
	check("J");
#endif
#if defined(BJ)
	check("J");
#endif
#if defined(CJ)
	check("J");
#endif
#if defined(DJ)
	check("J");
#endif
#if defined(EJ)
	check("J");
#endif
#if defined(FJ)
	check("J");
#endif
#if defined(GJ)
	check("J");
#endif
#if defined(HJ)
	check("J");
#endif
#if defined(IJ)
	check("J");
#endif
#if defined(JJ)
	check("J");
#endif
#if defined(KJ)
	check("J");
#endif
#if defined(LJ)
	check("J");
#endif
#if defined(MJ)
	check("J");
#endif
#if defined(NJ)
	check("J");
#endif
#if defined(OJ)
	check("J");
#endif
#if defined(PJ)
	check("J");
#endif
#if defined(QJ)
	check("J");
#endif
#if defined(RJ)
	check("J");
#endif
#if defined(SJ)
	check("J");
#endif
#if defined(TJ)
	check("J");
#endif
#if defined(UJ)
	check("J");
#endif
#if defined(VJ)
	check("J");
#endif
#if defined(WJ)
	check("J");
#endif
#if defined(XJ)
	check("J");
#endif
#if defined(YJ)
	check("J");
#endif
#if defined(ZJ)
	check("J");
#endif
#if defined(AK)
	check("K");
#endif
#if defined(BK)
	check("K");
#endif
#if defined(CK)
	check("K");
#endif
#if defined(DK)
	check("K");
#endif
#if defined(EK)
	check("K");
#endif
#if defined(FK)
	check("K");
#endif
#if defined(GK)
	check("K");
#endif
#if defined(HK)
	check("K");
#endif
#if defined(IK)
	check("K");
#endif
#if defined(JK)
	check("K");
#endif
#if defined(KK)
	check("K");
#endif
#if defined(LK)
	check("K");
#endif
#if defined(MK)
	check("K");
#endif
#if defined(NK)
	check("K");
#endif
#if defined(OK)
	check("K");
#endif
#if defined(PK)
	check("K");
#endif
#if defined(QK)
	check("K");
#endif
#if defined(RK)
	check("K");
#endif
#if defined(SK)
	check("K");
#endif
#if defined(TK)
	check("K");
#endif
#if defined(UK)
	check("K");
#endif
#if defined(VK)
	check("K");
#endif
#if defined(WK)
	check("K");
#endif
#if defined(XK)
	check("K");
#endif
#if defined(YK)
	check("K");
#endif
#if defined(ZK)
	check("K");
#endif
#if defined(AL)
	check("L");
#endif
#if defined(BL)
	check("L");
#endif
#if defined(CL)
	check("L");
#endif
#if defined(DL)
	check("L");
#endif
#if defined(EL)
	check("L");
#endif
#if defined(FL)
	check("L");
#endif
#if defined(GL)
	check("L");
#endif
#if defined(HL)
	check("L");
#endif
#if defined(IL)
	check("L");
#endif
#if defined(JL)
	check("L");
#endif
#if defined(KL)
	check("L");
#endif
#if defined(LL)
	check("L");
#endif
#if defined(ML)
	check("L");
#endif
#if defined(NL)
	check("L");
#endif
#if defined(OL)
	check("L");
#endif
#if defined(PL)
	check("L");
#endif
#if defined(QL)
	check("L");
#endif
#if defined(RL)
	check("L");
#endif
#if defined(SL)
	check("L");
#endif
#if defined(TL)
	check("L");
#endif
#if defined(UL)
	check("L");
#endif
#if defined(VL)
	check("L");
#endif
#if defined(WL)
	check("L");
#endif
#if defined(XL)
	check("L");
#endif
#if defined(YL)
	check("L");
#endif
#if defined(ZL)
	check("L");
#endif
#if defined(AM)
	check("M");
#endif
#if defined(BM)
	check("M");
#endif
#if defined(CM)
	check("M");
#endif
#if defined(DM)
	check("M");
#endif
#if defined(EM)
	check("M");
#endif
#if defined(FM)
	check("M");
#endif
#if defined(GM)
	check("M");
#endif
#if defined(HM)
	check("M");
#endif
#if defined(IM)
	check("M");
#endif
#if defined(JM)
	check("M");
#endif
#if defined(KM)
	check("M");
#endif
#if defined(LM)
	check("M");
#endif
#if defined(MM)
	check("M");
#endif
#if defined(NM)
	check("M");
#endif
#if defined(OM)
	check("M");
#endif
#if defined(PM)
	check("M");
#endif
#if defined(QM)
	check("M");
#endif
#if defined(RM)
	check("M");
#endif
#if defined(SM)
	check("M");
#endif
#if defined(TM)
	check("M");
#endif
#if defined(UM)
	check("M");
#endif
#if defined(VM)
	check("M");
#endif
#if defined(WM)
	check("M");
#endif
#if defined(XM)
	check("M");
#endif
#if defined(YM)
	check("M");
#endif
#if defined(ZM)
	check("M");
#endif
#if defined(AN)
	check("N");
#endif
#if defined(BN)
	check("N");
#endif
#if defined(CN)
	check("N");
#endif
#if defined(DN)
	check("N");
#endif
#if defined(EN)
	check("N");
#endif
#if defined(FN)
	check("N");
#endif
#if defined(GN)
	check("N");
#endif
#if defined(HN)
	check("N");
#endif
#if defined(IN)
	check("N");
#endif
#if defined(JN)
	check("N");
#endif
#if defined(KN)
	check("N");
#endif
#if defined(LN)
	check("N");
#endif
#if defined(MN)
	check("N");
#endif
#if defined(NN)
	check("N");
#endif
#if defined(ON)
	check("N");
#endif
#if defined(PN)
	check("N");
#endif
#if defined(QN)
	check("N");
#endif
#if defined(RN)
	check("N");
#endif
#if defined(SN)
	check("N");
#endif
#if defined(TN)
	check("N");
#endif
#if defined(UN)
	check("N");
#endif
#if defined(VN)
	check("N");
#endif
#if defined(WN)
	check("N");
#endif
#if defined(XN)
	check("N");
#endif
#if defined(YN)
	check("N");
#endif
#if defined(ZN)
	check("N");
#endif
#if defined(AO)
	check("O");
#endif
#if defined(BO)
	check("O");
#endif
#if defined(CO)
	check("O");
#endif
#if defined(DO)
	check("O");
#endif
#if defined(EO)
	check("O");
#endif
#if defined(FO)
	check("O");
#endif
#if defined(GO)
	check("O");
#endif
#if defined(HO)
	check("O");
#endif
#if defined(IO)
	check("O");
#endif
#if defined(JO)
	check("O");
#endif
#if defined(KO)
	check("O");
#endif
#if defined(LO)
	check("O");
#endif
#if defined(MO)
	check("O");
#endif
#if defined(NO)
	check("O");
#endif
#if defined(OO)
	check("O");
#endif
#if defined(PO)
	check("O");
#endif
#if defined(QO)
	check("O");
#endif
#if defined(RO)
	check("O");
#endif
#if defined(SO)
	check("O");
#endif
#if defined(TO)
	check("O");
#endif
#if defined(UO)
	check("O");
#endif
#if defined(VO)
	check("O");
#endif
#if defined(WO)
	check("O");
#endif
#if defined(XO)
	check("O");
#endif
#if defined(YO)
	check("O");
#endif
#if defined(ZO)
	check("O");
#endif
#if defined(AP)
	check("P");
#endif
#if defined(BP)
	check("P");
#endif
#if defined(CP)
	check("P");
#endif
#if defined(DP)
	check("P");
#endif
#if defined(EP)
	check("P");
#endif
#if defined(FP)
	check("P");
#endif
#if defined(GP)
	check("P");
#endif
#if defined(HP)
	check("P");
#endif
#if defined(IP)
	check("P");
#endif
#if defined(JP)
	check("P");
#endif
#if defined(KP)
	check("P");
#endif
#if defined(LP)
	check("P");
#endif
#if defined(MP)
	check("P");
#endif
#if defined(NP)
	check("P");
#endif
#if defined(OP)
	check("P");
#endif
#if defined(PP)
	check("P");
#endif
#if defined(QP)
	check("P");
#endif
#if defined(RP)
	check("P");
#endif
#if defined(SP)
	check("P");
#endif
#if defined(TP)
	check("P");
#endif
#if defined(UP)
	check("P");
#endif
#if defined(VP)
	check("P");
#endif
#if defined(WP)
	check("P");
#endif
#if defined(XP)
	check("P");
#endif
#if defined(YP)
	check("P");
#endif
#if defined(ZP)
	check("P");
#endif
#if defined(AQ)
	check("Q");
#endif
#if defined(BQ)
	check("Q");
#endif
#if defined(CQ)
	check("Q");
#endif
#if defined(DQ)
	check("Q");
#endif
#if defined(EQ)
	check("Q");
#endif
#if defined(FQ)
	check("Q");
#endif
#if defined(GQ)
	check("Q");
#endif
#if defined(HQ)
	check("Q");
#endif
#if defined(IQ)
	check("Q");
#endif
#if defined(JQ)
	check("Q");
#endif
#if defined(KQ)
	check("Q");
#endif
#if defined(LQ)
	check("Q");
#endif
#if defined(MQ)
	check("Q");
#endif
#if defined(NQ)
	check("Q");
#endif
#if defined(OQ)
	check("Q");
#endif
#if defined(PQ)
	check("Q");
#endif
#if defined(QQ)
	check("Q");
#endif
#if defined(RQ)
	check("Q");
#endif
#if defined(SQ)
	check("Q");
#endif
#if defined(TQ)
	check("Q");
#endif
#if defined(UQ)
	check("Q");
#endif
#if defined(VQ)
	check("Q");
#endif
#if defined(WQ)
	check("Q");
#endif
#if defined(XQ)
	check("Q");
#endif
#if defined(YQ)
	check("Q");
#endif
#if defined(ZQ)
	check("Q");
#endif
#if defined(AR)
	check("R");
#endif
#if defined(BR)
	check("R");
#endif
#if defined(CR)
	check("R");
#endif
#if defined(DR)
	check("R");
#endif
#if defined(ER)
	check("R");
#endif
#if defined(FR)
	check("R");
#endif
#if defined(GR)
	check("R");
#endif
#if defined(HR)
	check("R");
#endif
#if defined(IR)
	check("R");
#endif
#if defined(JR)
	check("R");
#endif
#if defined(KR)
	check("R");
#endif
#if defined(LR)
	check("R");
#endif
#if defined(MR)
	check("R");
#endif
#if defined(NR)
	check("R");
#endif
#if defined(OR)
	check("R");
#endif
#if defined(PR)
	check("R");
#endif
#if defined(QR)
	check("R");
#endif
#if defined(RR)
	check("R");
#endif
#if defined(SR)
	check("R");
#endif
#if defined(TR)
	check("R");
#endif
#if defined(UR)
	check("R");
#endif
#if defined(VR)
	check("R");
#endif
#if defined(WR)
	check("R");
#endif
#if defined(XR)
	check("R");
#endif
#if defined(YR)
	check("R");
#endif
#if defined(ZR)
	check("R");
#endif
#if defined(AS)
	check("S");
#endif
#if defined(BS)
	check("S");
#endif
#if defined(CS)
	check("S");
#endif
#if defined(DS)
	check("S");
#endif
#if defined(ES)
	check("S");
#endif
#if defined(FS)
	check("S");
#endif
#if defined(GS)
	check("S");
#endif
#if defined(HS)
	check("S");
#endif
#if defined(IS)
	check("S");
#endif
#if defined(JS)
	check("S");
#endif
#if defined(KS)
	check("S");
#endif
#if defined(LS)
	check("S");
#endif
#if defined(MS)
	check("S");
#endif
#if defined(NS)
	check("S");
#endif
#if defined(OS)
	check("S");
#endif
#if defined(PS)
	check("S");
#endif
#if defined(QS)
	check("S");
#endif
#if defined(RS)
	check("S");
#endif
#if defined(SS)
	check("S");
#endif
#if defined(TS)
	check("S");
#endif
#if defined(US)
	check("S");
#endif
#if defined(VS)
	check("S");
#endif
#if defined(WS)
	check("S");
#endif
#if defined(XS)
	check("S");
#endif
#if defined(YS)
	check("S");
#endif
#if defined(ZS)
	check("S");
#endif
#if defined(AT)
	check("T");
#endif
#if defined(BT)
	check("T");
#endif
#if defined(CT)
	check("T");
#endif
#if defined(DT)
	check("T");
#endif
#if defined(ET)
	check("T");
#endif
#if defined(FT)
	check("T");
#endif
#if defined(GT)
	check("T");
#endif
#if defined(HT)
	check("T");
#endif
#if defined(IT)
	check("T");
#endif
#if defined(JT)
	check("T");
#endif
#if defined(KT)
	check("T");
#endif
#if defined(LT)
	check("T");
#endif
#if defined(MT)
	check("T");
#endif
#if defined(NT)
	check("T");
#endif
#if defined(OT)
	check("T");
#endif
#if defined(PT)
	check("T");
#endif
#if defined(QT)
	check("T");
#endif
/*  we don't need to check RT, that token is important.  we won't see RT[ anyhow. 
#if defined(RT)
	check("T");
#endif
*/
/*  we don't need to check ST, that token is important.  we won't see ST[ anyhow. 
#if defined(ST)
	check("T");
#endif
*/
#if defined(TT)
	check("T");
#endif
#if defined(UT)
	check("T");
#endif
#if defined(VT)
	check("T");
#endif
#if defined(WT)
	check("T");
#endif
#if defined(XT)
	check("T");
#endif
#if defined(YT)
	check("T");
#endif
#if defined(ZT)
	check("T");
#endif
#if defined(AU)
	check("U");
#endif
#if defined(BU)
	check("U");
#endif
#if defined(CU)
	check("U");
#endif
#if defined(DU)
	check("U");
#endif
#if defined(EU)
	check("U");
#endif
#if defined(FU)
	check("U");
#endif
#if defined(GU)
	check("U");
#endif
#if defined(HU)
	check("U");
#endif
#if defined(IU)
	check("U");
#endif
#if defined(JU)
	check("U");
#endif
#if defined(KU)
	check("U");
#endif
#if defined(LU)
	check("U");
#endif
#if defined(MU)
	check("U");
#endif
#if defined(NU)
	check("U");
#endif
#if defined(OU)
	check("U");
#endif
#if defined(PU)
	check("U");
#endif
#if defined(QU)
	check("U");
#endif
#if defined(RU)
	check("U");
#endif
#if defined(SU)
	check("U");
#endif
#if defined(TU)
	check("U");
#endif
#if defined(UU)
	check("U");
#endif
#if defined(VU)
	check("U");
#endif
#if defined(WU)
	check("U");
#endif
#if defined(XU)
	check("U");
#endif
#if defined(YU)
	check("U");
#endif
#if defined(ZU)
	check("U");
#endif
#if defined(AV)
	check("V");
#endif
#if defined(BV)
	check("V");
#endif
#if defined(CV)
	check("V");
#endif
#if defined(DV)
	check("V");
#endif
#if defined(EV)
	check("V");
#endif
#if defined(FV)
	check("V");
#endif
#if defined(GV)
	check("V");
#endif
#if defined(HV)
	check("V");
#endif
#if defined(IV)
	check("V");
#endif
#if defined(JV)
	check("V");
#endif
#if defined(KV)
	check("V");
#endif
#if defined(LV)
	check("V");
#endif
#if defined(MV)
	check("V");
#endif
#if defined(NV)
	check("V");
#endif
#if defined(OV)
	check("V");
#endif
#if defined(PV)
	check("V");
#endif
#if defined(QV)
	check("V");
#endif
#if defined(RV)
	check("V");
#endif
#if defined(SV)
	check("V");
#endif
#if defined(TV)
	check("V");
#endif
#if defined(UV)
	check("V");
#endif
#if defined(VV)
	check("V");
#endif
#if defined(WV)
	check("V");
#endif
#if defined(XV)
	check("V");
#endif
#if defined(YV)
	check("V");
#endif
#if defined(ZV)
	check("V");
#endif
#if defined(AW)
	check("W");
#endif
#if defined(BW)
	check("W");
#endif
#if defined(CW)
	check("W");
#endif
#if defined(DW)
	check("W");
#endif
#if defined(EW)
	check("W");
#endif
#if defined(FW)
	check("W");
#endif
#if defined(GW)
	check("W");
#endif
#if defined(HW)
	check("W");
#endif
#if defined(IW)
	check("W");
#endif
#if defined(JW)
	check("W");
#endif
#if defined(KW)
	check("W");
#endif
#if defined(LW)
	check("W");
#endif
#if defined(MW)
	check("W");
#endif
#if defined(NW)
	check("W");
#endif
#if defined(OW)
	check("W");
#endif
#if defined(PW)
	check("W");
#endif
#if defined(QW)
	check("W");
#endif
#if defined(RW)
	check("W");
#endif
#if defined(SW)
	check("W");
#endif
#if defined(TW)
	check("W");
#endif
#if defined(UW)
	check("W");
#endif
#if defined(VW)
	check("W");
#endif
#if defined(WW)
	check("W");
#endif
#if defined(XW)
	check("W");
#endif
#if defined(YW)
	check("W");
#endif
#if defined(ZW)
	check("W");
#endif
#if defined(AX)
	check("X");
#endif
#if defined(BX)
	check("X");
#endif
#if defined(CX)
	check("X");
#endif
#if defined(DX)
	check("X");
#endif
#if defined(EX)
	check("X");
#endif
#if defined(FX)
	check("X");
#endif
#if defined(GX)
	check("X");
#endif
#if defined(HX)
	check("X");
#endif
#if defined(IX)
	check("X");
#endif
#if defined(JX)
	check("X");
#endif
#if defined(KX)
	check("X");
#endif
#if defined(LX)
	check("X");
#endif
#if defined(MX)
	check("X");
#endif
#if defined(NX)
	check("X");
#endif
#if defined(OX)
	check("X");
#endif
#if defined(PX)
	check("X");
#endif
#if defined(QX)
	check("X");
#endif
#if defined(RX)
	check("X");
#endif
#if defined(SX)
	check("X");
#endif
#if defined(TX)
	check("X");
#endif
#if defined(UX)
	check("X");
#endif
#if defined(VX)
	check("X");
#endif
#if defined(WX)
	check("X");
#endif
#if defined(XX)
	check("X");
#endif
#if defined(YX)
	check("X");
#endif
#if defined(ZX)
	check("X");
#endif
#if defined(AY)
	check("Y");
#endif
#if defined(BY)
	check("Y");
#endif
#if defined(CY)
	check("Y");
#endif
#if defined(DY)
	check("Y");
#endif
#if defined(EY)
	check("Y");
#endif
#if defined(FY)
	check("Y");
#endif
#if defined(GY)
	check("Y");
#endif
#if defined(HY)
	check("Y");
#endif
#if defined(IY)
	check("Y");
#endif
#if defined(JY)
	check("Y");
#endif
#if defined(KY)
	check("Y");
#endif
#if defined(LY)
	check("Y");
#endif
#if defined(MY)
	check("Y");
#endif
#if defined(NY)
	check("Y");
#endif
#if defined(OY)
	check("Y");
#endif
#if defined(PY)
	check("Y");
#endif
#if defined(QY)
	check("Y");
#endif
#if defined(RY)
	check("Y");
#endif
#if defined(SY)
	check("Y");
#endif
#if defined(TY)
	check("Y");
#endif
#if defined(UY)
	check("Y");
#endif
#if defined(VY)
	check("Y");
#endif
#if defined(WY)
	check("Y");
#endif
#if defined(XY)
	check("Y");
#endif
#if defined(YY)
	check("Y");
#endif
#if defined(ZY)
	check("Y");
#endif
#if defined(AZ)
	check("Z");
#endif
#if defined(BZ)
	check("Z");
#endif
#if defined(CZ)
	check("Z");
#endif
#if defined(DZ)
	check("Z");
#endif
#if defined(EZ)
	check("Z");
#endif
#if defined(FZ)
	check("Z");
#endif
#if defined(GZ)
	check("Z");
#endif
#if defined(HZ)
	check("Z");
#endif
#if defined(IZ)
	check("Z");
#endif
#if defined(JZ)
	check("Z");
#endif
#if defined(KZ)
	check("Z");
#endif
#if defined(LZ)
	check("Z");
#endif
#if defined(MZ)
	check("Z");
#endif
#if defined(NZ)
	check("Z");
#endif
#if defined(OZ)
	check("Z");
#endif
#if defined(PZ)
	check("Z");
#endif
#if defined(QZ)
	check("Z");
#endif
#if defined(RZ)
	check("Z");
#endif
#if defined(SZ)
	check("Z");
#endif
#if defined(TZ)
	check("Z");
#endif
#if defined(UZ)
	check("Z");
#endif
#if defined(VZ)
	check("Z");
#endif
#if defined(WZ)
	check("Z");
#endif
#if defined(XZ)
	check("Z");
#endif
#if defined(YZ)
	check("Z");
#endif
#if defined(ZZ)
	check("Z");
#endif
}
