
/************************************************************************/
/*                                                                      */
/* Copyright (c) 1987, 1988, 1989, 1990, 1991, 1992 -                   */
/*     The Rector and Visitors of the University of Virginia            */
/*                                                                      */
/* This code may not be distributed further without permission          */
/*      from the University of Virginia.                                */
/* This code is distributed WITHOUT ANY WARRANTY.  No claims are        */
/*      made as to whether it serves any particular purpose or even     */
/*      works at all.                                                   */
/*                                                                      */
/************************************************************************/

/************************************************************************
 
 Revision Control information

 $Source: /home/zephyr/zephyr-cvs/zephyr/backend/vpo/lib/scan.h,v $
 $Date: 1998/04/03 18:20:07 $
 $Revision: 1.2 $
 $Name:  $

 Log of changes:

 $Log: scan.h,v $
 Revision 1.2  1998/04/03 18:20:07  jwd
 First ANSI C version.


*************************************************************************/

/*
 * The following 26*26 definitions define all of the two letter codes that
 * are left undefined by the machine descriptions.  This will make it possible
 * for the scanner to accept all of the two upper-case letter tokens defined
 * by the machine description and return the appropriate token values for them
 * and to reject all others.
 */
#ifndef AA
#define AA 0
#endif
#ifndef AB
#define AB 0
#endif
#ifndef AC
#define AC 0
#endif
#ifndef AD
#define AD 0
#endif
#ifndef AE
#define AE 0
#endif
#ifndef AF
#define AF 0
#endif
#ifndef AG
#define AG 0
#endif
#ifndef AH
#define AH 0
#endif
#ifndef AI
#define AI 0
#endif
#ifndef AJ
#define AJ 0
#endif
#ifndef AK
#define AK 0
#endif
#ifndef AL
#define AL 0
#endif
#ifndef AM
#define AM 0
#endif
#ifndef AN
#define AN 0
#endif
#ifndef AO
#define AO 0
#endif
#ifndef AP
#define AP 0
#endif
#ifndef AQ
#define AQ 0
#endif
#ifndef AR
#define AR 0
#endif
#ifndef AS
#define AS 0
#endif
#ifndef AT
#define AT 0
#endif
#ifndef AU
#define AU 0
#endif
#ifndef AV
#define AV 0
#endif
#ifndef AW
#define AW 0
#endif
#ifndef AX
#define AX 0
#endif
#ifndef AY
#define AY 0
#endif
#ifndef AZ
#define AZ 0
#endif
#ifndef BA
#define BA 0
#endif
#ifndef BB
#define BB 0
#endif
#ifndef BC
#define BC 0
#endif
#ifndef BD
#define BD 0
#endif
#ifndef BE
#define BE 0
#endif
#ifndef BF
#define BF 0
#endif
#ifndef BG
#define BG 0
#endif
#ifndef BH
#define BH 0
#endif
#ifndef BI
#define BI 0
#endif
#ifndef BJ
#define BJ 0
#endif
#ifndef BK
#define BK 0
#endif
#ifndef BL
#define BL 0
#endif
#ifndef BM
#define BM 0
#endif
#ifndef BN
#define BN 0
#endif
#ifndef BO
#define BO 0
#endif
#ifndef BP
#define BP 0
#endif
#ifndef BQ
#define BQ 0
#endif
#ifndef BR
#define BR 0
#endif
#ifndef BS
#define BS 0
#endif
#ifndef BT
#define BT 0
#endif
#ifndef BU
#define BU 0
#endif
#ifndef BV
#define BV 0
#endif
#ifndef BW
#define BW 0
#endif
#ifndef BX
#define BX 0
#endif
#ifndef BY
#define BY 0
#endif
#ifndef BZ
#define BZ 0
#endif
#ifndef CA
#define CA 0
#endif
#ifndef CB
#define CB 0
#endif
#ifndef CC
#define CC 0
#endif
#ifndef CD
#define CD 0
#endif
#ifndef CE
#define CE 0
#endif
#ifndef CF
#define CF 0
#endif
#ifndef CG
#define CG 0
#endif
#ifndef CH
#define CH 0
#endif
#ifndef CI
#define CI 0
#endif
#ifndef CJ
#define CJ 0
#endif
#ifndef CK
#define CK 0
#endif
#ifndef CL
#define CL 0
#endif
#ifndef CM
#define CM 0
#endif
#ifndef CN
#define CN 0
#endif
#ifndef CO
#define CO 0
#endif
#ifndef CP
#define CP 0
#endif
#ifndef CQ
#define CQ 0
#endif
#ifndef CR
#define CR 0
#endif
#ifndef CS
#define CS 0
#endif
#ifndef CT
#define CT 0
#endif
#ifndef CU
#define CU 0
#endif
#ifndef CV
#define CV 0
#endif
#ifndef CW
#define CW 0
#endif
#ifndef CX
#define CX 0
#endif
#ifndef CY
#define CY 0
#endif
#ifndef CZ
#define CZ 0
#endif
#ifndef DA
#define DA 0
#endif
#ifndef DB
#define DB 0
#endif
#ifndef DC
#define DC 0
#endif
#ifndef DD
#define DD 0
#endif
#ifndef DE
#define DE 0
#endif
#ifndef DF
#define DF 0
#endif
#ifndef DG
#define DG 0
#endif
#ifndef DH
#define DH 0
#endif
#ifndef DI
#define DI 0
#endif
#ifndef DJ
#define DJ 0
#endif
#ifndef DK
#define DK 0
#endif
#ifndef DL
#define DL 0
#endif
#ifndef DM
#define DM 0
#endif
#ifndef DN
#define DN 0
#endif
#ifndef DO
#define DO 0
#endif
#ifndef DP
#define DP 0
#endif
#ifndef DQ
#define DQ 0
#endif
#ifndef DR
#define DR 0
#endif
#ifndef DS
#define DS 0
#endif
#ifndef DT
#define DT 0
#endif
#ifndef DU
#define DU 0
#endif
#ifndef DV
#define DV 0
#endif
#ifndef DW
#define DW 0
#endif
#ifndef DX
#define DX 0
#endif
#ifndef DY
#define DY 0
#endif
#ifndef DZ
#define DZ 0
#endif
#ifndef EA
#define EA 0
#endif
#ifndef EB
#define EB 0
#endif
#ifndef EC
#define EC 0
#endif
#ifndef ED
#define ED 0
#endif
#ifndef EE
#define EE 0
#endif
#ifndef EF
#define EF 0
#endif
#ifndef EG
#define EG 0
#endif
#ifndef EH
#define EH 0
#endif
#ifndef EI
#define EI 0
#endif
#ifndef EJ
#define EJ 0
#endif
#ifndef EK
#define EK 0
#endif
#ifndef EL
#define EL 0
#endif
#ifndef EM
#define EM 0
#endif
#ifndef EN
#define EN 0
#endif
#ifndef EO
#define EO 0
#endif
#ifndef EP
#define EP 0
#endif
#ifndef EQ
#define EQ 0
#endif
#ifndef ER
#define ER 0
#endif
#ifndef ES
#define ES 0
#endif
#ifndef ET
#define ET 0
#endif
#ifndef EU
#define EU 0
#endif
#ifndef EV
#define EV 0
#endif
#ifndef EW
#define EW 0
#endif
#ifndef EX
#define EX 0
#endif
#ifndef EY
#define EY 0
#endif
#ifndef EZ
#define EZ 0
#endif
#ifndef FA
#define FA 0
#endif
#ifndef FB
#define FB 0
#endif
#ifndef FC
#define FC 0
#endif
#ifndef FD
#define FD 0
#endif
#ifndef FE
#define FE 0
#endif
#ifndef FF
#define FF 0
#endif
#ifndef FG
#define FG 0
#endif
#ifndef FH
#define FH 0
#endif
#ifndef FI
#define FI 0
#endif
#ifndef FJ
#define FJ 0
#endif
#ifndef FK
#define FK 0
#endif
#ifndef FL
#define FL 0
#endif
#ifndef FM
#define FM 0
#endif
#ifndef FN
#define FN 0
#endif
#ifndef FO
#define FO 0
#endif
#ifndef FP
#define FP 0
#endif
#ifndef FQ
#define FQ 0
#endif
#ifndef FR
#define FR 0
#endif
#ifndef FS
#define FS 0
#endif
#ifndef FT
#define FT 0
#endif
#ifndef FU
#define FU 0
#endif
#ifndef FV
#define FV 0
#endif
#ifndef FW
#define FW 0
#endif
#ifndef FX
#define FX 0
#endif
#ifndef FY
#define FY 0
#endif
#ifndef FZ
#define FZ 0
#endif
#ifndef GA
#define GA 0
#endif
#ifndef GB
#define GB 0
#endif
#ifndef GC
#define GC 0
#endif
#ifndef GD
#define GD 0
#endif
#ifndef GE
#define GE 0
#endif
#ifndef GF
#define GF 0
#endif
#ifndef GG
#define GG 0
#endif
#ifndef GH
#define GH 0
#endif
#ifndef GI
#define GI 0
#endif
#ifndef GJ
#define GJ 0
#endif
#ifndef GK
#define GK 0
#endif
#ifndef GL
#define GL 0
#endif
#ifndef GM
#define GM 0
#endif
#ifndef GN
#define GN 0
#endif
#ifndef GO
#define GO 0
#endif
#ifndef GP
#define GP 0
#endif
#ifndef GQ
#define GQ 0
#endif
#ifndef GR
#define GR 0
#endif
#ifndef GS
#define GS 0
#endif
#ifndef GT
#define GT 0
#endif
#ifndef GU
#define GU 0
#endif
#ifndef GV
#define GV 0
#endif
#ifndef GW
#define GW 0
#endif
#ifndef GX
#define GX 0
#endif
#ifndef GY
#define GY 0
#endif
#ifndef GZ
#define GZ 0
#endif
#ifndef HA
#define HA 0
#endif
#ifndef HB
#define HB 0
#endif
#ifndef HC
#define HC 0
#endif
#ifndef HD
#define HD 0
#endif
#ifndef HE
#define HE 0
#endif
#ifndef HF
#define HF 0
#endif
#ifndef HG
#define HG 0
#endif
#ifndef HH
#define HH 0
#endif
#ifndef HI
#define HI 0
#endif
#ifndef HJ
#define HJ 0
#endif
#ifndef HK
#define HK 0
#endif
#ifndef HL
#define HL 0
#endif
#ifndef HM
#define HM 0
#endif
#ifndef HN
#define HN 0
#endif
#ifndef HO
#define HO 0
#endif
#ifndef HP
#define HP 0
#endif
#ifndef HQ
#define HQ 0
#endif
#ifndef HR
#define HR 0
#endif
#ifndef HS
#define HS 0
#endif
#ifndef HT
#define HT 0
#endif
#ifndef HU
#define HU 0
#endif
#ifndef HV
#define HV 0
#endif
#ifndef HW
#define HW 0
#endif
#ifndef HX
#define HX 0
#endif
#ifndef HY
#define HY 0
#endif
#ifndef HZ
#define HZ 0
#endif
#ifndef IA
#define IA 0
#endif
#ifndef IB
#define IB 0
#endif
#ifndef IC
#define IC 0
#endif
#ifndef ID
#define ID 0
#endif
#ifndef IE
#define IE 0
#endif
#ifndef IF
#define IF 0
#endif
#ifndef IG
#define IG 0
#endif
#ifndef IH
#define IH 0
#endif
#ifndef II
#define II 0
#endif
#ifndef IJ
#define IJ 0
#endif
#ifndef IK
#define IK 0
#endif
#ifndef IL
#define IL 0
#endif
#ifndef IM
#define IM 0
#endif
#ifndef IN
#define IN 0
#endif
#ifndef IO
#define IO 0
#endif
#ifndef IP
#define IP 0
#endif
#ifndef IQ
#define IQ 0
#endif
#ifndef IR
#define IR 0
#endif
#ifndef IS
#define IS 0
#endif
#ifndef IT
#define IT 0
#endif
#ifndef IU
#define IU 0
#endif
#ifndef IV
#define IV 0
#endif
#ifndef IW
#define IW 0
#endif
#ifndef IX
#define IX 0
#endif
#ifndef IY
#define IY 0
#endif
#ifndef IZ
#define IZ 0
#endif
#ifndef JA
#define JA 0
#endif
#ifndef JB
#define JB 0
#endif
#ifndef JC
#define JC 0
#endif
#ifndef JD
#define JD 0
#endif
#ifndef JE
#define JE 0
#endif
#ifndef JF
#define JF 0
#endif
#ifndef JG
#define JG 0
#endif
#ifndef JH
#define JH 0
#endif
#ifndef JI
#define JI 0
#endif
#ifndef JJ
#define JJ 0
#endif
#ifndef JK
#define JK 0
#endif
#ifndef JL
#define JL 0
#endif
#ifndef JM
#define JM 0
#endif
#ifndef JN
#define JN 0
#endif
#ifndef JO
#define JO 0
#endif
#ifndef JP
#define JP 0
#endif
#ifndef JQ
#define JQ 0
#endif
#ifndef JR
#define JR 0
#endif
#ifndef JS
#define JS 0
#endif
#ifndef JT
#define JT 0
#endif
#ifndef JU
#define JU 0
#endif
#ifndef JV
#define JV 0
#endif
#ifndef JW
#define JW 0
#endif
#ifndef JX
#define JX 0
#endif
#ifndef JY
#define JY 0
#endif
#ifndef JZ
#define JZ 0
#endif
#ifndef KA
#define KA 0
#endif
#ifndef KB
#define KB 0
#endif
#ifndef KC
#define KC 0
#endif
#ifndef KD
#define KD 0
#endif
#ifndef KE
#define KE 0
#endif
#ifndef KF
#define KF 0
#endif
#ifndef KG
#define KG 0
#endif
#ifndef KH
#define KH 0
#endif
#ifndef KI
#define KI 0
#endif
#ifndef KJ
#define KJ 0
#endif
#ifndef KK
#define KK 0
#endif
#ifndef KL
#define KL 0
#endif
#ifndef KM
#define KM 0
#endif
#ifndef KN
#define KN 0
#endif
#ifndef KO
#define KO 0
#endif
#ifndef KP
#define KP 0
#endif
#ifndef KQ
#define KQ 0
#endif
#ifndef KR
#define KR 0
#endif
#ifndef KS
#define KS 0
#endif
#ifndef KT
#define KT 0
#endif
#ifndef KU
#define KU 0
#endif
#ifndef KV
#define KV 0
#endif
#ifndef KW
#define KW 0
#endif
#ifndef KX
#define KX 0
#endif
#ifndef KY
#define KY 0
#endif
#ifndef KZ
#define KZ 0
#endif
#ifndef LA
#define LA 0
#endif
#ifndef LB
#define LB 0
#endif
#ifndef LC
#define LC 0
#endif
#ifndef LD
#define LD 0
#endif
#ifndef LE
#define LE 0
#endif
#ifndef LF
#define LF 0
#endif
#ifndef LG
#define LG 0
#endif
#ifndef LH
#define LH 0
#endif
#ifndef LI
#define LI 0
#endif
#ifndef LJ
#define LJ 0
#endif
#ifndef LK
#define LK 0
#endif
#ifndef LL
#define LL 0
#endif
#ifndef LM
#define LM 0
#endif
#ifndef LN
#define LN 0
#endif
#ifndef LO
#define LO 0
#endif
#ifndef LP
#define LP 0
#endif
#ifndef LQ
#define LQ 0
#endif
#ifndef LR
#define LR 0
#endif
#ifndef LS
#define LS 0
#endif
#ifndef LT
#define LT 0
#endif
#ifndef LU
#define LU 0
#endif
#ifndef LV
#define LV 0
#endif
#ifndef LW
#define LW 0
#endif
#ifndef LX
#define LX 0
#endif
#ifndef LY
#define LY 0
#endif
#ifndef LZ
#define LZ 0
#endif
#ifndef MA
#define MA 0
#endif
#ifndef MB
#define MB 0
#endif
#ifndef MC
#define MC 0
#endif
#ifndef MD
#define MD 0
#endif
#ifndef ME
#define ME 0
#endif
#ifndef MF
#define MF 0
#endif
#ifndef MG
#define MG 0
#endif
#ifndef MH
#define MH 0
#endif
#ifndef MI
#define MI 0
#endif
#ifndef MJ
#define MJ 0
#endif
#ifndef MK
#define MK 0
#endif
#ifndef ML
#define ML 0
#endif
#ifndef MM
#define MM 0
#endif
#ifndef MN
#define MN 0
#endif
#ifndef MO
#define MO 0
#endif
#ifndef MP
#define MP 0
#endif
#ifndef MQ
#define MQ 0
#endif
#ifndef MR
#define MR 0
#endif
#ifndef MS
#define MS 0
#endif
#ifndef MT
#define MT 0
#endif
#ifndef MU
#define MU 0
#endif
#ifndef MV
#define MV 0
#endif
#ifndef MW
#define MW 0
#endif
#ifndef MX
#define MX 0
#endif
#ifndef MY
#define MY 0
#endif
#ifndef MZ
#define MZ 0
#endif
#ifndef NA
#define NA 0
#endif
#ifndef NB
#define NB 0
#endif
#ifndef NC
#define NC 0
#endif
#ifndef ND
#define ND 0
#endif
#ifndef NE
#define NE 0
#endif
#ifndef NF
#define NF 0
#endif
#ifndef NG
#define NG 0
#endif
#ifndef NH
#define NH 0
#endif
#ifndef NI
#define NI 0
#endif
#ifndef NJ
#define NJ 0
#endif
#ifndef NK
#define NK 0
#endif
#ifndef NL
#define NL 0
#endif
#ifndef NM
#define NM 0
#endif
#ifndef NN
#define NN 0
#endif
#ifndef NO
#define NO 0
#endif
#ifndef NP
#define NP 0
#endif
#ifndef NQ
#define NQ 0
#endif
#ifndef NR
#define NR 0
#endif
#ifndef NS
#define NS 0
#endif
#ifndef NT
#define NT 0
#endif
#ifndef NU
#define NU 0
#endif
#ifndef NV
#define NV 0
#endif
#ifndef NW
#define NW 0
#endif
#ifndef NX
#define NX 0
#endif
#ifndef NY
#define NY 0
#endif
#ifndef NZ
#define NZ 0
#endif
#ifndef OA
#define OA 0
#endif
#ifndef OB
#define OB 0
#endif
#ifndef OC
#define OC 0
#endif
#ifndef OD
#define OD 0
#endif
#ifndef OE
#define OE 0
#endif
#ifndef OF
#define OF 0
#endif
#ifndef OG
#define OG 0
#endif
#ifndef OH
#define OH 0
#endif
#ifndef OI
#define OI 0
#endif
#ifndef OJ
#define OJ 0
#endif
#ifndef OK
#define OK 0
#endif
#ifndef OL
#define OL 0
#endif
#ifndef OM
#define OM 0
#endif
#ifndef ON
#define ON 0
#endif
#ifndef OO
#define OO 0
#endif
#ifndef OP
#define OP 0
#endif
#ifndef OQ
#define OQ 0
#endif
#ifndef OR
#define OR 0
#endif
#ifndef OS
#define OS 0
#endif
#ifndef OT
#define OT 0
#endif
#ifndef OU
#define OU 0
#endif
#ifndef OV
#define OV 0
#endif
#ifndef OW
#define OW 0
#endif
#ifndef OX
#define OX 0
#endif
#ifndef OY
#define OY 0
#endif
#ifndef OZ
#define OZ 0
#endif
#ifndef PA
#define PA 0
#endif
#ifndef PB
#define PB 0
#endif
#ifndef PC
#define PC 0
#endif
#ifndef PD
#define PD 0
#endif
#ifndef PE
#define PE 0
#endif
#ifndef PF
#define PF 0
#endif
#ifndef PG
#define PG 0
#endif
#ifndef PH
#define PH 0
#endif
#ifndef PI
#define PI 0
#endif
#ifndef PJ
#define PJ 0
#endif
#ifndef PK
#define PK 0
#endif
#ifndef PL
#define PL 0
#endif
#ifndef PM
#define PM 0
#endif
#ifndef PN
#define PN 0
#endif
#ifndef PO
#define PO 0
#endif
#ifndef PP
#define PP 0
#endif
#ifndef PQ
#define PQ 0
#endif
#ifndef PR
#define PR 0
#endif
#ifndef PS
#define PS 0
#endif
#ifndef PT
#define PT 0
#endif
#ifndef PU
#define PU 0
#endif
#ifndef PV
#define PV 0
#endif
#ifndef PW
#define PW 0
#endif
#ifndef PX
#define PX 0
#endif
#ifndef PY
#define PY 0
#endif
#ifndef PZ
#define PZ 0
#endif
#ifndef QA
#define QA 0
#endif
#ifndef QB
#define QB 0
#endif
#ifndef QC
#define QC 0
#endif
#ifndef QD
#define QD 0
#endif
#ifndef QE
#define QE 0
#endif
#ifndef QF
#define QF 0
#endif
#ifndef QG
#define QG 0
#endif
#ifndef QH
#define QH 0
#endif
#ifndef QI
#define QI 0
#endif
#ifndef QJ
#define QJ 0
#endif
#ifndef QK
#define QK 0
#endif
#ifndef QL
#define QL 0
#endif
#ifndef QM
#define QM 0
#endif
#ifndef QN
#define QN 0
#endif
#ifndef QO
#define QO 0
#endif
#ifndef QP
#define QP 0
#endif
#ifndef QQ
#define QQ 0
#endif
#ifndef QR
#define QR 0
#endif
#ifndef QS
#define QS 0
#endif
#ifndef QT
#define QT 0
#endif
#ifndef QU
#define QU 0
#endif
#ifndef QV
#define QV 0
#endif
#ifndef QW
#define QW 0
#endif
#ifndef QX
#define QX 0
#endif
#ifndef QY
#define QY 0
#endif
#ifndef QZ
#define QZ 0
#endif
#ifndef RA
#define RA 0
#endif
#ifndef RB
#define RB 0
#endif
#ifndef RC
#define RC 0
#endif
#ifndef RD
#define RD 0
#endif
#ifndef RE
#define RE 0
#endif
#ifndef RF
#define RF 0
#endif
#ifndef RG
#define RG 0
#endif
#ifndef RH
#define RH 0
#endif
#ifndef RI
#define RI 0
#endif
#ifndef RJ
#define RJ 0
#endif
#ifndef RK
#define RK 0
#endif
#ifndef RL
#define RL 0
#endif
#ifndef RM
#define RM 0
#endif
#ifndef RN
#define RN 0
#endif
#ifndef RO
#define RO 0
#endif
#ifndef RP
#define RP 0
#endif
#ifndef RQ
#define RQ 0
#endif
#ifndef RR
#define RR 0
#endif
#ifndef RS
#define RS 0
#endif
#ifndef RT
#define RT 0
#endif
#ifndef RU
#define RU 0
#endif
#ifndef RV
#define RV 0
#endif
#ifndef RW
#define RW 0
#endif
#ifndef RX
#define RX 0
#endif
#ifndef RY
#define RY 0
#endif
#ifndef RZ
#define RZ 0
#endif
#ifndef SA
#define SA 0
#endif
#ifndef SB
#define SB 0
#endif
#ifndef SC
#define SC 0
#endif
#ifndef SD
#define SD 0
#endif
#ifndef SE
#define SE 0
#endif
#ifndef SF
#define SF 0
#endif
#ifndef SG
#define SG 0
#endif
#ifndef SH
#define SH 0
#endif
#ifndef SI
#define SI 0
#endif
#ifndef SJ
#define SJ 0
#endif
#ifndef SK
#define SK 0
#endif
#ifndef SL
#define SL 0
#endif
#ifndef SM
#define SM 0
#endif
#ifndef SN
#define SN 0
#endif
#ifndef SO
#define SO 0
#endif
#ifndef SP
#define SP 0
#endif
#ifndef SQ
#define SQ 0
#endif
#ifndef SR
#define SR 0
#endif
#ifndef SS
#define SS 0
#endif
#ifndef ST
#define ST 0
#endif
#ifndef SU
#define SU 0
#endif
#ifndef SV
#define SV 0
#endif
#ifndef SW
#define SW 0
#endif
#ifndef SX
#define SX 0
#endif
#ifndef SY
#define SY 0
#endif
#ifndef SZ
#define SZ 0
#endif
#ifndef TA
#define TA 0
#endif
#ifndef TB
#define TB 0
#endif
#ifndef TC
#define TC 0
#endif
#ifndef TD
#define TD 0
#endif
#ifndef TE
#define TE 0
#endif
#ifndef TF
#define TF 0
#endif
#ifndef TG
#define TG 0
#endif
#ifndef TH
#define TH 0
#endif
#ifndef TI
#define TI 0
#endif
#ifndef TJ
#define TJ 0
#endif
#ifndef TK
#define TK 0
#endif
#ifndef TL
#define TL 0
#endif
#ifndef TM
#define TM 0
#endif
#ifndef TN
#define TN 0
#endif
#ifndef TO
#define TO 0
#endif
#ifndef TP
#define TP 0
#endif
#ifndef TQ
#define TQ 0
#endif
#ifndef TR
#define TR 0
#endif
#ifndef TS
#define TS 0
#endif
#ifndef TT
#define TT 0
#endif
#ifndef TU
#define TU 0
#endif
#ifndef TV
#define TV 0
#endif
#ifndef TW
#define TW 0
#endif
#ifndef TX
#define TX 0
#endif
#ifndef TY
#define TY 0
#endif
#ifndef TZ
#define TZ 0
#endif
#ifndef UA
#define UA 0
#endif
#ifndef UB
#define UB 0
#endif
#ifndef UC
#define UC 0
#endif
#ifndef UD
#define UD 0
#endif
#ifndef UE
#define UE 0
#endif
#ifndef UF
#define UF 0
#endif
#ifndef UG
#define UG 0
#endif
#ifndef UH
#define UH 0
#endif
#ifndef UI
#define UI 0
#endif
#ifndef UJ
#define UJ 0
#endif
#ifndef UK
#define UK 0
#endif
#ifndef UL
#define UL 0
#endif
#ifndef UM
#define UM 0
#endif
#ifndef UN
#define UN 0
#endif
#ifndef UO
#define UO 0
#endif
#ifndef UP
#define UP 0
#endif
#ifndef UQ
#define UQ 0
#endif
#ifndef UR
#define UR 0
#endif
#ifndef US
#define US 0
#endif
#ifndef UT
#define UT 0
#endif
#ifndef UU
#define UU 0
#endif
#ifndef UV
#define UV 0
#endif
#ifndef UW
#define UW 0
#endif
#ifndef UX
#define UX 0
#endif
#ifndef UY
#define UY 0
#endif
#ifndef UZ
#define UZ 0
#endif
#ifndef VA
#define VA 0
#endif
#ifndef VB
#define VB 0
#endif
#ifndef VC
#define VC 0
#endif
#ifndef VD
#define VD 0
#endif
#ifndef VE
#define VE 0
#endif
#ifndef VF
#define VF 0
#endif
#ifndef VG
#define VG 0
#endif
#ifndef VH
#define VH 0
#endif
#ifndef VI
#define VI 0
#endif
#ifndef VJ
#define VJ 0
#endif
#ifndef VK
#define VK 0
#endif
#ifndef VL
#define VL 0
#endif
#ifndef VM
#define VM 0
#endif
#ifndef VN
#define VN 0
#endif
#ifndef VO
#define VO 0
#endif
#ifndef VP
#define VP 0
#endif
#ifndef VQ
#define VQ 0
#endif
#ifndef VR
#define VR 0
#endif
#ifndef VS
#define VS 0
#endif
#ifndef VT
#define VT 0
#endif
#ifndef VU
#define VU 0
#endif
#ifndef VV
#define VV 0
#endif
#ifndef VW
#define VW 0
#endif
#ifndef VX
#define VX 0
#endif
#ifndef VY
#define VY 0
#endif
#ifndef VZ
#define VZ 0
#endif
#ifndef WA
#define WA 0
#endif
#ifndef WB
#define WB 0
#endif
#ifndef WC
#define WC 0
#endif
#ifndef WD
#define WD 0
#endif
#ifndef WE
#define WE 0
#endif
#ifndef WF
#define WF 0
#endif
#ifndef WG
#define WG 0
#endif
#ifndef WH
#define WH 0
#endif
#ifndef WI
#define WI 0
#endif
#ifndef WJ
#define WJ 0
#endif
#ifndef WK
#define WK 0
#endif
#ifndef WL
#define WL 0
#endif
#ifndef WM
#define WM 0
#endif
#ifndef WN
#define WN 0
#endif
#ifndef WO
#define WO 0
#endif
#ifndef WP
#define WP 0
#endif
#ifndef WQ
#define WQ 0
#endif
#ifndef WR
#define WR 0
#endif
#ifndef WS
#define WS 0
#endif
#ifndef WT
#define WT 0
#endif
#ifndef WU
#define WU 0
#endif
#ifndef WV
#define WV 0
#endif
#ifndef WW
#define WW 0
#endif
#ifndef WX
#define WX 0
#endif
#ifndef WY
#define WY 0
#endif
#ifndef WZ
#define WZ 0
#endif
#ifndef XA
#define XA 0
#endif
#ifndef XB
#define XB 0
#endif
#ifndef XC
#define XC 0
#endif
#ifndef XD
#define XD 0
#endif
#ifndef XE
#define XE 0
#endif
#ifndef XF
#define XF 0
#endif
#ifndef XG
#define XG 0
#endif
#ifndef XH
#define XH 0
#endif
#ifndef XI
#define XI 0
#endif
#ifndef XJ
#define XJ 0
#endif
#ifndef XK
#define XK 0
#endif
#ifndef XL
#define XL 0
#endif
#ifndef XM
#define XM 0
#endif
#ifndef XN
#define XN 0
#endif
#ifndef XO
#define XO 0
#endif
#ifndef XP
#define XP 0
#endif
#ifndef XQ
#define XQ 0
#endif
#ifndef XR
#define XR 0
#endif
#ifndef XS
#define XS 0
#endif
#ifndef XT
#define XT 0
#endif
#ifndef XU
#define XU 0
#endif
#ifndef XV
#define XV 0
#endif
#ifndef XW
#define XW 0
#endif
#ifndef XX
#define XX 0
#endif
#ifndef XY
#define XY 0
#endif
#ifndef XZ
#define XZ 0
#endif
#ifndef YA
#define YA 0
#endif
#ifndef YB
#define YB 0
#endif
#ifndef YC
#define YC 0
#endif
#ifndef YD
#define YD 0
#endif
#ifndef YE
#define YE 0
#endif
#ifndef YF
#define YF 0
#endif
#ifndef YG
#define YG 0
#endif
#ifndef YH
#define YH 0
#endif
#ifndef YI
#define YI 0
#endif
#ifndef YJ
#define YJ 0
#endif
#ifndef YK
#define YK 0
#endif
#ifndef YL
#define YL 0
#endif
#ifndef YM
#define YM 0
#endif
#ifndef YN
#define YN 0
#endif
#ifndef YO
#define YO 0
#endif
#ifndef YP
#define YP 0
#endif
#ifndef YQ
#define YQ 0
#endif
#ifndef YR
#define YR 0
#endif
#ifndef YS
#define YS 0
#endif
#ifndef YT
#define YT 0
#endif
#ifndef YU
#define YU 0
#endif
#ifndef YV
#define YV 0
#endif
#ifndef YW
#define YW 0
#endif
#ifndef YX
#define YX 0
#endif
#ifndef YY
#define YY 0
#endif
#ifndef YZ
#define YZ 0
#endif
#ifndef ZA
#define ZA 0
#endif
#ifndef ZB
#define ZB 0
#endif
#ifndef ZC
#define ZC 0
#endif
#ifndef ZD
#define ZD 0
#endif
#ifndef ZE
#define ZE 0
#endif
#ifndef ZF
#define ZF 0
#endif
#ifndef ZG
#define ZG 0
#endif
#ifndef ZH
#define ZH 0
#endif
#ifndef ZI
#define ZI 0
#endif
#ifndef ZJ
#define ZJ 0
#endif
#ifndef ZK
#define ZK 0
#endif
#ifndef ZL
#define ZL 0
#endif
#ifndef ZM
#define ZM 0
#endif
#ifndef ZN
#define ZN 0
#endif
#ifndef ZO
#define ZO 0
#endif
#ifndef ZP
#define ZP 0
#endif
#ifndef ZQ
#define ZQ 0
#endif
#ifndef ZR
#define ZR 0
#endif
#ifndef ZS
#define ZS 0
#endif
#ifndef ZT
#define ZT 0
#endif
#ifndef ZU
#define ZU 0
#endif
#ifndef ZV
#define ZV 0
#endif
#ifndef ZW
#define ZW 0
#endif
#ifndef ZX
#define ZX 0
#endif
#ifndef ZY
#define ZY 0
#endif
#ifndef ZZ
#define ZZ 0
#endif

/*
 * Now define any of the tokens used to declare valid memory reference
 * types.  Since the '[' character conveniently follows the 'Z' (in the
 * ASCII character set, of course), we can encode these items in the same
 * lookup table as the two upper-case character tokens.
 */
#ifndef AMEM
#define AMEM 0
#endif
#ifndef BMEM
#define BMEM 0
#endif
#ifndef CMEM
#define CMEM 0
#endif
#ifndef DMEM
#define DMEM 0
#endif
#ifndef EMEM
#define EMEM 0
#endif
#ifndef FMEM
#define FMEM 0
#endif
#ifndef GMEM
#define GMEM 0
#endif
#ifndef HMEM
#define HMEM 0
#endif
#ifndef IMEM
#define IMEM 0
#endif
#ifndef JMEM
#define JMEM 0
#endif
#ifndef KMEM
#define KMEM 0
#endif
#ifndef LMEM
#define LMEM 0
#endif
#ifndef MMEM
#define MMEM 0
#endif
#ifndef NMEM
#define NMEM 0
#endif
#ifndef OMEM
#define OMEM 0
#endif
#ifndef PMEM
#define PMEM 0
#endif
#ifndef QMEM
#define QMEM 0
#endif
#ifndef RMEM
#define RMEM 0
#endif
#ifndef SMEM
#define SMEM 0
#endif
#ifndef TMEM
#define TMEM 0
#endif
#ifndef UMEM
#define UMEM 0
#endif
#ifndef VMEM
#define VMEM 0
#endif
#ifndef WMEM
#define WMEM 0
#endif
#ifndef XMEM
#define XMEM 0
#endif
#ifndef YMEM
#define YMEM 0
#endif
#ifndef ZMEM
#define ZMEM 0
#endif

/*
 * The following array allows two upper-case letter tokens to be looked up
 * for either a 0 (if not defined by the machine description) or the correct
 * token value to return for that sequence.  Note that the indexing system
 * is 27 * 32 rather than just the 27 * 28 that is really required.  The 32
 * is used because it permits a single shift to be used in place of a multiply
 * when performing a lookup operation on the array.
 */
int lu[864] = {  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
                 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
                 0, AA, AB, AC, AD, AE, AF, AG, AH, AI, AJ, AK, AL, AM, AN, AO,
                AP, AQ, AR, AS, AT, AU, AV, AW, AX, AY, AZ, AMEM,0,  0,  0,  0,
                 0, BA, BB, BC, BD, BE, BF, BG, BH, BI, BJ, BK, BL, BM, BN, BO,
                BP, BQ, BR, BS, BT, BU, BV, BW, BX, BY, BZ, BMEM,0,  0,  0,  0,
                 0, CA, CB, CC, CD, CE, CF, CG, CH, CI, CJ, CK, CL, CM, CN, CO,
                CP, CQ, CR, CS, CT, CU, CV, CW, CX, CY, CZ, CMEM,0,  0,  0,  0,
                 0, DA, DB, DC, DD, DE, DF, DG, DH, DI, DJ, DK, DL, DM, DN, DO,
                DP, DQ, DR, DS, DT, DU, DV, DW, DX, DY, DZ, DMEM,0,  0,  0,  0,
                 0, EA, EB, EC, ED, EE, EF, EG, EH, EI, EJ, EK, EL, EM, EN, EO,
                EP, EQ, ER, ES, ET, EU, EV, EW, EX, EY, EZ, EMEM,0,  0,  0,  0,
                 0, FA, FB, FC, FD, FE, FF, FG, FH, FI, FJ, FK, FL, FM, FN, FO,
                FP, FQ, FR, FS, FT, FU, FV, FW, FX, FY, FZ, FMEM,0,  0,  0,  0,
                 0, GA, GB, GC, GD, GE, GF, GG, GH, GI, GJ, GK, GL, GM, GN, GO,
                GP, GQ, GR, GS, GT, GU, GV, GW, GX, GY, GZ, GMEM,0,  0,  0,  0,
                 0, HA, HB, HC, HD, HE, HF, HG, HH, HI, HJ, HK, HL, HM, HN, HO,
                HP, HQ, HR, HS, HT, HU, HV, HW, HX, HY, HZ, HMEM,0,  0,  0,  0,
                 0, IA, IB, IC, ID, IE, IF, IG, IH, II, IJ, IK, IL, IM, IN, IO,
                IP, IQ, IR, IS, IT, IU, IV, IW, IX, IY, IZ, IMEM,0,  0,  0,  0,
                 0, JA, JB, JC, JD, JE, JF, JG, JH, JI, JJ, JK, JL, JM, JN, JO,
                JP, JQ, JR, JS, JT, JU, JV, JW, JX, JY, JZ, JMEM,0,  0,  0,  0,
                 0, KA, KB, KC, KD, KE, KF, KG, KH, KI, KJ, KK, KL, KM, KN, KO,
                KP, KQ, KR, KS, KT, KU, KV, KW, KX, KY, KZ, KMEM,0,  0,  0,  0,
                 0, LA, LB, LC, LD, LE, LF, LG, LH, LI, LJ, LK, LL, LM, LN, LO,
                LP, LQ, LR, LS, LT, LU, LV, LW, LX, LY, LZ, LMEM,0,  0,  0,  0,
                 0, MA, MB, MC, MD, ME, MF, MG, MH, MI, MJ, MK, ML, MM, MN, MO,
                MP, MQ, MR, MS, MT, MU, MV, MW, MX, MY, MZ, MMEM,0,  0,  0,  0,
                 0, NA, NB, NC, ND, NE, NF, NG, NH, NI, NJ, NK, NL, NM, NN, NO,
                NP, NQ, NR, NS, NT, NU, NV, NW, NX, NY, NZ, NMEM,0,  0,  0,  0,
                 0, OA, OB, OC, OD, OE, OF, OG, OH, OI, OJ, OK, OL, OM, ON, OO,
                OP, OQ, OR, OS, OT, OU, OV, OW, OX, OY, OZ, OMEM,0,  0,  0,  0,
                 0, PA, PB, PC, PD, PE, PF, PG, PH, PI, PJ, PK, PL, PM, PN, PO,
                PP, PQ, PR, PS, PT, PU, PV, PW, PX, PY, PZ, PMEM,0,  0,  0,  0,
                 0, QA, QB, QC, QD, QE, QF, QG, QH, QI, QJ, QK, QL, QM, QN, QO,
                QP, QQ, QR, QS, QT, QU, QV, QW, QX, QY, QZ, QMEM,0,  0,  0,  0,
                 0, RA, RB, RC, RD, RE, RF, RG, RH, RI, RJ, RK, RL, RM, RN, RO,
                RP, RQ, RR, RS, RT, RU, RV, RW, RX, RY, RZ, RMEM,0,  0,  0,  0,
                 0, SA, SB, SC, SD, SE, SF, SG, SH, SI, SJ, SK, SL, SM, SN, SO,
                SP, SQ, SR, SS, ST, SU, SV, SW, SX, SY, SZ, SMEM,0,  0,  0,  0,
                 0, TA, TB, TC, TD, TE, TF, TG, TH, TI, TJ, TK, TL, TM, TN, TO,
                TP, TQ, TR, TS, TT, TU, TV, TW, TX, TY, TZ, TMEM,0,  0,  0,  0,
                 0, UA, UB, UC, UD, UE, UF, UG, UH, UI, UJ, UK, UL, UM, UN, UO,
                UP, UQ, UR, US, UT, UU, UV, UW, UX, UY, UZ, UMEM,0,  0,  0,  0,
                 0, VA, VB, VC, VD, VE, VF, VG, VH, VI, VJ, VK, VL, VM, VN, VO,
                VP, VQ, VR, VS, VT, VU, VV, VW, VX, VY, VZ, VMEM,0,  0,  0,  0,
                 0, WA, WB, WC, WD, WE, WF, WG, WH, WI, WJ, WK, WL, WM, WN, WO,
                WP, WQ, WR, WS, WT, WU, WV, WW, WX, WY, WZ, WMEM,0,  0,  0,  0,
                 0, XA, XB, XC, XD, XE, XF, XG, XH, XI, XJ, XK, XL, XM, XN, XO,
                XP, XQ, XR, XS, XT, XU, XV, XW, XX, XY, XZ, XMEM,0,  0,  0,  0,
                 0, YA, YB, YC, YD, YE, YF, YG, YH, YI, YJ, YK, YL, YM, YN, YO,
                YP, YQ, YR, YS, YT, YU, YV, YW, YX, YY, YZ, YMEM,0,  0,  0,  0,
                 0, ZA, ZB, ZC, ZD, ZE, ZF, ZG, ZH, ZI, ZJ, ZK, ZL, ZM, ZN, ZO,
                ZP, ZQ, ZR, ZS, ZT, ZU, ZV, ZW, ZX, ZY, ZZ, ZMEM,0,  0,  0,  0};
