#ifdef INTERACT
/*
 * sockets.h	Supporting routines for socket communications
 *
 *              Created by Dr. Xin Yuan for project I in the
 *              Computer Networks class (cis49306).
 *              Modify on your own risk. 
 */

#include <sys/types.h>

int     open_bound_tcp_socket     (int *port);

int     tcp_write                 (int sock,
				   char * msgp,
				   unsigned msgsize);
int     tcp_read                  (int sock,
				   char * msgp,
				   unsigned msgsize);

#define Tcp_write(s, msgp)	tcp_write(s, (char *) msgp, sizeof(*msgp))
#define Tcp_read(s, msgp)	tcp_read(s, (char *) msgp, sizeof(*msgp))

int     tcp_connect               (char *host, int port);

void    init_tcp_accept           (int acc_port, fd_set *dset);



#endif
