#include <stdio.h>
#include <stdarg.h>


#include "misc.h"

void _fatal(char *file, char *func, int line, char* fmt, ...)
{
	va_list args;
	va_start(args,fmt);
	vfprintf(stderr, fmt, args);
	fprintf(stderr, "\nFatal error in %s:%s(), line %d\n", file, func, line);
	exit(-1);
		
}
