
/************************************************************************/
/*                                                                      */
/* Copyright (c) 1990, 1991, 1992 -                                     */
/*     The Rector and Visitors of the University of Virginia            */
/*                                                                      */
/* This code may not be distributed further without permission          */
/*      from the University of Virginia.                                */
/* This code is distributed WITHOUT ANY WARRANTY.  No claims are        */
/*      made as to whether it serves any particular purpose or even     */
/*      works at all.                                                   */
/*                                                                      */
/************************************************************************/

/************************************************************************
 
 Revision Control information

 $Source: /home/zephyr/zephyr-cvs/zephyr/backend/vpo/tools/regtool/semact.h,v $
 $Date: 2000/08/22 21:10:33 $
 $Revision: 1.1.1.1 $
 $Name:  $

 Log of changes:

 $Log: semact.h,v $
 Revision 1.1.1.1  2000/08/22 21:10:33  zephyr
 Created directory structure

 Revision 1.2  2000/07/18 18:40:02  jdh8d
 changes to get mips to compile/run under new system

 Revision 1.1  1998/04/08 18:08:39  jwd
 Initial revision

*************************************************************************/

#ifndef SEMACT_H
#define SEMACT_H

void deftype(char *);
void defmem(char *);
void defcode(char *);
void defclass(char *);
void number(int);
void scratch(struct vector *);
void reserve(struct vector *);
void order(struct vector *);
void fifo(void);
void stack(void);
void addtype(char *);
void endtype(void);
void alignment(struct align_expr *);
void size(int);
void limit(int, int);
void group(char *);
void invariant(struct vector *);
void localtype(char *);
void noalloc(void);
void compatible(char *, char *);
void memchar(char);
void regchar(char);
void newlist(void);
void con(int);
void range(int, int);
struct vector *list(void);
struct align_expr *expr(int, int);
char regprt[17];
char memprt[17];
char codes[193];
int code_num;
int tnum;
struct vector *clist;
struct classinfo *current;
struct classinfo *classes;
struct typeinfo *ctypes;
struct typeinfo *types;

#endif
