/******************************************************************************
 *
 * Copyright (c) 1993 by Mark Bailey.
 *
 * This code is distributed WITHOUT ANY WARRANTY. No claims are made as to
 * whether it serves any particular purpose or even works at all.
 *
 *****************************************************************************/

/******************************************************************************
 *
 * File: gencode.h
 *
 * Author: Mark Bailey
 *
 * Created: 12/21/93
 *
 * Description:
 *
 *      Header file for gencode.c.
 *
 * RCS Header:
 * 	$Header: /home/zephyr/zephyr-cvs/zephyr/backend/vpo/tools/rtlprep/gencode.h,v 1.1.1.1 2000/08/22 21:10:33 zephyr Exp $
 *
 * Change Log:
 *	$Log: gencode.h,v $
 *	Revision 1.1.1.1  2000/08/22 21:10:33  zephyr
 *	Created directory structure
 *	
 *	Revision 1.2  2000/06/10 18:16:19  jwd
 *	Added a prototype for function error_and_exit.
 *	
 *	Revision 1.1  1998/01/29 20:54:04  jch8f
 *	Initial revision
 *	Revision 1.3  1995/08/26 14:13:19  mwb5y
 *	Delete function VPO_CGEN_Generate
 *
 *	Revision 1.2  1995/08/21 15:48:20  mwb5y
 *	Updated to work with vpo and code expander.
 *
 * Revision 1.1  1994/01/13  16:40:40  mwb5y
 * Initial revision
 *
 *
 *****************************************************************************/


#ifndef __GENCODE_H__
#define __GENCODE_H__

#include "expr.h"

void GenerateTree(Expr *expr);
void VPO_Generate(Expr *expr, char *strname);
void NTRO_Generate(Expr *expr);
void error_and_exit(char *s);
#ifndef __GENCODE_C__
extern int ConstSp;
extern char *ConstStack[];
#endif

#endif /* __GENCODE_H__ */
