#ifndef __VET_CALLBACKS_H__
#define __VET_CALLBACKS_H__
#include <Xm/Xm.h>
#include <Xm/ToggleB.h>

void next_func_pressed(Widget, XtPointer, XtPointer);
void next_phase_pressed(Widget, XtPointer, XtPointer);
void prev_phase_pressed(Widget, XtPointer, XtPointer);
void next_trans_pressed(Widget, XtPointer, XtPointer);
void apply_trans_pressed(Widget, XtPointer, XtPointer);
void prev_trans_pressed(Widget, XtPointer, XtPointer);
void undo_trans_pressed(Widget, XtPointer, XtPointer);
void sanity_pressed(Widget, XtPointer, XtPointer);
void asm_pressed(Widget, XtPointer, XtPointer);
void trash_pressed(Widget, XtPointer, XtPointer);
void use_pressed(Widget, XtPointer, XtPointer);
void reserve_pressed(Widget, XtPointer, XtPointer);
void comment_pressed(Widget, XtPointer, XtPointer);
void set_pressed(Widget, XtPointer, XtPointer);
void csline_pressed(Widget, XtPointer, XtPointer);
void sides_pressed(Widget, XtPointer, XtPointer);
void deads_pressed(Widget, XtPointer, XtPointer);
void exit_pressed(Widget, XtPointer, XtPointer);
void help_pressed(Widget, XtPointer, XtPointer);
void break_pressed(Widget, XtPointer, XtPointer);
void display_right(Widget, XtPointer, XtPointer);
void display_left(Widget, XtPointer, XtPointer);
void phase_break_callback(Widget, XtPointer, XtPointer);

typedef enum {
    initial_state,
    infunction_state,
    inphase_state,
    lastphase_state,
    intransbefore_state,
    intransafter_state,
    final_state
} state_enum;

typedef enum {
    newfunction,
    lastfunction,
    newphase,
    lastphase
} process_enum;


extern unsigned int rtls_to_display;
extern char display_deads;
extern char display_sides;
extern char sanity_enabled;
#endif
