/***********************************************************************
 * 
 * Copyright (c) 1996 Ann H. Bailey.
 * 
 * This code is distributed WITHOUT ANY WARRANTY. No claims are made 
 * as to whether it serves any particular purpose or even works at all.
 *
 * $Source: /home/zephyr/zephyr-cvs/zephyr/backend/vpo/tools/vet/vet_init.h,v $
 * $Revision: 1.1.1.1 $
 * 
 ***********************************************************************/

#ifndef __VET_INIT_H__
#define __VET_INIT_H__

#include <netdb.h>
#ifndef MAXHOSTNAMELEN		/* Solaris defines this */
#define MAXHOSTNAMELEN 64	/* SunOS 4.x does not.  */
#endif

/* From vpcc.h */
#define LISTLEN   4096     /* Length of a list of strings */

char *parse_arguments(int, char**);	/* Get command-line arguments    */

extern char remotehostname[MAXHOSTNAMELEN + 1];  /* host running VPO   */
extern char localhostname[MAXHOSTNAMELEN + 1];   /* host running VET   */
#endif
