#ifndef _OPTIONSDATABASE_H
#define _OPTIONSDATABASE_H

#include <Macros.h>
#include <types.h>
#include <BaseObject.h>

class OptionsDatabase : public BaseObject
{
	public:
		// prevent shallow copies and an empty constructer.  we
		// need argv/argc from main to work properly
		OptionsDatabase() NOT_IMPLEMENTED;
		OptionsDatabase(const OptionsDatabase&) NOT_IMPLEMENTED;
		

		OptionsDatabase(char** argv, int argc);
		~OptionsDatabase();



		// get the input files
		list<char*> *getInputFilenames();

		// get the output file
                char* getOutputFilename();


		// no other options, yet 

	protected:

	private:
		list<char*> inputFilenames;

		// the output file we write to.  
		// If this is 0 we use stdout 
		char* outputFile;
		
};

#endif /* _OPTIONSDATABASE_H */
