
#include <BaseObject.h>
#include <Rtl.h>


Rtl::Rtl(const Rtl& theRtl)
{
	type=theRtl.type;
	value=strdup(theRtl.value);
} 

Rtl::Rtl(char theType, char* theValue)
{
	type=theType;
	assert(theValue);
	value=strdup(theValue);
}

Rtl::~Rtl()
{
	GetRidOfArray(value);
}


char Rtl::getType()
{
	return type;
}

/* not yet implemented */
int Rtl::isLegal()
{
	assert(0);
}	

void Rtl::output(FILE* fout)
{
	fprintf(fout, "%c%s\n", type, value);
}

void Rtl::setValue(char* theValue)
{
	value=strdup(theValue);
}
