/************************************************************************/
/*                                                                      */
/* Copyright (c) 1990, 1991, 1992 -                                     */
/*     The Rector and Visitors of the University of Virginia            */
/*                                                                      */
/* This code may not be distributed further without permission          */
/*      from the University of Virginia.                                */
/* This code is distributed WITHOUT ANY WARRANTY.  No claims are        */
/*      made as to whether it serves any particular purpose or even     */
/*      works at all.                                                   */
/*                                                                      */
/************************************************************************/

/************************************************************************
 
 Revision Control information

 $Source: /home/zephyr/zephyr-cvs/zephyr/backend/vpo/tools/yyfast/yyfast2.h,v $
 $Date: 2000/08/22 21:10:35 $
 $Revision: 1.1.1.1 $
 $Name:  $

 Log of changes:

 $Log: yyfast2.h,v $
 Revision 1.1.1.1  2000/08/22 21:10:35  zephyr
 Created directory structure

 Revision 1.1  1998/04/08 18:41:28  jwd
 Initial revision

*************************************************************************/

#ifndef YYFAST2_H
#define YYFAST2_H

int main(int, char **);
void read_yacc_parser(void);
void build_state_info(void);
void build_reduce(short int, int);
int complex_check(int);
int reduce_complex_check(short int);
void write_yacc_parser(void);
void reduce_production(char *,short  int, int);
void process_semantic_action(string_pointer, short int, short int, int);
short get_array(array, int);
int read_semantic_actions(void);
int read_array(array *);
int read_define(char *);
int read_input_line(char *);
void write_output_line(char *);
void initialize_tokens(void);
void token_value(char *);
char *token_identifier(int);
int complex_token(int);
int uses_yylval(int);


#endif
