/************************************************************************
 
 Revision Control information

 $Source: /home/zephyr/zephyr-cvs/zephyr/backend/vpo/arm/ease/genreport.h,v $
 $Date: 2003/11/09 14:19:52 $
 $Revision: 1.1 $
 $Name:  $

 Log of changes:

 $Log: genreport.h,v $
 Revision 1.1  2003/11/09 14:19:52  jwd
 Initial version from SPARC--incomplete for arm

 Revision 1.3  2002/11/25 14:39:29  jwd
 Made changes so EASE functionality can be built.  It had gotten out of sync
 with the rest of the compiler.

 Revision 1.2  1998/04/07 20:08:37  jwd
 First ANSI C version.

 Revision 1.1  1998/04/07 19:25:20  jwd
 Initial revision

*************************************************************************/

int main(int, char **);
void function_profile(void);
void function_loopinfo(void);
void instruction_distributions(void);
void instruction_class_distributions(void);
void addressing_mode_distributions(void);
void memory_reference_type_distributions(void);
void memory_reference_address_distributions(void);
void registers_saved_and_restored(unsigned int (*)[], unsigned int);
void register_usage_totals(unsigned int (*)[]);
void register_usage_per_call(unsigned int (*)[], unsigned int);
void condition_code_usage(unsigned int (*)[]);
void conditional_branches_taken(void);
void control_flow_distributions(void);
void data_distributions_per_instruction(unsigned int (*)[]);
void data_distributions_per_mode(unsigned int (*)[]);
void field_mode_type_distributions(unsigned int (*)[]);
void header(char *);
void subheader(char *);
int instindex(int);
int addrindex(int);
int dataindex(int);
int ccindex(int);
unsigned int (*salloc(int))[];
struct finfo *falloc(void);
struct linfo *lalloc(void);
void error(char *);
void error_str(char *, char *);
void error_int(char *, int);
void error_chr(char *, char);
unsigned int numexeccnt[50000];
int maxrpart;
int maxhmem;
int maxinst;
int maxclass;
int maxdata;
int maxaddr;
int maxcc;
int maxreg;
char *myname;
int width;
struct finfo *funcinfo;
