#include <stdio.h>
#define MAXFUNCS 500
#define MAXNAME 80
#define MAXLINE 200

main(int argc, char *argv[])
{
   int i, num, mainfilenum;
   FILE *f, *fout;
   char funcs[MAXFUNCS][MAXNAME];
   char filename[MAXNAME];
   char filenameout[MAXNAME];
   char line[MAXLINE];

   num = 0;
   mainfilenum = -1;
   for (i = 1; i < argc; i++) {
      sprintf(filename, "%s.cex", argv[i]);
      f = fopen(filename, "r");
      while (fgets(line, MAXLINE, f)) {
         if (line[0] == 'f') {
            strcpy(funcs[num], &line[1]);
            funcs[num][strlen(funcs[num])-1] = '\0';
            if (strcmp(funcs[num], "main") == 0)
               mainfilenum = i;
            num++;
         }
      }
      fclose(f);
   }
   if (mainfilenum == -1) {
      fprintf(stderr, "could not find main function\n");
      exit(1);
   }
   sprintf(filename, "%s.cex", argv[mainfilenum]);
   f = fopen(filename, "r");
   sprintf(filenameout, "%s.cex.tmp", argv[mainfilenum]);
   fout = fopen(filenameout, "w");
   while (fgets(line, MAXLINE, f)) {
      fprintf(fout, "%s", line);
      if (line[0] == 'f' && strcmp(&line[1], "main\n") == 0)
         for (i = 0; i < num; i++)
            fprintf(fout, "g%s\n", funcs[i]);
   }
   fclose(fout);
   fclose(f);
   sprintf(line, "mv %s %s", filenameout, filename);
   system(line);
   exit(0);
}
