/*************************************************************************
 Revision Control information

 $Source: /home/zephyr/zephyr-cvs/zephyr/backend/vpo/arm/linstinfo.h,v $
 $Date: 2003/11/09 14:38:02 $
 $Revision: 1.2 $
 $Name:  $

 Log of changes:

 $Log: linstinfo.h,v $
 Revision 1.2  2003/11/09 14:38:02  jwd
 Fixed RCS information at beginning


*************************************************************************/

#ifndef LINSTINFO_H
#define LINSTINFO_H
extern char *main_fn_name;
extern char *startblklabel;
extern char *endblklabel;
extern int *info_ptr;
extern int func_instinfo[];
extern struct bblock *top;
extern struct list *curptr;
extern int numblks[];
extern int blksinec[];
extern int numinsts[];
extern int totalblks;
extern int equiv_classes;
extern int saveoff;
extern int swef, swed, swei;
extern char *bpos, *epos;
extern struct callfunc *ext_funcs;
extern int ext_num;

#ifdef INTERACT
extern int swef, swed, swei;
extern char *fn;
extern int measure_phase;
#endif

void 
register_usage_information();

void 
stinstinfo(int, int, int, struct addr_entry *, struct addr_entry *,
           struct addr_entry *);

int 
increment_class_counter(struct bblock *, struct list *, int, int);

int 
increment_class_counter_by_expression(struct bblock *, struct list *, char *,
                                      int);

void 
increment_if_branch_not_taken(struct bblock *, int);

void 
initial_call(struct bblock *, struct list *, char *);

void 
final_call(struct bblock *, struct list *, char *);

#ifdef INTERACT
void freq_info(FILE *fp);
#else
void freq_info();
#endif

void 
trace_call(struct bblock *, struct list *, int, int);

void 
unify_call(struct bblock *, struct list *, int);

struct list *
inst_labels(struct list *);

int 
trace_memory_references(struct list *, int);

#ifdef INTERACT
void inst_info(FILE *fp);
void unified_info(FILE *fp);
void end_info(FILE *fp);
void link_module(FILE *fp);
void call_graph(FILE *fp);
#else
void inst_info();
void unified_info();
void end_info();
void link_module();
void call_graph();
#endif

int 
callsexit(struct list *);

int 
is_anyrjmp(char *);

int 
tracememaddr(struct list *, int, char *, int, int);

int 
traceothermemaddr(struct list *, int, int);

void 
savescratch(struct bblock *, struct list *);

void 
restorescratch(struct bblock *, struct list *);

void 
live_scratch(struct bblock *, struct list *);

int 
save_cc(struct bblock *, struct list *);

int 
memsize(char);

#endif
