
/************************************************************************
 
 Revision Control information

 $Source: /home/zephyr/zephyr-cvs/zephyr/backend/vpo/arm/regs2.h,v $
 $Date: 2003/01/24 20:20:48 $
 $Revision: 1.3 $
 $Name:  $

 Log of changes:

 $Log: regs2.h,v $
 Revision 1.3  2003/01/24 20:20:48  clc5q
 Move maybe_same() from each target's rtl.c module up into combine.c.
    Make calls into rtl.c for machine-dependent information or processing.

 Revision 1.2  2002/07/16 19:42:50  clc5q
 Clean up #include chains. Use #include instead of extern to get access
 to global variables from other modules.

 Revision 1.1  2001/02/01 22:55:19  jdh8d

 Initial arm version. Much stuff is still wrong.  Mostly this is a copy
 of the mips code but setup as an "arm" target.  Next I'll start converting
 functions so that they work with ARM instead of mips.  inst.c here I come.

 Revision 1.1  2000/09/15 23:03:13  jwd
 Initial revision

*************************************************************************/

#ifndef REGS2_H
#define REGS2_H

#define REG_FP  11
#define REG_SP  13

extern int ptr_type;    /* Type of register needed for pointers.     */
extern int spilloff;    /* Starting offset for spill locations       */
extern int regmap[];    /* Permits registers to be mapped on output  */
extern char cc_reg[];
extern int fp_num;

void fixentry(struct list *, struct blist *);
int regarg(struct locuse *);
void initmap(void);
int map(char *);
int transfer(char *, rlist *, int, int, int, int, int, int);
void maketemp(char *, int, int);
int leaf(void);
#endif
