/************************************************************************
 
 Revision Control information

 $Source: /home/zephyr/zephyr-cvs/zephyr/backend/vpo/arm/sched.h,v $
 $Date: 2001/04/26 19:00:16 $
 $Revision: 1.1 $
 $Name:  $

 Log of changes:

 $Log: sched.h,v $
 Revision 1.1  2001/04/26 19:00:16  jdh8d

 initial version of machine dependend scheduling for arm.

 Revision 1.3  1998/04/29 19:38:35  jwd
 Added void to setup_noop() prototype so it matches the
 definition in sched.c
 Revision 1.2  1998/04/07 20:03:51  jwd
 First ANSI C version.
 Revision 1.1  1998/04/07 19:20:16  jwd
 Initial revision

*************************************************************************/

#ifndef SCHED_H
#define SCHED_H

int md_sets_uses(struct list *);
int md_uses(struct list *, int *, int *, rlist, rlist);
int sched_adv(int, struct list *, struct list *);
int modify(struct bblock *, struct list *, struct list *);
int noconflict(struct list *, struct list *);
void create_noop(char *);
void setup_noop(struct list *);

#ifdef INTERACT
int ins_latency(struct list *ptr, int cycle, double *sup_cycle,
		int reg_avail[], int unit_avail[]);
int issue_ins(struct list *ptr, double *sup_cycle, int cycle);
struct list *exec_ins(int cycle);
void fu_unit_init();

#endif /*INTERACT*/

#endif
