/************************************************************************
 *                                                                      *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991, 1992 -                   *
 *     The Rector and Visitors of the University of Virginia            *
 *                                                                      *
 * This code may not be distributed further without permission          *
 *      from the University of Virginia.                                *
 * This code is distributed WITHOUT ANY WARRANTY.  No claims are        *
 *      made as to whether it serves any particular purpose or even     *
 *      works at all.                                                   *
 *                                                                      *
 ************************************************************************/

/* $Id: arena.h,v 1.2 2002/07/11 15:19:20 clc5q Exp $ */
#ifndef ARENA_INCLUDED
#define ARENA_INCLUDED

typedef struct Arena_T *Arena_T;
extern Arena_T    Arena_new    (void);
extern void Arena_dispose(Arena_T *ap);
extern void *Arena_alloc (Arena_T arena, long nbytes);
extern void *Arena_calloc(Arena_T arena, long count, long nbytes);
extern void  Arena_free  (Arena_T arena);

#endif
