
#ifdef INTERACT
/*structures used by encode_rtl*/
#ifndef REGSTRING
#define REGSTRING 4
#endif
#define MAXGLOBALS 200;

struct glouse{
  char code[REGSTRING];
  char *global_name_ptr;
  struct glouse *next;
} ;

/*functions in encode_rtl.c*/
void encode_rtl(char *src, char *dst);
void ignore_space(char *src, char *dst);

int is_name(char *src);
int is_register(char *src);
int is_local(char *src);
int is_global(char *src);
int is_global(char *src);
int is_HI_LO(char *src);
int is_label(char *src);

int get_name(char *src, char *name);
int get_reg(char *srcptr, int *reg_type, int *reg_num);
int get_type (char c);
int get_local_name(char *src, char *local_name);
int get_HILO_name(char *src, char *local_name);

char *find_local(char *local_name);
char *find_global(char *global_name);

void add_glouse_node(struct glouse *gloptr);

#endif
