/************************************************************************
 *                                                                      *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991, 1992 -                   *
 *     The Rector and Visitors of the University of Virginia            *
 *                                                                      *
 * This code may not be distributed further without permission          *
 *      from the University of Virginia.                                *
 * This code is distributed WITHOUT ANY WARRANTY.  No claims are        *
 *      made as to whether it serves any particular purpose or even     *
 *      works at all.                                                   *
 *                                                                      *
 ************************************************************************/

/************************************************************************
 
 Revision Control information

 $Source: /home/zephyr/zephyr-cvs/zephyr/backend/vpo/lib/eod.h,v $
 $Date: 2002/07/11 15:20:48 $
 $Revision: 1.3 $
 $Name:  $

 Log of changes:

 $Log: eod.h,v $
 Revision 1.3  2002/07/11 15:20:48  clc5q
 Clean up #include chains. Use #include instead of extern to get access
 to global variables from other modules.

 Revision 1.2  1998/04/28 20:21:15  jwd
 Deleted some commented out code.

 Revision 1.1  1998/04/03 16:53:42  jwd
 Initial revision

*************************************************************************/

#ifndef EOD_H
#define EOD_H
 
void 
evaluation_order_determination(int);

int 
rusage(struct list *);

struct list *
reorder(struct list *);

struct list *
movedown(struct list *, struct list *);

char *
is_linked_to_reserve(struct list *);

#endif

