/************************************************************************
 *                                                                      *
 * Copyright (c) 1987, 1988, 1989, 1990, 1991, 1992 -                   *
 *     The Rector and Visitors of the University of Virginia            *
 *                                                                      *
 * This code may not be distributed further without permission          *
 *      from the University of Virginia.                                *
 * This code is distributed WITHOUT ANY WARRANTY.  No claims are        *
 *      made as to whether it serves any particular purpose or even     *
 *      works at all.                                                   *
 *                                                                      *
 ************************************************************************/

/************************************************************************
 
 Revision Control information

 $Source: /home/zephyr/zephyr-cvs/zephyr/backend/vpo/lib/links.h,v $
 $Date: 2002/07/11 15:20:48 $
 $Revision: 1.3 $
 $Name:  $

 Log of changes:

 $Log: links.h,v $
 Revision 1.3  2002/07/11 15:20:48  clc5q
 Clean up #include chains. Use #include instead of extern to get access
 to global variables from other modules.

 Revision 1.2  2001/08/31 15:34:05  jdh8d
 *** empty log message ***

 Revision 1.1  1998/04/03 16:53:47  jwd
 Initial revision

*************************************************************************/

#ifndef LINKS_H
#define LINKS_H

int set_local_links(int);
int set_global_links(int);
int search_for_use(char *, unsigned int, struct bblock *, struct list *);
int remv_forward_links(int);
int remv_forward_links_in_block(struct bblock* cblk);
void merge_links(struct list *, struct list *);
int add_link(struct list *, struct list *);
void remv_links(struct list *);
void remv_links_to(struct list *);
void remv_link(struct list **, struct list *);
void combmark(struct list *);
void reset_local_links();

#endif
