/************************************************************************/
/*                                                                      */
/* Copyright (c) 1987, 1988, 1989, 1990, 1991, 1992 -                   */
/*     The Rector and Visitors of the University of Virginia            */
/*                                                                      */
/* This code may not be distributed further without permission          */
/*      from the University of Virginia.                                */
/* This code is distributed WITHOUT ANY WARRANTY.  No claims are        */
/*      made as to whether it serves any particular purpose or even     */
/*      works at all.                                                   */
/*                                                                      */
/************************************************************************/

/************************************************************************
 
 Revision Control information

 $Source: /home/zephyr/zephyr-cvs/zephyr/backend/vpo/lib/sched.h,v $
 $Date: 2003/02/06 04:48:21 $
 $Revision: 1.3 $
 $Name:  $

 Log of changes:

 $Log: sched.h,v $
 Revision 1.3  2003/02/06 04:48:21  jg9h
 Merged VISTA into mainline vpo under the INTERACT preprocessor flag

 Revision 1.1.1.1  2002/05/31 15:17:19  kulkarni
 vista start

 Revision 1.1.1.1  2001/09/19 20:11:50  mabailey
 Source gleaned as initial distribution for interactive compiler modifications

 Revision 1.1  2000/05/25 14:11:53  whalley
 Initial revision

 Revision 1.1  1998/04/03 18:16:01  jwd
 Initial revision

*************************************************************************/

#ifndef SCHED_H
#define SCHED_H

int md_sets_uses(struct list *);
int md_uses(struct list *, int *, int *, rlist, rlist);
int sched_adv(int, struct list *, struct list *);
int modify(struct bblock *, struct list *, struct list *);
int noconflict(struct list *, struct list *);
void create_noop(char *);
int setup_noop(struct list *);

#endif
