/***********************************************************************
 * 
 * Copyright (c) 1998 Ann H. Bailey.
 * 
 * This code is distributed WITHOUT ANY WARRANTY. No claims are made 
 * as to whether it serves any particular purpose or even works at all.
 *
 * $Source: /home/zephyr/zephyr-cvs/zephyr/backend/vpo/tools/vet/hash_functions.h,v $
 * $Revision: 1.1.1.1 $
 * 
 ***********************************************************************/
#ifndef __HASH_H__
#define __HASH_H__

#define HASH_TABLE_SIZE 1024

typedef void *hash_info;

typedef struct hash_entry hash_entry;

struct hash_entry {
    int key;
    hash_info info;
    hash_entry *next;
};

typedef hash_entry **hash_table;

hash_table new_hash_table();
hash_info search_hash_table(hash_table, int);
void insert_hash_table(hash_table, int, hash_info);
hash_info delete_hash_info(hash_table, int);
void delete_hash_table(hash_table, void (*free_info)(hash_info));
#endif
