/***********************************************************************
 * 
 * Copyright (c) 1998 Ann H. Bailey.
 * 
 * This code is distributed WITHOUT ANY WARRANTY. No claims are made 
 * as to whether it serves any particular purpose or even works at all.
 *
 * $Source: /home/zephyr/zephyr-cvs/zephyr/backend/vpo/tools/vet/vet.h,v $
 * $Revision: 1.1.1.1 $
 * 
 ***********************************************************************/
#ifndef __VET_H__
#define __VET_H__


/* Allows different levels of debugging */
/* This DEBUG_HI writes to log file all input from VPO */
#define DEBUG_HI 3
#define DEBUG_MED 2
#define DEBUG_LO 1

#ifdef __VET_C__

#if DEBUG >= DEBUG_LO
FILE *errlog;
#endif

#else

#if DEBUG >= DEBUG_LO
extern FILE *errlog;
#endif

#endif

#ifdef XWINDOWS
#include <Xm/Xm.h>

void startvpo(Widget, XtPointer, XtPointer);
#endif

#endif
