#ifndef _MACROS_H
#define _MACROS_H


// we should read this from regs.rt, but i havent gotten that far yet 
#define LOCSIZE 4


//
// includes for fprintf and exit
//
#include <stdio.h>
#include <stdlib.h>
#include <string>
#include "my_stl.h"

//
// Some macros to avoid dangling pointers
//
#define GetRidOfObject(arg) {if (arg!=0) {/*delete    arg;*/ arg=0;} }
#define GetRidOfArray(arg)  {if (arg!=0) {/*delete [] arg;*/ arg=0;} }


//
// a macro used to tell the user about a function that may have been
// called automatically (copy constructor)
//

#define NOT_IMPLEMENTED 						\
{ 									\
	fprintf(stderr, "function is not implemented at %d of %s\n",	\
		__LINE__, __FILE__); 					\
	exit(-1000);							\
}


#define fatal(args)							   \
{									   \
   fprintf(stderr, "Fatal error occured at %d of %s: ", __LINE__,__FILE__);\
   fprintf(stderr, args);						   \
   exit(-1000);								   \
}


#define TRUE (1==1)
#define FALSE (!TRUE)

typedef long long LabelNumType;

#endif
