#include <OptionsDatabase.h>
#include <string.h>
#include <assert.h>

using namespace std;


OptionsDatabase::OptionsDatabase(char** argv, word32 argc)
{
	outputFile=0;

	/* start at 1 to avoid thinking the exe name is a input file */
	for(word32 x=1;x<argc;x++)
	{
		if(*argv[x]!='-')
		{
			inputFilenames.push_back(argv[x]);
		}
		else if(strcasecmp(argv[x], "-o")==0)
		{
			if(++x>=argc)
				fatal("-o specified without filename");
			outputFile=argv[x];
		}	
	}
}

OptionsDatabase::~OptionsDatabase()
{
	/* nothing to do yet */
}



list<char*> *OptionsDatabase::getInputFilenames()
{
	return &inputFilenames;
}
char* OptionsDatabase::getOutputFilename()
{
	return outputFile;
}


