#ifndef _RTLFILE_H
#define _RTLFILE_H 

#include <Macros.h>
#include <BaseRtlFile.h>
#include <string>
#include "my_stl.h"

class RtlFile : public BaseRtlFile
{

	public:
                RtlFile() NOT_IMPLEMENTED;
                RtlFile(const RtlFile&) NOT_IMPLEMENTED;
                RtlFile(OptionsDatabase* opt) : BaseRtlFile(opt) {}       

		void readFile(char* filename);

		LabelNumType renumberGlobalsAndLocals(LabelNumType startNum,
                                            int fileNum);
		LabelNumType renumberLabels(LabelNumType startNum);
		void removeDuplicates(map<string,string,less<string> > *alreadyDefined);

		void output(char* filename=NULL);



	private:

	protected:

			
};

#endif
